#pragma rtGlobals=1		// Use modern global access method.
#pragma ModuleName = tracesAnalyzer3

// particle analysis procedures are in this page.
// Marijonas Tutkus @ BioNano, 2014-04-28

Function CP_TA_MT( ctrlName ) :BUTTONCONTROL
	string ctrlName
	// closing unnecessay windows
	dowindow/k ndChannel; dowindow/k stChannel;	dowindow/k thresholdChannel
	//
	make/o/n = ( 1, 1 )  stChImage, ndChImage, thresholdImage
	newimage/k=2/n = stChannel /s=0 stChImage
	newimage/K=2/n = ndChannel /s=0 ndChImage
	newimage/K=2/n = thresholdChannel /s=0 thresholdImage
	// arrange windows
	updateMCH_TAMT(  );		updatePCH_TAMT(  );		updateTrCH_TAMT(  )
	// killing unecessary variables, strings and waves
	killWaves/z/a; killStrings/z/a; killVariables/z/a
	// ******  loading structure varaibles
	Struct TA_preferences TAPrefs
	load_preferences_TA_MT( TAPrefs )
	// *******   defining local variables 
	variable colocDistance = TAPrefs.lenghtLinkParticles			// co - localization distance
	variable coefRadius = TAPrefs.radiusVariables					// crop size for particle fitting to 2D GAussian
	// background subtractio nfrom images
	variable flatteningToggle1 = TAPrefs.bckgSubtrVariables[ 0 ] 		// bckg removing from 1st ch image
	variable flatteningToggle2 = TAPrefs.bckgSubtrVariables[ 1 ] 		// bckg removing from 2nd ch image
	variable radiusBall1 = TAPrefs.bckgSubtrVariables[ 2 ]			// ball size for bckg removing from 1st ch image
	variable radiusBall2 = TAPrefs.bckgSubtrVariables[ 3 ]			// ball size for bckg reoving from 2nd ch image
	// particle fitting to  2D gaussian
	variable gaussFitMembrLoc = TAPrefs.particleFitting[ 0 ]
	variable gaussFitProtLoc  = TAPrefs.particleFitting[ 1 ] 			// toggles for paricle fitting by 2d Gaussian
	// image filtering
	variable numberOfImagesAccum = TAPrefs.imageFiltering[ 8 ]
	variable filtering2 = TAPrefs.imageFiltering[ 2 ]				// low pass filtering 
	variable filtering1 = TAPrefs.imageFiltering[ 0 ] 				// gaussian smooting
	variable filteringCuttOff = TAPrefs.imageFiltering[ 6 ]
	variable gaussianSize = TAPrefs.imageFiltering[ 4 ]
	variable numberOfImagesAccum2 = TAPrefs.imageFiltering[ 9 ]
	variable filtering22 = TAPrefs.imageFiltering[ 3 ]			// low pass filtering 
	variable filtering12 = TAPrefs.imageFiltering[ 1 ] 			// gaussian smooting
	variable filteringCuttOff2 = TAPrefs.imageFiltering[ 7 ]
	variable gaussianSize2 = TAPrefs.imageFiltering[ 5 ]
	variable radius = 0
	variable distSpotsThresh = 3							// minimal distance between center positions of detected spots
	//
	variable aa , bb , numColocItems, index	, numImPropBleached = 0							// counters
	//
	pathinfo path1
	if( V_flag == 0 )
		abort "Define paths!"
	endif
	pathinfo path2
	if( V_flag == 0 )
		abort "Define paths!"
	endif
	string nameList1UnSort =  indexedFIle ( path1 , -1 , "????" )  // list of 1st images names
	nameList1UnSort= RemoveFromList(".DS_Store", nameList1UnSort, ";" )	
	string nameList1 = SortList( nameList1UnSort, ";", 16 )
	string nameList2UnSort =  indexedFIle ( path2 , -1 , "????" )  // list of 2nd images names
	nameList2UnSort= RemoveFromList(".DS_Store", nameList2UnSort, ";" )	
	string nameList2 = SortList( nameList2UnSort, ";", 16 )
	// defining local waves
	make/o/d/n = 3 particleNumberWave = 0    // particleNumberWave[ 0 ]  - 1st channel ; particleNumberWave[ 1 ]  - 2nd channel ; particleNumberWave[ 2 ]  - co - localized
	// brief description of the function writen to the history window.
	print "**********************************          Spot detection program         ********************************************" 
	print "This function analyze particles in 1st and 2nd channel images, then co-localize overlapping ones"
	// making waves for results of particle indentification and co-localization saving
	make/o /d /n = ( 0 , 10 ) nonColoc1stChWave , nonColoc2ndChWave	// wave for non co-localized particle properties saving
	//	give names for columns
	make/o /t /n = ( dimSIze( nonColoc1stChWave , 1 ) ) labelsWave = {"index","xC","yC","amp","ampErr","xW","xWErr","avgRInt","z0", "type" }
	labeling_TA_MT( nonColoc1stChWave , labelsWave , 1 )
	labeling_TA_MT( nonColoc2ndChWave , labelsWave , 1 )
	//****************    detect particles in the 1st channel   *************************************
	print "*********************     Particle analysis in 1st channel    ***********************"
	// filtering of images by accumulation of desired number of images, low-pass filtering and convolution with gaussian
	filterImage_TA_MT( nameList1, 0 , radiusBall1, flatteningToggle1 , numberOfImagesAccum, filtering1, filtering2, filteringCuttOff,  gaussianSize )
	wave stChImageAcc
	ImageSave/O/F/T="TIFF"/P=path4 stChImage as "stChImageProcessed.tif"
	// identifying particles by Gaussian fitting
	print "*****************************************"
	make/o /d /n = (0,0) coordsBefreGaussian
	SFA_CP_TA_MT( stChImageAcc , nonColoc1stChWave , 1, coefRadius , coordsBefreGaussian , stChImage, gaussFitMembrLoc )
	nonColoc1stChWave[ ][ %type ] = 1	// indicates that particle is from 1st ch
	//**************    	 detect particles in the 2nd channel   	****************************
	// filtering of images by accumulation of desired number of images, low-pass filtering and convolution with gaussian
	print "****************      Particle analysis in 2nd channel     **********************"
	filterImage_TA_MT( nameList2,1, radiusBall2 , flatteningToggle2 , numberOfImagesAccum2, filtering12, filtering22, filteringCuttOff2,  gaussianSize2 )
	wave ndChImageAcc
	ImageSave/O/F/T="TIFF"/P=path4 ndChImage as "ndChImageProcessed.tif"
	// identifying particles by Gaussian fitting
	print "*****************************************"
	make/o /d /n = (0,0) coordsBefreGaussian
	SFA_CP_TA_MT( ndChImageAcc , nonColoc2ndChWave , 2, coefRadius , coordsBefreGaussian , ndChImage, gaussFitProtLoc )
	nonColoc2ndChWave[ ][ %type ] = 2	// indicates that particle is from 2nd ch	
	//*************  co-localization part:	co-localize and print # of co-localized items in the history window.
	numColocItems = coLocalizeAllPArticles( nonColoc1stChWave, nonColoc2ndChWave, colocDistance );	wave allParticlesContainer
	print "Number of colocalized items: "+num2str( numColocItems )
	//  clear windows of all channels	
	SetDrawLayer /W = stChannel /K userFront;			SetDrawLayer /W = stChannel /K ProgFront
	SetDrawLayer /W = ndChannel /K ProgFront;			SetDrawLayer /W = ndChannel /K userFront
	SetDrawLayer /W = thresholdChannel /K ProgFront;	SetDrawLayer /W = thresholdChannel /K userFront
	// Draw circles around colocolized particles  in both channels
	for( aa = 0 ; aa < dimSIze( allParticlesContainer, 0) ; aa +=1 )
		if( allParticlesContainer[ aa ][ %type1 ] == 1 ) // 1st channel
			//
			bb = allParticlesContainer[ aa ][ %xC1 ] 
			index = allParticlesContainer[ aa ][ %yC1 ] 
			radius = max( 1, allParticlesContainer[ aa ][ %xW1 ] )
			//
			DSC_TA_MT( bb , index , 40000, 0, 0 , "stChannel",0, dimSize( stChImage, 1 ) , dimSize( stChImage, 0 ) , 1 , num2str(aa) , radius )	// drawing particle on 1st channel window
		 	DSC_TA_MT( bb , index , 40000, 0, 0 , "thresholdChannel",0, dimSize( thresholdIMage, 1 ) , dimSize( thresholdIMage, 0 )  , 1 , num2str(aa) , radius )   // drawing particle on threshold channel window
		 	particleNumberWave[ 0 ] += 1
		 	//
		 elseif( allParticlesContainer[ aa ][ %type1 ] == 2 ) // 2nd channel
		 	//
		 	bb = allParticlesContainer[ aa ][ %xC2 ] 
			index = allParticlesContainer[ aa ][ %yC2 ]
			radius = max( 1, allParticlesContainer[ aa ][ %xW2 ] )
			//
		 	DSC_TA_MT( bb , index , 0, 40000, 0 , "ndChannel",0 , dimSize( ndChImage, 1 ) , dimSize( ndChImage, 0 )  , 1 , num2str(aa), radius )
		 	DSC_TA_MT( bb , index , 0, 40000, 0 , "thresholdChannel",0 , dimSize( thresholdIMage, 1 ) , dimSize( thresholdIMage, 0 )  , 1 , num2str(aa), radius )
		 	particleNumberWave[ 1 ] += 1
		 	//
		 elseif( allParticlesContainer[ aa ][ %type1 ] == 3 )	// co-localized
		 	//
		 	bb = allParticlesContainer[ aa ][ %xC1 ] 
			index = allParticlesContainer[ aa ][ %yC1 ] 
			radius = max( 1, allParticlesContainer[ aa ][ %xW1 ] )
			//
			DSC_TA_MT( bb , index , 0, 0, 40000 , "stChannel",0 , dimSize( stChImage, 1 ) , dimSize( stChImage, 0 )  , 1 , num2str(aa), radius )
			//
			bb = allParticlesContainer[ aa ][ %xC2 ] 
			index = allParticlesContainer[ aa ][ %yC2 ] 
			radius = max( 1, allParticlesContainer[ aa ][ %xW2 ] )
			//
			DSC_TA_MT( bb , index , 0, 0, 40000 , "ndChannel",0 , dimSize( ndChImage, 1 ) , dimSize( ndChImage, 0 )  , 1 , num2str(aa), radius)
		 	DSC_TA_MT( bb , index , 0, 0, 40000 , "thresholdChannel",0 , dimSize( thresholdIMage, 1 ) , dimSize( thresholdIMage, 0 )  , 1 , num2str(aa), radius )
		 	particleNumberWave[ 2 ] += 1
		 endif
	endFor
	// particle information into the waves
	make/o/n = 3 particleInfo
	particleInfo[ 0 ] = dimSize( nonColoc1stChWave, 0 )							// # of st ch
	particleInfo[ 1 ] = dimSize( nonColoc2ndChWave, 0 )							// # of nd ch
	particleInfo[ 2 ] = numColocItems											// # of co-localized
	// labelling # of particles wave
	make/o /t /n = ( dimSIze( particleInfo , 1 ) ) labelsWave = {"stCh","ndCh","Coloc"}
	labeling_TA_MT( particleInfo , labelsWave , 1 )
	// add the text box onto the threshold channel window, which indicates # of co-localized, memberane only and protein only items.
	Legend/w=thresholdChannel/N=text0/K
	Legend/w=thresholdChannel/C/N=text0/J/A=LT/X=0.00/Y=0.00 "\Z10\F'arial'\\K(40000,0,0)\\W508 st ch:  "+num2str( particleNumberWave[ 0 ] )+"\r\\K(0,40000,0)\\W508 nd ch:  "+num2str( particleNumberWave[ 1 ] )+"\r\\K(0,0,40000)\\W508 colocalized:  "+num2str( particleNumberWave[ 2 ] )+"\rTotal number:  "+num2str( sum( particleNumberWave ) )
	doUpdate
	// updating sate of a program
	State_GUI_TA_MT("# of unique spos in st ch: "+num2str( particleNumberWave[ 0 ] )+"\r# of unique spots in nd ch:  "+num2str( particleNumberWave[ 1 ] )+ "\r# of co-localized spots: "+num2str( particleNumberWave[ 2 ] ))
	print "Spot detection and co-localization finished!"
	// ********    saving results
	// images with circles around particles
	SavePICT/O /P=path4 /E=-5 /B=72/tran=2 /W=(0,0,dimSize(ndChImage,0),dimSize(ndChImage,1)) /Win = ndChannel as "ndChImageMarked.png"
	SavePICT/O /P=path4 /E=-5 /B=72/tran=2 /W=(0,0,dimSize(ndChImage,0),dimSize(ndChImage,1)) /Win = stChannel as "stChImageMarked.png"
	// results tables
	Save/C/O/P = path4 allParticlesContainer as "01_allIdentifiedPartInfo.ibw"
	Save/C/O/P = path4 particleInfo as "00_particleInfo.ibw"
	// saving structure
	save_preferences_TA_MT( TAPrefs )
	// writing notes
	Notes_spotDetect_TA_MT( )
	// releasing memory occupied by local variables, strings and waves
	killVariables/z/a; killStrings/z/a; 	killWaves/z/a
	//
end// end of colocalization procedure
// ******   Movie analysis - extracting bleaching traces of single particle   ***************
Function PM_TA_MT(ctrlName) : buttonControl
	string ctrlName
	// close unecessary windows
	dowindow/k ndChannel; dowindow/k stChannel
	dowindow/k thresholdChannel; 	doWindow/k tempWind
	// 	killing Unecessary waves, strings and variables
	killWaves/z/a; killStrings/z/a; killVariables/z/a
	killProcc(  )  // kill previously used multi-threads.
	//	loading structure varaibles
	Struct TA_preferences TAPrefs
	load_preferences_TA_MT( TAPrefs )
	//	defining local variables
	variable  ii , jj , zz, kk									// counters
	variable paricleToggle = TAPrefs.paricleToggle 		// toggle for choosing type of partiocles for the analysis
	variable cropSize = TAPrefs.radiusVariables			// size of crop for fitting
	variable intGToggle = TAPrefs.traceInt					// 1 - amplitude trace, 2 - gaussian integrated intensity
	variable imageTypeTog = TAPrefs.imageFileType			// 1 - TIFF, 2 - signed 32-bit
	variable numImages = TAPrefs.numImagesTA				// number of image to be loaded for signals extraction.
	variable varGWidth = TAPrefs.variableGWidth			// vary Gauss width during trace extraction. 1 - on, 2 - off
	variable varGcoord = TAPrefs.variableGcoord			// vary Gauss center pos during trace extraction. 1 - on, 2 - off
	variable excitationType = TAPrefs.excType				// 1 - ALEX, 2 -single laser
	variable stLaser = TAPrefs.alex_stLaser
	variable startingLaser										// -1 : starts with the second laser excitation; 1- the first.
	variable currentLaser
	variable nthreads, threadGroupID, threadGroupStatus
	//	coordinates of protein image display
	variable leftImage2 = TAPrefs.imageCoords[ 4 ]
	variable topImage2 = TAPrefs.imageCoords[ 5 ]
	variable rightImage2 = TAPrefs.imageCoords[ 6 ]
	variable bottomImage2 = TAPrefs.imageCoords[ 7 ]
	// 	check if the path4 exsists if not abort the program
	pathInfo path4
	if( V_flag == 0 )
		abort "Path to data does not exsist"
	endif
	//	load names of files existing in path3 with .tif type into string and sort it in alphanumerical order
	string nameListUnsort1 =  indexedFIle ( path1 , -1 ,"????" )
	nameListUnsort1= RemoveFromList(".DS_Store", nameListUnsort1, ";" )	
	string nameList1 = SortList( nameListUnsort1, ";", 16 )
	string nameListUnsort2 =  indexedFIle ( path2 , -1 , "????" )
	nameListUnsort2= RemoveFromList(".DS_Store", nameListUnsort2, ";" )	
	string nameList2 = SortList( nameListUnsort2, ";", 16 )
	// 	load particles characteristics from results folder
	LoadWave/H /O /P = path4 "01_allIdentifiedPartInfo.ibw"; 	duplicate/o $stringFromList(0, S_wavenames), particleInfo
	// make a table contianing information abot particles, for which SM trajectories will be extracted
	duplicate/o /r = [ 0 , 0 ][ * , * ] particleInfo, partContTrExtract;		partContTrExtract = 0
	// 	briefy description of program in the history window
	print "**************************								******************************"
	print "Software extracts SM trajectories - intensity versus time traces for the selected type of spots"
	print "Multi-threaded 2D Gaussian fitting uses this size of cropped image: "+num2str(cropSize*2)
	if( intGToggle == 1 )
		print "SM trace intesity is: amplitude"
	else
		print "SM trace intesity is: Gaussian integral = amp * width ^ 2"
	endif
	make/o /t / n = 6 namesTemp = {"non-coloc stCh","non-coloc ndCh","Colocalized","coloc stCh", "coloc ndCh","all"}; 	print "Extracts trajectories for: "+namesTemp[ paricleToggle - 1 ]+"  spots"
	//
	if( TAPrefs.noChToggle == 1 )
		print "Extract traces for 1st channel."
	elseif( TAPrefs.noChToggle == 2 )
		print "Extract traces for 2nd channel."
	elseif( TAPrefs.noChToggle == 3 )
		print "Extract traces for two channels (FRET)."
	endif
	//
	if( varGWidth == 1 )
		print "Variable width of gaussian fit: on"
	else
		print "Variable width of gaussian fit: off"	
	endif
	if( varGcoord == 1 )
		print "Variable center position of gaussian fit: on"
	else
		print "Variable center position of gaussian fit: off"	
	endif
	//
	if( excitationType == 1 )
		print "Excitation type: ALEX."
		if( stLaser == 1 )
		 	startingLaser = -1
		 	print "Starting laser: red."
		else
			startingLaser = 1
			print "Starting laser: green."
		endif
	else
		print "Excitation type: single laser."
	endif
	//
	currentLaser = startingLaser					// -1 : starts with the second laser excitation; 1- the first.
	//***	recording required coordinates
	recordRequiredCoords_TA_MT( paricleToggle, particleInfo, partContTrExtract )
	//***		intensity versus time traces tables, layer 0 - parametr value, 1 - erorr of the fit.
	make/o /d /n = ( numImages , dimSize( partContTrExtract , 0 ), 2 ) traceContainerSignal, traceContCh1, traceContCh2
	make/o /d /n = ( numImages , dimSize( partContTrExtract , 0 ), 2 ) widthContainerSignal, widthContCh1, widthContCh2
	if( excitationType == 1 )
		make/o /d /n = ( numImages , dimSize( partContTrExtract , 0 ), 2 ) traceContAlexCh1, traceContAlexCh2, traceContAlexStoch
		make/o /d /n = ( numImages , dimSize( partContTrExtract , 0 ), 2 ) widthContAlexCh1, widthContAlexCh2
	endif
	// wave for parameters for alignment of 2nd ch image
	make/o /d /n = ( 22 ) parmW = 0
	make/o /n = ( 1, 1 ) tempImage
   //***    	extraction of particle's intesity by gauss fit.
   print "Extracting signals for: "+num2str(dimSize( partContTrExtract , 0 ))+" spots."
   //
	if( TAPrefs.noChToggle == 1 )		// extracts signals from the 1st ch.
		//
		pathinfo path1; 		print "Path to images: "+S_path
		for( ii = 0 ; ii < numImages ; ii += 1 )			// ii runs until reaches the last frame of movie	
			//	update the status line of the control panel
			State_GUI_TA_MT("st ch. traces extraction"+"\r\t frame:\t"+num2str( ii + 1 )+"\t from:\t"+num2str( numImages ) )
			//	load image ii from list in dir defined by path1
			Wave/z tempImage = $StringFromList(0, loadImage_TA_MT( nameList1, ii, 1, imageTypeTog, 0 ),";")
			// dual-view / dual-cam set-up
			cropIm_dualVDualC_ta_mt( tempImage, TAPrefs.imageTypeTA[0], TAPrefs.imageTypeTA[1], TAPrefs.imageTypeTA[3], "stChImage" );	wave/z stChImage
			//
			nthreads = min( 7, ThreadProcessorCount );	 threadGroupID = ThreadGroupCreate(nthreads)
			//
			for( jj = 0; jj < dimSize( partContTrExtract, 0 ); jj += 1 )
				//
				for( kk = 0; kk < nthreads; kk += 1)
					//
					ThreadStart threadGroupID, kk, fitSinglePart( partContTrExtract, stChImage, jj, intGToggle, varGWidth, ii, widthContainerSignal, varGcoord, traceContainerSignal, kk, partContTrExtract[jj][%xW1], partContTrExtract[jj][%xC1], partContTrExtract[jj][%yC1], cropSize )
					jj += 1
					//
					if( jj >= dimSize( partContTrExtract, 0 ) )
						break
					endif
				endfor
				//
				jj -= 1
				//
				do
					threadGroupStatus = ThreadGroupWait(threadGroupID,100)
				while( threadGroupStatus != 0 )
				//
			endfor
			//
			jj= ThreadGroupRelease(threadGroupID)
			//		
		endFor   // end for ii
		//	saving waves
		Save/C/O/P = path4 traceContainerSignal as "030_0_SignalTr.ibw"
		Save/C/O/P = path4 widthContainerSignal as "030_3_widthTr.ibw"
		Save/C/O/P = path4 partContTrExtract as "040_partContTrExtract.ibw"
		//
	elseif( TAPrefs.noChToggle == 2 ) // extracts signals from the 2nd ch.
		//
		pathinfo path2; 		print "Path to images: "+S_path
		for( ii = 0 ; ii < numImages ; ii += 1 )			// ii runs until reaches the last frame of movie	
			//	update the status line of the control panel
			State_GUI_TA_MT("nd ch. traces extraction"+"\r\t frame:\t"+num2str( ii + 1 )+"\t from:\t"+num2str( numImages ) )
			//	load image ii from list in dir defined by path2
			Wave/z tempImage = $StringFromList(0, loadImage_TA_MT( nameList2, ii, 2, imageTypeTog, 0 ),";")
			// dual-view / dual-cam set-up
			cropIm_dualVDualC_ta_mt( tempImage, TAPrefs.imageTypeTA[0], TAPrefs.imageTypeTA[2], TAPrefs.imageTypeTA[3], "ndChImage" );	wave/z ndChImage
			// align image
			if( TAPrefs.regParams[ 0 ]  == 1 )
				parmW = 0
				parmW[0] = TAPrefs.regParams[ 1 ] // dx
				parmW[1] = TAPrefs.regParams[ 2 ] // dy
				parmW[3] = TAPrefs.regParams[ 3 ] // a11
				parmW[4] = TAPrefs.regParams[ 4 ] // a12
				parmW[6] = TAPrefs.regParams[ 5 ] //a21
				parmW[7] = TAPrefs.regParams[ 6 ] //a22
				parmW[11] = TAPrefs.regParams[ 7 ] //a33
				parmW[17] = TAPrefs.regParams[ 8 ] // originX
				parmW[18] = TAPrefs.regParams[ 9 ] // originY
				//
				alignImage2_paramsGiven_TA_MT( ndChImage, parmW  );  wave/z ndChImage = M_RegOut
				//
			endif
			//
			nthreads = min( 7, ThreadProcessorCount );	 threadGroupID = ThreadGroupCreate(nthreads)
			//
			for( jj = 0; jj < dimSize( partContTrExtract, 0 ); jj += 1 )
				//
				for( kk = 0; kk < nthreads; kk += 1)
					//
					ThreadStart threadGroupID, kk, fitSinglePart( partContTrExtract, ndChImage, jj, intGToggle, varGWidth, ii, widthContainerSignal, varGcoord, traceContainerSignal, kk, partContTrExtract[jj][%xW2], partContTrExtract[jj][%xC2], partContTrExtract[jj][%yC2], cropSize )
					jj += 1
					//
					if( jj >= dimSize( partContTrExtract, 0 ) )
						break
					endif
				endfor
				//
				jj -= 1
				//
				do
					threadGroupStatus = ThreadGroupWait(threadGroupID,100)
				while( threadGroupStatus != 0 )
				//
			endfor
			//
			jj= ThreadGroupRelease(threadGroupID)
			//
		endFor   // end for ii
		//	saving waves
		Save/C/O/P = path4 traceContainerSignal as "030_0_SignalTr.ibw"
		Save/C/O/P = path4 widthContainerSignal as "030_3_widthTr.ibw"
		Save/C/O/P = path4 partContTrExtract as "040_partContTrExtract.ibw"
		//
	elseif( TAPrefs.noChToggle == 3 )		// extracts signals from both channels and calculates FRET efficiency
		//
		pathinfo path1; 		print "Path to donor ch. images: "+S_path
		pathinfo path2; 		print "Path to acceptor ch. images: "+S_path
		//
		for( ii = 0 ; ii < numImages ; ii += 1 )			// ii runs until reaches the last frame of movie
			//	update the status line of the control panel
			State_GUI_TA_MT("Two ch. traces extraction"+"\r\t frame:\t"+num2str( ii + 1 )+"\t from:\t"+num2str( numImages ) )
			//	load image ii from list in dir defined by path1
			Wave/z tempImage = $StringFromList(0, loadImage_TA_MT( nameList1, ii, 1, imageTypeTog, 0 ),";")
			// dual-view / dual-cam set-up
			cropIm_dualVDualC_ta_mt( tempImage, TAPrefs.imageTypeTA[0], TAPrefs.imageTypeTA[1], TAPrefs.imageTypeTA[3], "stChImage" ); wave/z stChImage
			//	extract intensities of particles in frame ii
			nthreads = min( 7, ThreadProcessorCount );	 threadGroupID = ThreadGroupCreate(nthreads)
			//
			for( jj = 0; jj < dimSize( partContTrExtract, 0 ); jj += 1 )
				//
				for( kk = 0; kk < nthreads; kk += 1)
					//
					if( excitationType == 1 )
						//
						if( currentLaser == 1 )
							ThreadStart threadGroupID, kk, fitSinglePart( partContTrExtract, stChImage, jj, intGToggle, varGWidth, ii, widthContCh1, varGcoord, traceContCh1, kk, partContTrExtract[jj][%xW1], partContTrExtract[jj][%xC1], partContTrExtract[jj][%yC1], cropSize )
						else
							ThreadStart threadGroupID, kk, fitSinglePart( partContTrExtract, stChImage, jj, intGToggle, varGWidth, ii, widthContAlexCh1, varGcoord, traceContAlexCh1, kk, partContTrExtract[jj][%xW1], partContTrExtract[jj][%xC1], partContTrExtract[jj][%yC1], cropSize )
						endif
						//
					else
						ThreadStart threadGroupID, kk, fitSinglePart( partContTrExtract, stChImage, jj, intGToggle, varGWidth, ii, widthContCh1, varGcoord, traceContCh1, kk, partContTrExtract[jj][%xW1], partContTrExtract[jj][%xC1], partContTrExtract[jj][%yC1], cropSize )
					endif
					jj += 1
					//
					if( jj >= dimSize( partContTrExtract, 0 ) )
						break
					endif
				endfor
				//
				jj -= 1
				//
				do
					threadGroupStatus = ThreadGroupWait(threadGroupID,100)
				while( threadGroupStatus != 0 )
				//
			endfor
			//
			jj= ThreadGroupRelease(threadGroupID)
			//
			killWaves/z tempImage
			//	load image ii from list in dir defined by path2
			Wave/z tempImage = $StringFromList(0, loadImage_TA_MT( nameList2, ii, 2, imageTypeTog, 0 ),";")	
			// dual-view / dual-cam set-up
			cropIm_dualVDualC_ta_mt( tempImage, TAPrefs.imageTypeTA[0], TAPrefs.imageTypeTA[2], TAPrefs.imageTypeTA[3], "ndChImage" );	wave/z ndChImage
			// align image
			if( TAPrefs.regParams[ 0 ]  == 1 )
				parmW = 0
				parmW[0] = TAPrefs.regParams[ 1 ] // dx
				parmW[1] = TAPrefs.regParams[ 2 ] // dy
				parmW[3] = TAPrefs.regParams[ 3 ] // a11
				parmW[4] = TAPrefs.regParams[ 4 ] // a12
				parmW[6] = TAPrefs.regParams[ 5 ] //a21
				parmW[7] = TAPrefs.regParams[ 6 ] //a22
				parmW[11] = TAPrefs.regParams[ 7 ] //a33
				parmW[17] = TAPrefs.regParams[ 8 ] // originX
				parmW[18] = TAPrefs.regParams[ 9 ] // originY
				//
				alignImage2_paramsGIven_TA_MT( ndChImage, parmW  ); wave/z ndChImage = M_RegOut
				//
			endif
			// multi-processsor signal extraction.
			nthreads= min( 7, ThreadProcessorCount );	 threadGroupID= ThreadGroupCreate(nthreads)
			//	
			for( jj = 0; jj < dimSIze( partContTrExtract, 0 ); jj += 1 )
				//
				for( kk = 0; kk < nthreads; kk += 1)
					if( excitationType == 1 )
						if( currentLaser == 1 )
							ThreadStart threadGroupID, kk, fitSinglePart( partContTrExtract, ndChImage, jj, intGToggle, varGWidth, ii, widthContCh2, varGcoord, traceContCh2, kk, partContTrExtract[jj][%xW2], partContTrExtract[jj][%xC2], partContTrExtract[jj][%yC2], cropSize )
						else
							ThreadStart threadGroupID, kk, fitSinglePart( partContTrExtract, ndChImage, jj, intGToggle, varGWidth, ii, widthContAlexCh2, varGcoord, traceContAlexCh2, kk, partContTrExtract[jj][%xW2], partContTrExtract[jj][%xC2], partContTrExtract[jj][%yC2], cropSize )
						endif
					else
						ThreadStart threadGroupID, kk, fitSinglePart( partContTrExtract, ndChImage, jj, intGToggle, varGWidth, ii, widthContCh2, varGcoord, traceContCh2, kk, partContTrExtract[jj][%xW2], partContTrExtract[jj][%xC2], partContTrExtract[jj][%yC2], cropSize )
					endif
					jj += 1
					if( jj >= dimSIze( partContTrExtract, 0 ) )
						break
					endif
				endfor
				//
				jj -= 1
				//
				do
					threadGroupStatus = ThreadGroupWait(threadGroupID,100)
				while( threadGroupStatus != 0 )
				//
			endfor
			//
			jj= ThreadGroupRelease(threadGroupID)
			// update laser
			currentLaser *= -1
			//
		endFor   // end for ii
		//*******
		// calculate FRET efficiency traces
		traceContainerSignal[ ][ ][ 0 ] = traceContCh2[ p ][ q ][ 0 ] / ( traceContCh1[ p ][ q ][ 0 ] + traceContCh2[ p ][ q ][ 0 ] )		// Efret = Iacc / ( Iacc + Idon )
		//******
		// remove unfilled entries of tables in case of ALEX
		if( excitationType == 1 )
			// 635nm excitation
			if( startingLaser == -1 )
				ii = 1
			else
				ii = 0
			endif
			//
			do
				deletepoints/m= 0 ii, 1, traceContAlexCh1, traceContAlexCh2, widthContAlexCh1, widthContAlexCh2, traceContAlexStoch
				ii += 1
				if( ii >= Dimsize( traceContAlexCh1, 0 ) )
					break
				endif
			while(1)
			// 532nm excitation
			if( startingLaser == -1 )
				ii = 0
			else
				ii = 1
			endif
			//
			do
				deletepoints/m= 0 ii, 1, traceContainerSignal, traceContCh1, traceContCh2, widthContCh1, widthContCh2
				ii += 1
				if( ii >= Dimsize( traceContCh1, 0 ) )
					break
				endif
			while(1)	
			// calculate stochiometry factor for each point
			// Sraw = Fdd  + Fda / Fdd + Fda  + Faa (fist index denotes excitation ch, second emission ch.)
			// calculation comes from: Biophys J. 2005 Apr; 88(4): 29392953, doi:  10.1529/biophysj.104.054114. Nam Ki Lee and Achillefs Kapanidis
			traceContAlexStoch[][][] = traceContCh1[p][q][0] + traceContCh2[p][q][0]
			traceContAlexStoch[][][] /=  traceContCh1[p][q][0] + traceContCh2[p][q][0] + traceContAlexCh2[p][q][0]
			//
		endif
		//	saving waves
		Save/C/O/P = path4 traceContainerSignal as "030_0_SignalTr.ibw"
		Save/C/O/P = path4 traceContCh1 as "030_1_SignalTr.ibw"
		Save/C/O/P = path4 traceContCh2 as "030_2_SignalTr.ibw"
		Save/C/O/P = path4 widthContCh1 as "030_4_widthTr.ibw"
		Save/C/O/P = path4 widthContCh2 as "030_5_widthTr.ibw"
		// alex
		if( excitationType == 1 )
			Save/C/O/P = path4 traceContAlexCh1 as "030_6_SignalTr.ibw"
			Save/C/O/P = path4 traceContAlexCh2 as "030_7_SignalTr.ibw"
			Save/C/O/P = path4 widthContAlexCh1 as "030_8_widthTr.ibw"
			Save/C/O/P = path4 widthContAlexCh2 as "030_9_widthTr.ibw"
			Save/C/O/P = path4 traceContAlexStoch as "030_10_SignalTr.ibw"
		endif	
		// spot info
		Save/C/O/P = path4 partContTrExtract as "040_partContTrExtract.ibw"
		//
	endif
	//	closing unnecessay windows
	dowindow/k graph1; 	dowindow/k ndChannel; 	dowindow/k stChannel
	dowindow/k thresholdChannel; 		dowindow/k tempWind
	// 	update structure variables
	leftImage2 = TAPrefs.imageCoords[ 8 ]
	topImage2 = TAPrefs.imageCoords[ 9 ]
	rightImage2 = TAPrefs.imageCoords[ 10 ]
	bottomImage2 = TAPrefs.imageCoords[ 11 ]
	//	saving structure preferences
	save_preferences_TA_MT( TAPrefs )
	// 	saving notes 
	Notes_signalExtraction_TA_MT(   )
	//
	State_GUI_TA_MT("Signals extracted.")
	print "Signals were extracted!"+time()
	// releasing memory ocupied by local variables, strings and waves
	killVariables/z/a; killStrings/z/a; killWaves/z/a
	//
end  // end of traces making procedure
// *************************************************************************************
// ****** Record required type of spots coordinates for trace extraction
Function recordRequiredCoords_TA_MT( paricleToggle, particleInfo, partContTrExtract )
	// input 
	variable paricleToggle
	wave particleInfo, partContTrExtract
	// local variabes
	variable zz = 0, ii = 0
	//
	if( paricleToggle < 4 )
		//
		for( ii = 0 ; ii < dimSize( particleInfo , 0 ) ; ii += 1 )
			//
			if( particleInfo[ ii ][ %type1 ] == paricleToggle )
				// insert a point only if the pointer to tha table is more than the size of table in x direction
				if( zz >= dimsize( partContTrExtract, 0 ) )
					insertPoints/m=0 zz , 1 , partContTrExtract
				endif
				//
				partContTrExtract[ zz ][ ] = particleInfo[ ii ][ q ]		// all columns
				if( paricleToggle == 2 )	// ch2
					partContTrExtract[ zz ][%index1] = particleInfo[ ii ][ %index2 ]
					partContTrExtract[ zz ][%xC1] = particleInfo[ ii ][ %xC2 ]
					partContTrExtract[ zz ][%yC1] = particleInfo[ ii ][ %yC2 ]
					partContTrExtract[ zz ][%amp1] = particleInfo[ ii ][ %amp2 ]
					partContTrExtract[ zz ][%ampErr1] = particleInfo[ ii ][ %ampErr2 ]
					partContTrExtract[ zz ][%xW1] = particleInfo[ ii ][ %xW2 ]	
					partContTrExtract[ zz ][%xWErr1] = particleInfo[ ii ][ %xWErr2 ]
					partContTrExtract[ zz ][%avgRInt1] = particleInfo[ ii ][ %avgRInt2 ]
					partContTrExtract[ zz ][%z01] = particleInfo[ ii ][ %z02 ]
				elseif( paricleToggle == 1 )	// ch1
					partContTrExtract[ zz ][%index2] = particleInfo[ ii ][ %index1 ]
					partContTrExtract[ zz ][%xC2] = particleInfo[ ii ][ %xC1 ]
					partContTrExtract[ zz ][%yC2] = particleInfo[ ii ][ %yC1 ]
					partContTrExtract[ zz ][%amp2] = particleInfo[ ii ][ %amp1 ]
					partContTrExtract[ zz ][%ampErr2] = particleInfo[ ii ][ %ampErr1 ]
					partContTrExtract[ zz ][%xW2] = particleInfo[ ii ][ %xW1 ]	
					partContTrExtract[ zz ][%xWErr2] = particleInfo[ ii ][ %xWErr1 ]
					partContTrExtract[ zz ][%avgRInt2] = particleInfo[ ii ][ %avgRInt1 ]
					partContTrExtract[ zz ][%z02] = particleInfo[ ii ][ %z01 ]
				endif
				zz += 1
				//
			endif
			//
		endFor
		//
	elseif( paricleToggle == 4 ) // all ch1
		//
		for( ii = 0 ; ii < dimSize( particleInfo , 0 ) ; ii += 1 )
			//
			if( particleInfo[ ii ][ %type1 ] == 1 || particleInfo[ ii ][ %type1 ] == 3 )
				// insert a point only if the pointer to tha table is more than the size of table in x direction
				if( zz >= dimsize( partContTrExtract, 0 ) )
					insertPoints/m=0 zz , 1 , partContTrExtract
				endif
				//
				partContTrExtract[ zz ][ ] = particleInfo[ ii ][ q ]		// all columns
				//
				if( particleInfo[ ii ][ %type1 ] == 1 )	// ch1
					partContTrExtract[ zz ][ %index2 ] = particleInfo[ ii ][ %index1 ]
					partContTrExtract[ zz ][ %xC2 ] = particleInfo[ ii ][ %xC1 ]
					partContTrExtract[ zz ][ %yC2 ] = particleInfo[ ii ][ %yC1 ]
					partContTrExtract[ zz ][ %amp2 ] = particleInfo[ ii ][ %amp1 ]
					partContTrExtract[ zz ][ %ampErr2 ] = particleInfo[ ii ][ %ampErr1 ]
					partContTrExtract[ zz ][ %xW2 ] = particleInfo[ ii ][ %xW1 ]	
					partContTrExtract[ zz ][ %xWErr2 ] = particleInfo[ ii ][ %xWErr1 ]
					partContTrExtract[ zz ][ %avgRInt2 ] = particleInfo[ ii ][ %avgRInt1 ]
					partContTrExtract[ zz ][ %z02 ] = particleInfo[ ii ][ %z01 ]
				endif
				//
				zz += 1
				//
			endif
			//
		endFor
		//	
	elseif( paricleToggle == 5 ) // all ch2
		//
		for( ii = 0 ; ii < dimSize( particleInfo , 0 ) ; ii += 1 )
			//
			if( particleInfo[ ii ][ %type1 ] == 2 || particleInfo[ ii ][ %type1 ] == 3 )
				// insert a point only if the pointer to tha table is more than the size of table in x direction
				if( zz >= dimsize( partContTrExtract, 0 ) )
					insertPoints/m=0 zz , 1 , partContTrExtract
				endif
				//
				partContTrExtract[ zz ][ ] = particleInfo[ ii ][ q ]		// all columns
				//
				if( particleInfo[ ii ][ %type1 ] == 2 )	// ch2
					partContTrExtract[ zz ][ %index1 ] = particleInfo[ ii ][ %index2 ]
					partContTrExtract[ zz ][ %xC1 ] = particleInfo[ ii ][ %xC2 ]
					partContTrExtract[ zz ][ %yC1 ] = particleInfo[ ii ][ %yC2 ]
					partContTrExtract[ zz ][ %amp1 ] = particleInfo[ ii ][ %amp2 ]
					partContTrExtract[ zz ][ %ampErr1 ] = particleInfo[ ii ][ %ampErr2 ]
					partContTrExtract[ zz ][ %xW1 ] = particleInfo[ ii ][ %xW2 ]	
					partContTrExtract[ zz ][ %xWErr1 ] = particleInfo[ ii ][ %xWErr2 ]
					partContTrExtract[ zz ][ %avgRInt1 ] = particleInfo[ ii ][ %avgRInt2 ]
					partContTrExtract[ zz ][ %z01 ] = particleInfo[ ii ][ %z02 ]
				endif
				//
				zz += 1
				//
			endif
			//
		endFor
		//	
	elseif( paricleToggle == 6 ) // copy entire table
		duplicate/o particleInfo, partContTrExtract
	endif
	//
end
// *************************************************
// ******* dual-view / dual-cam set-up
function  cropIm_dualVDualC_ta_mt( inW, dualVdualC, topBottom, horizVert, strWaveName )
	wave inW
	variable dualVdualC, topBottom, horizVert
	string strWaveName
	// dual-view/ dual-cam set-up
	if( dualVdualC == 1 )	// dual-view set-up
		//
		if( topBottom == 1 )	// top
			//
			if( horizVert == 1 )	// horizontal
				duplicate/o /r =[*,*][0,round( dimsize(inW,1)*0.5 ) - 1] inW, $strWaveName;	setscale/p x 0, 1 , $strWaveName; 	setscale/p y 0, 1 , $strWaveName
			else								// vertical
				duplicate/o /r =[0,round( dimsize(inW,1)*0.5 )-1][*,*] inW, $strWaveName;		setscale/p x 0, 1 , $strWaveName; 	setscale/p y 0, 1 , $strWaveName
			endif
			//
		else								// bottom
			//
			if( horizVert == 1 )	// horizontal
				duplicate/o /r =[*,*][round( dimsize(inW,1)*0.5 ),* ] inW, $strWaveName;	setscale/p x 0, 1 , $strWaveName; 	setscale/p y 0, 1 , $strWaveName
			else								// vertical
				duplicate/o /r =[round( dimsize(inW,1)*0.5 ),*][*,*] inW, $strWaveName;	setscale/p x 0, 1 , $strWaveName; 	setscale/p y 0, 1 , $strWaveName
			endif
			//			
		endif
		//
	else					//full image: dual - cam set-up
		// 
		wave/z croppedInW = inW
		//
	endif
	//
end
//**********************    colocalize particles     *************************
function/d coLocalizeAllPArticles( stChWIn, ndChWIn, colocDistance )
	wave stChWIn, ndChWIn
	variable colocDistance
	//
	print "*********************************************************************************"
	Print "Spots from 1st and 2nd channel within "+num2str(colocDistance)+" pix. distance will be considered as co-localized."
	// local variables
	variable aa = dimSize( stChWIn, 0 ) + dimsize( ndChWIn, 0 )
	variable bb =  abs( dimSIze(stChWIn,1) + dimSize( ndChWIn, 1 ) ) - 1
	variable distance = 0, numColoc = 0
	// make a table for storing infor of all spots.
	make/o /n=( aa , bb ) allParticlesContainer
	// give labels for the table
	string tempNames = "index1;xC1;yC1;amp1;ampErr1;xW1;xWErr1;avgRInt1;z01;type1;"
	tempNames += "index2;xC2;yC2;amp2;ampErr2;xW2;xWErr2;avgRInt2;z02;"
	make/o/t/n = ( dimSIze( allParticlesContainer , 1 ) ) labelsWave = StringFromList( p, tempNames , ";" )
	labeling_TA_MT( allParticlesContainer , labelsWave , 1 )
	// fill the table
	bb = 0
	for( aa = 0 ; aa < dimsize( stChWIn, 0 ) ; aa += 1 )
		allParticlesContainer[ bb ][ ] = stChWIn[ aa ][ q ]
		bb += 1
	endfor
	for( aa = 0 ; aa < dimsize( ndChWIn, 0 ) ; aa += 1 )
		allParticlesContainer[ bb ][ ] = ndChWIn[ aa ][ q ]
		bb += 1
	endfor
	// identify spots which are co-localised in between ch1 and ch2.
	aa = 0; bb = 0;
	do
		bb = aa + 1
		make/o /d /n = 0 distanceWave, indexWave1
		do // calculate distance in pixels between particle aa and bb
			distance = sqrt( (allParticlesContainer[ aa ][ %xC1 ] - allParticlesContainer[ bb ][ %xC1 ] )^2 + (allParticlesContainer[ aa ][ %yC1 ] - allParticlesContainer[ bb ][ %yC1 ] )^2 )
			//
			if( distance <= colocDistance && allParticlesContainer[ bb ][ %type1 ] != allParticlesContainer[ aa ][ %type1 ]  )
				insertPoints/m= 0 0, 1, distanceWave, indexWave1
				distanceWave[ 0 ] = distance
				indexWave1[ 0 ] = bb
			endif
			bb += 1
			if( bb >= dimSize( allParticlesContainer, 0 ) )
				break
			endif
		while( 1 > 0 )
		// finding closest particle - co-localization
		if( dimSize( distanceWave, 0 ) > 0 )
			//
			sort distanceWave, distanceWave, indexWave1
			// type of particle: co-localized
			allParticlesContainer[ aa ][ %type1 ] = 3
			//  fill values for 2nd channel
			allParticlesContainer[ aa ][ %index2 ] = allParticlesContainer[ indexWave1[ 0 ] ][ %index1 ]
			allParticlesContainer[ aa ][ %xC2 ] = allParticlesContainer[ indexWave1[ 0 ] ][ %xC1 ]
			allParticlesContainer[ aa ][ %yC2 ] = allParticlesContainer[ indexWave1[ 0 ] ][ %yC1 ]
			allParticlesContainer[ aa ][ %amp2 ] = allParticlesContainer[ indexWave1[ 0 ] ][ %amp1 ]
			allParticlesContainer[ aa ][ %ampErr2 ] = allParticlesContainer[ indexWave1[ 0 ] ][ %ampErr1 ]
			allParticlesContainer[ aa ][ %xW2 ] = allParticlesContainer[ indexWave1[ 0 ] ][ %xW1 ]
			allParticlesContainer[ aa ][ %xWErr2 ] = allParticlesContainer[ indexWave1[ 0 ] ][ %xWErr1 ]
			allParticlesContainer[ aa ][ %avgRInt2 ] = allParticlesContainer[ indexWave1[ 0 ] ][ %avgRInt1 ]
			allParticlesContainer[ aa ][ %z02 ] = allParticlesContainer[ indexWave1[ 0 ] ][ %z01 ]
			// delete the co-localizing 1st ch entry
			deletepoints/m= 0 indexWave1[ 0 ], 1 , allParticlesContainer
			// update number of co-localing particle counter
			numColoc += 1
			//
		endif
		// ******   update counter
		aa += 1
		// ****** stop the loop if it exceeds the dimensions 
		if ( aa + 1 >= dimSize( allParticlesContainer, 0 ) )
			break
		endif
	while( 1 > 0 )
	// find non-coloc spots and copy it self info tho the second half of the table.
	for( aa = 0 ; aa < dimsize(allParticlesContainer, 0) ; aa += 1 )
		// co-loc index is 3, otherwise not coloc.
		if( allParticlesContainer[ aa ][ %type1 ] == 2 )		// 1st channel spot
			// fill right half of the table with the same info as in the left side.
			allParticlesContainer[ aa ][ %index2 ] = allParticlesContainer[ aa ][ %index1 ]
			allParticlesContainer[ aa ][ %xC2 ] = allParticlesContainer[ aa ][ %xC1 ]
			allParticlesContainer[ aa ][ %yC2 ] = allParticlesContainer[ aa ][ %yC1 ]
			allParticlesContainer[ aa ][ %amp2 ] = allParticlesContainer[ aa ][ %amp1 ]
			allParticlesContainer[ aa ][ %ampErr2 ] = allParticlesContainer[ aa ][ %ampErr1 ]
			allParticlesContainer[ aa ][ %xW2 ] = allParticlesContainer[ aa ][ %xW1 ]
			allParticlesContainer[ aa ][ %xWErr2 ] = allParticlesContainer[ aa ][ %xWErr1 ]
			allParticlesContainer[ aa ][ %avgRInt2 ] = allParticlesContainer[ aa ][ %avgRInt1 ]
			allParticlesContainer[ aa ][ %z02 ] = allParticlesContainer[ aa ][ %z01 ]
			//
			allParticlesContainer[ aa ][ %index1 ] = nan
			allParticlesContainer[ aa ][ %xC1 ] = nan
			allParticlesContainer[ aa ][ %yC1 ] = nan
			allParticlesContainer[ aa ][ %amp1 ] = nan
			allParticlesContainer[ aa ][ %ampErr1 ] = nan
			allParticlesContainer[ aa ][ %xW1 ] = nan
			allParticlesContainer[ aa ][ %xWErr1 ] = nan
			allParticlesContainer[ aa ][ %avgRInt1 ] = nan
			allParticlesContainer[ aa ][ %z01 ] = nan
			//
		elseif(  allParticlesContainer[ aa ][ %type1 ] == 1 )	// 2nd channel spot
			//
			allParticlesContainer[ aa ][ %index2 ] = nan
			allParticlesContainer[ aa ][ %xC2 ] = nan
			allParticlesContainer[ aa ][ %yC2 ] = nan
			allParticlesContainer[ aa ][ %amp2 ] = nan
			allParticlesContainer[ aa ][ %ampErr2 ] = nan
			allParticlesContainer[ aa ][ %xW2 ] = nan
			allParticlesContainer[ aa ][ %xWErr2 ] = nan
			allParticlesContainer[ aa ][ %avgRInt2 ] = nan
			allParticlesContainer[ aa ][ %z02 ] = nan
			//
		endif
		//
	endFor
	//
	killWaves/z 	distanceWave, indexWave1
	killVariables/z   aa , bb, distance
	killstrings/z tempNames
	//
	return numColoc
end
// 	fit a circular 2D gaussian for a piece of image
ThreadSafe function fitSinglePart( partContTrExtract, imageIn, indexCol,  intGToggle, varGWidthToggle, indexRow, widthContainerSignal, varGcoordToggle, destW, threadIndex, width, xCenter, yCenter, cropSize )
	wave partContTrExtract, imageIn, widthContainerSignal, destW
	variable indexCol, intGToggle, varGWidthToggle, indexRow, varGcoordToggle, threadIndex
	variable width, xCenter, yCenter, cropSize
	// making waves for fitting parameter storing.
	make/o /d /n = 5 W_coefGauss0, W_coefGauss1, W_coefGauss2, W_coefGauss3, W_coefGauss4, W_coefGauss5, W_coefGauss6
	make/o /d /n = 5 W_sigma
	//   local variables
	variable x1_0, x2_0, y1_0, y2_0
	variable x1_1, x2_1, y1_1, y2_1
	variable x1_2, x2_2, y1_2, y2_2
	variable x1_3, x2_3, y1_3, y2_3
	variable x1_4, x2_4, y1_4, y2_4
	variable x1_5, x2_5, y1_5, y2_5
	variable x1_6, x2_6, y1_6, y2_6
	variable/G V_fitError = 0
	//
	if( threadIndex == 0 )
		// 	boundaries of roi in x and y directions
		x1_0 = max( 0, round(xCenter - cropSize) );	x2_0 = min( round(xCenter + cropSize), dimSize( imageIn, 0 ) - 1 )
		y1_0 = max( 0, round(yCenter - cropSize) );	y2_0 = min( round(yCenter + cropSize), dimSIze( imageIn, 1 ) - 1 )
		imagestats/q /m=1 /G={x1_0 ,x2_0, y1_0 ,y2_0 } imageIn
		//
		W_coefGauss0 = { V_min, imageIn[xCenter][yCenter] - V_min, xCenter, yCenter, width }
		//	Fitting og 2D circular Gaussian with these constrains
		V_fitError = 0
		//
		if( varGWidthToggle == 1 &&  varGcoordToggle == 1 )  // no parameters hold
			//
			make/o /n = ( 6 , 5 ) m_constrain0 = 0
			m_constrain0[0][2] = -1; 	m_constrain0[1][2] = 1; 	m_constrain0[2][3] = -1; 	m_constrain0[3][3] = 1; 	m_constrain0[4][4] = -1	; m_constrain0[5][4] = 1
			make/o /n = 6 w_constrain0 = {-x1_0,x2_0,-y1_0, y2_0, -0.001 , cropSize*2}
			//
			FuncFitMD/H="00000"/N /NTHR=1 /G /W =2 /Q  gaus2dAllAtOnce W_coefGauss0  imageIn[x1_0, x2_0][y1_0, y2_0] /C={m_constrain0, w_constrain0} 
			//
		elseif( varGWidthToggle == 1 &&  varGcoordToggle != 1 )  // hold center
			//
			make/o /n = ( 2 , 5 ) m_constrain0 = 0; 		m_constrain0[0][4] = -1; m_constrain0[1][4] = 1	
			make/o /n = 2 w_constrain0 = {-0.001,cropSize*2}
			//
			FuncFitMD/H="00110"/N /NTHR=1 /G /W =2 /Q gaus2dAllAtOnce W_coefGauss0  imageIn[x1_0, x2_0][y1_0, y2_0] /C={m_constrain0, w_constrain0}
			//
		elseif( varGWidthToggle != 1 &&  varGcoordToggle == 1 ) // hold width
			//
			make/o /n = ( 4 , 5 ) m_constrain0 = 0; 		m_constrain0[0][2] = -1; 	m_constrain0[1][2] = 1; 	m_constrain0[2][3] = -1; 	m_constrain0[3][3] = 1	
			make/o /n = 4 w_constrain0 = {-x1_0,x2_0,-y1_0, y2_0}
			//
			FuncFitMD/H="00001"/N /NTHR=1 /G /W =2 /Q gaus2dAllAtOnce W_coefGauss0  imageIn[x1_0, x2_0][y1_0, y2_0] /C={m_constrain0, w_constrain0} 
			//
		else		// hold center and width
			FuncFitMD/H="00111"/N /NTHR=1 /G /W =2 /Q gaus2dAllAtOnce W_coefGauss0  imageIn[x1_0, x2_0][y1_0, y2_0]
		endif
		duplicate/o W_sigma, W_sigma1
		// if fitt succeeded
		if( W_coefGauss0[ 1 ] != 0 )
			//
			if( intGToggle == 1 )		 // amplitude
				destW[ indexRow ][ indexCol ][ 0 ] = W_coefGauss0[ 1 ]
				destW[ indexRow ][ indexCol ][ 1 ] = W_sigma1[ 1 ]		// error of the fit value.
			elseif( intGToggle == 2 )	// gaussian integral
				destW[ indexRow ][ indexCol ][ 0 ] = W_coefGauss0[ 1 ] * abs( W_coefGauss0[ 4 ] ^ 2 )
				destW[ indexRow ][ indexCol ][ 1 ] = W_sigma1[ 1 ] 	// error of the fit value.
			endif
			//
			if( varGWidthToggle == 1 )
				widthContainerSignal[ indexRow ][ indexCol ][ 0 ] = W_coefGauss0[ 4 ]
				widthContainerSignal[ indexRow ][ indexCol ][ 1 ] = W_sigma1[ 4 ]			// error of the fit value
			endif
			//
		else		// if fit failed
			//
			destW[ indexRow ][ indexCol ][ 0 ] = 0
			destW[ indexRow ][ indexCol ][ 1 ] = 0
			//
			if( varGWidthToggle == 1 )
				widthContainerSignal[ indexRow ][ indexCol ][ 0 ] = 0
				widthContainerSignal[ indexRow ][ indexCol ][ 1 ] = 0
			endif
			//
		endif
		//
	elseif( threadIndex == 1 )
		// 	boundaries of roi in x and y directions
		x1_1 = max( 0, round(xCenter - cropSize) );	x2_1 = min( round(xCenter + cropSize), dimSize( imageIn, 0 ) - 1 )
		y1_1 = max( 0, round(yCenter - cropSize) );	y2_1 = min( round(yCenter + cropSize), dimSIze( imageIn, 1 ) - 1 )
		imagestats/q /m=1 /G={x1_1 ,x2_1, y1_1 ,y2_1 } imageIn
		//
		W_coefGauss1 = { V_min, imageIn[xCenter][yCenter] - V_min, xCenter, yCenter, width }
		//	Fitting og 2D circular Gaussian with these constrains
		V_fitError = 0
		//
		if( varGWidthToggle == 1 &&  varGcoordToggle == 1 )  // no parameters hold.
			//
			make/o /n = ( 6 , 5 ) m_constrain1 = 0
			m_constrain1[0][2] = -1; 	m_constrain1[1][2] = 1; m_constrain1[2][3] = -1; m_constrain1[3][3] = 1; m_constrain1[4][4] = -1; m_constrain1[5][4] = 1
			make/o /n = 6 w_constrain1 = {-x1_1,x2_1,-y1_1, y2_1, -0.001 , cropSize*2}
			//
			FuncFitMD/c/H="00000"/N /NTHR=1 /G /W =2 /Q gaus2dAllAtOnce W_coefGauss1  imageIn[x1_1, x2_1][y1_1, y2_1] /C={m_constrain1, w_constrain1} 
			//
		elseif( varGWidthToggle == 1 &&  varGcoordToggle != 1 )  // hold center
			//
			make/o /n = ( 2 , 5 ) m_constrain1 = 0; 		m_constrain1[0][4] = -1; m_constrain1[1][4] = 1
			make/o /n = 2 w_constrain1 = {-0.001,cropSize*2}
			//
			FuncFitMD/c/H="00110"/N /NTHR=1 /G /W =2 /Q gaus2dAllAtOnce W_coefGauss1  imageIn[x1_1, x2_1][y1_1, y2_1] /C={m_constrain1, w_constrain1} 
			//
		elseif( varGWidthToggle != 1 &&  varGcoordToggle == 1 ) // hold width
			//
			make/o /n = ( 4 , 5 ) m_constrain1 = 0; 		m_constrain1[0][2] = -1; m_constrain1[1][2] = 1; m_constrain1[2][3] = -1; m_constrain1[3][3] = 1
			make/o /n = 4 w_constrain1 = {-x1_1,x2_1,-y1_1, y2_1}
			//
			FuncFitMD/c/H="00001"/N /NTHR=1 /G /W =2 /Q gaus2dAllAtOnce W_coefGauss1  imageIn[x1_1, x2_1][y1_1, y2_1] /C={m_constrain1, w_constrain1} 
			//
		else		// hold center and width
			FuncFitMD/c/H="00111"/N /NTHR=1 /G /W =2 /Q gaus2dAllAtOnce W_coefGauss1  imageIn[x1_1, x2_1][y1_1, y2_1]
		endif
		duplicate/o W_sigma, W_sigma2
		// if fitt succeeded
		if( W_coefGauss1[ 1 ] != 0 )
			if( intGToggle == 1 )		// amplitude
				destW[ indexRow ][ indexCol ][ 0 ] = W_coefGauss1[ 1 ]
				destW[ indexRow ][ indexCol ][ 1 ] = W_sigma2[ 1 ]			// error of the fit
			elseif( intGToggle == 2 )	// gaussian integral
				destW[ indexRow ][ indexCol ][ 0 ] = W_coefGauss1[ 1 ] * abs( W_coefGauss1[ 4 ] ^ 2 )
				destW[ indexRow ][ indexCol ][ 1 ] = W_sigma2[ 1 ]			// error of the fit
			endif
			//
			if( varGWidthToggle == 1 )
				widthContainerSignal[ indexRow ][ indexCol ][ 0 ] = W_coefGauss1[ 4 ]
				widthContainerSignal[ indexRow ][ indexCol ][ 1 ] = W_sigma2[ 4 ]
			endif
			//
		else		// if fit failed
			destW[ indexRow ][ indexCol ][ 0 ] = 0
			destW[ indexRow ][ indexCol ][ 1 ] = 0
			//
			if( varGWidthToggle == 1 )
				widthContainerSignal[ indexRow ][ indexCol ][ 0 ] = 0
				widthContainerSignal[ indexRow ][ indexCol ][ 1 ] = 0
			endif
			//
		endif
		//
	elseif( threadIndex == 2 )
		// 	boundaries of roi in x and y directions
		x1_2 = max( 0, round( xCenter - cropSize ) );	x2_2 = min( round( xCenter + cropSize ), dimSize( imageIn, 0 ) - 1 )
		y1_2 = max( 0, round( yCenter - cropSize ) );	y2_2 = min( round( yCenter + cropSize ), dimSIze( imageIn, 1 ) - 1 )
		imagestats/q /m=1 /G={x1_2 ,x2_2, y1_2 ,y2_2 } imageIn
		//	extract statistics of ROI
		W_coefGauss2 = { V_min, imageIn[xCenter][yCenter] - V_min, xCenter, yCenter, width }
		//	Fitting og 2D circular Gaussian with these constrains
		V_fitError = 0
		//
		if( varGWidthToggle == 1 &&  varGcoordToggle == 1 )  // no parameters hold.
			//
			make/o /n = ( 6 , 5 ) m_constrain2 = 0
			m_constrain2[0][2] = -1; 	m_constrain2[1][2] = 1; m_constrain2[2][3] = -1; m_constrain2[3][3] = 1; m_constrain2[4][4] = -1; m_constrain2[5][4] = 1
			make/o /n = 6 w_constrain2 = {-x1_2,x2_2,-y1_2, y2_2, -0.001 , cropSize*2}
			//
			FuncFitMD/H="00000"/N /NTHR=1 /G /W =2 /Q gaus2dAllAtOnce W_coefGauss2  imageIn[x1_2, x2_2][y1_2, y2_2] /C={m_constrain2, w_constrain2} 
			//
		elseif( varGWidthToggle == 1 &&  varGcoordToggle != 1 )  // hold center
			//
			make/o /n = ( 2 , 5 ) m_constrain2 = 0; 		m_constrain2[0][4] = -1; m_constrain2[1][4] = 1
			make/o /n = 2 w_constrain2 = {-0.001,cropSize*2}
			//
			FuncFitMD/H="00110"/N /NTHR=1 /G /W =2 /Q gaus2dAllAtOnce W_coefGauss2  imageIn[x1_2, x2_2][y1_2, y2_2] /C={m_constrain2, w_constrain2} 
			//
		elseif( varGWidthToggle != 1 &&  varGcoordToggle == 1 ) // hold width
			//
			make/o /n = ( 4 , 5 ) m_constrain2 = 0; 		m_constrain2[0][2] = -1; m_constrain2[1][2] = 1; m_constrain2[2][3] = -1; m_constrain2[3][3] = 1
			make/o /n = 4 w_constrain2 = {-x1_2,x2_2,-y1_2, y2_2}
			//
			FuncFitMD/H="00001"/N /NTHR=1 /G /W =2 /Q gaus2dAllAtOnce W_coefGauss2  imageIn[x1_2, x2_2][y1_2, y2_2] /C={m_constrain2, w_constrain2} 
			//
		else		// hold center and width
			FuncFitMD/H="00111"/N /NTHR=1 /G /W =2 /Q gaus2dAllAtOnce W_coefGauss2  imageIn[x1_2, x2_2][y1_2, y2_2]
		endif
		duplicate/o W_sigma, W_sigma3
		// if fitt succeeded
		if( W_coefGauss2[ 1 ] != 0 )
			if( intGToggle == 1 )		 // amplitude
				destW[ indexRow ][ indexCol ][ 0 ] = W_coefGauss2[ 1 ]
				destW[ indexRow ][ indexCol ][ 1 ] = W_sigma3[ 1 ]
			elseif( intGToggle == 2 )	// gauss integral
				destW[ indexRow ][ indexCol ][ 0 ] = W_coefGauss2[ 1 ] * abs( W_coefGauss2[ 4 ] ^ 2 )
				destW[ indexRow ][ indexCol ][ 1 ] = W_sigma3[ 1 ]
			endif
			//
			if( varGWidthToggle == 1 )
				widthContainerSignal[ indexRow ][ indexCol ][ 0 ] = W_coefGauss2[ 4 ]
				widthContainerSignal[ indexRow ][ indexCol ][ 1 ] = W_sigma3[ 4 ]
			endif
			//
		else		// if fit failed
			destW[ indexRow ][ indexCol ][ 0 ] = 0
			destW[ indexRow ][ indexCol ][ 1 ] = 0
			//
			if( varGWidthToggle == 1 )
				widthContainerSignal[ indexRow ][ indexCol ][ 0 ] = 0
				widthContainerSignal[ indexRow ][ indexCol ][ 1 ] = 0
			endif
			//
		endif
		//
	elseif( threadIndex == 3 )
		// 	boundaries of roi in x and y directions
		x1_3 = max( 0, round( xCenter - cropSize ) );	x2_3 = min( round( xCenter + cropSize ), dimSize( imageIn, 0 ) - 1 )
		y1_3 = max( 0, round( yCenter - cropSize ) );	y2_3 = min( round( yCenter + cropSize ), dimSIze( imageIn, 1 ) - 1 )
		imagestats/q /m=1 /G={x1_3 ,x2_3, y1_3 ,y2_3 } imageIn
		//	extract statistics of ROI
		W_coefGauss3 = { V_min, imageIn[xCenter][yCenter] - V_min, xCenter, yCenter, width }
		V_fitError = 0
		//
		//	Fitting og 2D circular Gaussian with these constrains
		if( varGWidthToggle == 1 &&  varGcoordToggle == 1 )  // no parameters hold.
			//
			make/o /n = ( 6 , 5 ) m_constrain3 = 0
			m_constrain3[0][2] = -1; 	m_constrain3[1][2] = 1; m_constrain3[2][3] = -1; m_constrain3[3][3] = 1; m_constrain3[4][4] = -1; m_constrain3[5][4] = 1
			make/o /n = 6 w_constrain3 = {-x1_3,x2_3,-y1_3, y2_3, -0.001 , cropSize*2}
			//
			FuncFitMD/H="00000"/N /NTHR=1 /G /W =2 /Q gaus2dAllAtOnce W_coefGauss3  imageIn[x1_3, x2_3][y1_3, y2_3] /C={m_constrain3, w_constrain3} 
			//
		elseif( varGWidthToggle == 1 &&  varGcoordToggle != 1 )  // hold center
			//
			make/o /n = ( 2 , 5 ) m_constrain3 = 0; 		m_constrain3[0][4] = -1; m_constrain3[1][4] = 1
			make/o /n = 2 w_constrain3 = {-0.001,cropSize*2}
			//
			FuncFitMD/H="00110"/N /NTHR=1 /G /W =2 /Q gaus2dAllAtOnce W_coefGauss3  imageIn[x1_3, x2_3][y1_3, y2_3] /C={m_constrain3, w_constrain3} 
			//
		elseif( varGWidthToggle != 1 &&  varGcoordToggle == 1 ) // hold width
			//
			make/o /n = ( 4 , 5 ) m_constrain3 = 0; 		m_constrain3[0][2] = -1; m_constrain3[1][2] = 1; m_constrain3[2][3] = -1; m_constrain3[3][3] = 1
			make/o /n = 4 w_constrain3 = {-x1_3,x2_3,-y1_3, y2_3}
			//
			FuncFitMD/H="00001"/N /NTHR=1 /G /W =2 /Q gaus2dAllAtOnce W_coefGauss3  imageIn[x1_3, x2_3][y1_3, y2_3] /C={m_constrain3, w_constrain3} 
			//
		else		// hold center and width
			FuncFitMD/H="00111"/N /NTHR=1 /G /W =2 /Q gaus2dAllAtOnce W_coefGauss3  imageIn[x1_3, x2_3][y1_3, y2_3]
		endif
		duplicate/o W_sigma, W_sigma4
		// if fitt succeeded
		if( W_coefGauss3[ 1 ] != 0 )
			if( intGToggle == 1 )
				destW[ indexRow ][ indexCol ][ 0 ] = W_coefGauss3[ 1 ]
				destW[ indexRow ][ indexCol ][ 1 ] = W_sigma4[ 1 ]
			elseif( intGToggle == 2 )
				destW[ indexRow ][ indexCol ][ 0 ] = W_coefGauss3[ 1 ] * abs( W_coefGauss3[ 4 ] ^ 2 )
				destW[ indexRow ][ indexCol ][ 1 ] = W_sigma4[ 1 ]
			endif
			//
			if( varGWidthToggle == 1 )
				widthContainerSignal[ indexRow ][ indexCol ][ 0 ] = W_coefGauss3[ 4 ]
				widthContainerSignal[ indexRow ][ indexCol ][ 1 ] = W_sigma4[ 4 ]
			endif
			//
		else		// if fit failed
			destW[ indexRow ][ indexCol ][ 0 ] = 0
			destW[ indexRow ][ indexCol ][ 1 ] = 0
			//
			if( varGWidthToggle == 1 )
				widthContainerSignal[ indexRow ][ indexCol ][ 0 ] = 0
				widthContainerSignal[ indexRow ][ indexCol ][ 1 ] = 0
			endif
			//
		endif
		//
	elseif( threadIndex == 4 )
		// 	boundaries of roi in x and y directions
		x1_4 = max( 0, round( xCenter - cropSize ) );	x2_4 = min( round( xCenter + cropSize ), dimSize( imageIn, 0 ) - 1 )
		y1_4 = max( 0, round( yCenter - cropSize ) );	y2_4 = min( round( yCenter + cropSize ), dimSIze( imageIn, 1 ) - 1 )
		imagestats/q /m=1 /G={x1_4 ,x2_4, y1_4 ,y2_4 } imageIn
		//	extract statistics of ROI
		W_coefGauss4 = { V_min, imageIn[xCenter][yCenter] - V_min, xCenter, yCenter, width}
		V_fitError = 0
		//	Fitting og 2D circular Gaussian with these constrains
		if( varGWidthToggle == 1 &&  varGcoordToggle == 1 )  // no parameters hold.
			//
			make/o /n = ( 6 , 5 ) m_constrain4 = 0
			m_constrain4[0][2] = -1; 	m_constrain4[1][2] = 1; m_constrain4[2][3] = -1; m_constrain4[3][3] = 1; m_constrain4[4][4] = -1; m_constrain4[5][4] = 1
			make/o /n = 6 w_constrain4 = {-x1_4,x2_4,-y1_4, y2_4, -0.001 , cropSize*2}
			//
			FuncFitMD/H="00000"/N /NTHR=1 /G /W =2 /Q gaus2dAllAtOnce W_coefGauss4  imageIn[x1_4, x2_4][y1_4, y2_4] /C={m_constrain4, w_constrain4}
			//
		elseif( varGWidthToggle == 1 &&  varGcoordToggle != 1 )  // hold center
			//
			make/o /n = ( 2 , 5 ) m_constrain4 = 0; 		m_constrain4[0][4] = -1; m_constrain4[1][4] = 1
			make/o /n = 2 w_constrain4 = {-0.001,cropSize*2}
			//
			FuncFitMD/H="00110"/N /NTHR=1 /G /W =2 /Q gaus2dAllAtOnce W_coefGauss4  imageIn[x1_4, x2_4][y1_4, y2_4] /C={m_constrain4, w_constrain4}
			//
		elseif( varGWidthToggle != 1 &&  varGcoordToggle == 1 ) // hold width
			//
			make/o /n = ( 4 , 5 ) m_constrain4 = 0; 		m_constrain4[0][2] = -1; m_constrain4[1][2] = 1; m_constrain4[2][3] = -1; m_constrain4[3][3] = 1
			make/o /n = 4 w_constrain4 = {-x1_4,x2_4,-y1_4, y2_4}
			//
			FuncFitMD/H="00001"/N /NTHR=1 /G /W =2 /Q gaus2dAllAtOnce W_coefGauss4  imageIn[x1_4, x2_4][y1_4, y2_4] /C={m_constrain4, w_constrain4}
			//
		else		// hold center and width
			FuncFitMD/H="00111"/N /NTHR=1 /G /W =2 /Q gaus2dAllAtOnce W_coefGauss4  imageIn[x1_4, x2_4][y1_4, y2_4]
		endif
		duplicate/o W_sigma, W_sigma5
		// if fitt succeeded
		if( W_coefGauss4[ 1 ] != 0 )
			if( intGToggle == 1 )		 // amplitude
				destW[ indexRow ][ indexCol ][ 0 ] = W_coefGauss4[ 1 ]
				destW[ indexRow ][ indexCol ][ 1 ] = W_sigma5[ 1 ]
			elseif( intGToggle == 2 )	// gauss integral
				destW[ indexRow ][ indexCol ][ 0 ] = W_coefGauss4[ 1 ] * abs( W_coefGauss4[ 4 ] ^ 2 )
				destW[ indexRow ][ indexCol ][ 1 ] = W_sigma5[ 1 ]
			endif
			//
			if( varGWidthToggle == 1 )
				widthContainerSignal[ indexRow ][ indexCol ][ 0 ] = W_coefGauss4[ 4 ]
				widthContainerSignal[ indexRow ][ indexCol ][ 1 ] = W_sigma5[ 4 ]
			endif
			//
		else		// if fit failed
			destW[ indexRow ][ indexCol ][ 0 ] = 0
			destW[ indexRow ][ indexCol ][ 1 ] = 0
			//
			if( varGWidthToggle == 1 )
				widthContainerSignal[ indexRow ][ indexCol ][0] = 0
				widthContainerSignal[ indexRow ][ indexCol ][1] = 0
			endif
			//
		endif
		//
	elseif( threadIndex == 5 )
		// 	boundaries of roi in x and y directions
		x1_5 = max( 0, round( xCenter - cropSize ) );	x2_5 = min( round( xCenter + cropSize ), dimSize( imageIn, 0 ) - 1 )
		y1_5 = max( 0, round( yCenter - cropSize ) );	y2_5 = min( round( yCenter + cropSize ), dimSIze( imageIn, 1 ) - 1 )
		imagestats/q /m=1 /G={x1_5 ,x2_5, y1_5 ,y2_5 } imageIn
		//
		W_coefGauss5 = { V_min, imageIn[xCenter][yCenter] - V_min, xCenter, yCenter, width }
		V_fitError = 0
		//
		//	Fitting og 2D circular Gaussian with these constrains
		if( varGWidthToggle == 1 &&  varGcoordToggle == 1 )  // no parameters hod.
			//
			make/o /n = ( 6 , 5 ) m_constrain5 = 0
			m_constrain5[0][2] = -1; 	m_constrain5[1][2] = 1; m_constrain5[2][3] = -1; m_constrain5[3][3] = 1; m_constrain5[4][4] = -1; m_constrain5[5][4] = 1
			make/o /n = 6 w_constrain5 = {-x1_5,x2_5,-y1_5, y2_5, -0.001 , cropSize*2}
			//
			FuncFitMD/H="00000"/N /NTHR=1 /G /W = 2 /Q gaus2dAllAtOnce W_coefGauss5  imageIn[x1_5, x2_5][y1_5, y2_5] /C={m_constrain5, w_constrain5}
			//
		elseif( varGWidthToggle == 1 &&  varGcoordToggle != 1 )  // hold center
			//
			make/o /n = ( 2 , 5 ) m_constrain5 = 0; 		m_constrain5[0][4] = -1; m_constrain5[1][4] = 1
			make/o /n = 2 w_constrain5 = {-0.001,cropSize*2}
			//
			FuncFitMD/H="00110"/N /NTHR=1 /G /W = 2 /Q gaus2dAllAtOnce W_coefGauss5  imageIn[x1_5, x2_5][y1_5, y2_5] /C={m_constrain5, w_constrain5}
			//
		elseif( varGWidthToggle != 1 &&  varGcoordToggle == 1 ) // hold width
			//
			make/o /n = ( 4 , 5 ) m_constrain5 = 0; 		m_constrain5[0][2] = -1; m_constrain5[1][2] = 1; m_constrain5[2][3] = -1; m_constrain5[3][3] = 1
			make/o /n = 4 w_constrain5 = {-x1_5,x2_5,-y1_5, y2_5}
			//
			FuncFitMD/H="00001"/N /NTHR=1 /G /W = 2 /Q gaus2dAllAtOnce W_coefGauss5  imageIn[x1_5, x2_5][y1_5, y2_5] /C={m_constrain5, w_constrain5}
			//
		else		// hold center and width
			FuncFitMD/H="00111"/N /NTHR=1 /G /W = 2 /Q gaus2dAllAtOnce W_coefGauss5  imageIn[x1_5, x2_5][y1_5, y2_5]
		endif
		duplicate/o W_sigma, W_sigma6
		// if fitt succeeded
		if( W_coefGauss5[ 1 ] != 0 )
			if( intGToggle == 1 )		// amplitude
				destW[ indexRow ][ indexCol ][ 0 ] = W_coefGauss5[ 1 ]
				destW[ indexRow ][ indexCol ][ 1 ] = W_sigma6[ 1 ]
			elseif( intGToggle == 2 )	// gauss integral
				destW[ indexRow ][ indexCol ][ 0 ] = W_coefGauss5[ 1 ] * abs( W_coefGauss5[ 4 ] ^ 2 )
				destW[ indexRow ][ indexCol ][ 1 ] = W_sigma6[ 1 ]
			endif
			//
			if( varGWidthToggle == 1 )
				widthContainerSignal[ indexRow ][ indexCol ][ 0 ] = W_coefGauss5[ 4 ]
				widthContainerSignal[ indexRow ][ indexCol ][ 1 ] = W_Sigma6[ 4 ]
			endif
			//
		else		// if fit failed
			destW[ indexRow ][ indexCol ][ 0 ] = 0
			destW[ indexRow ][ indexCol ][ 1 ] = 0
			//
			if( varGWidthToggle == 1 )
				widthContainerSignal[ indexRow ][ indexCol ][ 0 ] = 0
				widthContainerSignal[ indexRow ][ indexCol ][ 1 ] = 0
			endif
			//
		endif
		//
	elseif( threadIndex == 6 )
		// 	boundaries of roi in x and y directions
		x1_6 = max( 0, round( xCenter - cropSize ) );	x2_6 = min( round( xCenter + cropSize ), dimSize( imageIn, 0 ) - 1 )
		y1_6 = max( 0, round( yCenter - cropSize ) );	y2_6 = min( round( yCenter + cropSize ), dimSIze( imageIn, 1 ) - 1 )
		imagestats/q /m=1 /G={x1_6 ,x2_6, y1_6 ,y2_6 } imageIn
		//
		W_coefGauss6 = { V_min, imageIn[xCenter][yCenter] - V_min, xCenter, yCenter, width}
		V_fitError = 0
		//
		//	Fitting og 2D circular Gaussian with these constrains
		if( varGWidthToggle == 1 &&  varGcoordToggle == 1 )  // no parameters hold.
			//
			make/o /n = ( 6 , 5 ) m_constrain6 = 0
			m_constrain6[0][2] = -1; 	m_constrain6[1][2] = 1; m_constrain6[2][3] = -1; m_constrain6[3][3] = 1; m_constrain6[4][4] = -1; m_constrain6[5][4] = 1
			make/o /n = 6 w_constrain6 = {-x1_6,x2_6,-y1_6, y2_6, -0.001 , cropSize*2}
			//
			FuncFitMD/H="00000"/N /NTHR=1 /G /W = 2 /Q gaus2dAllAtOnce W_coefGauss6  imageIn[x1_6, x2_6][y1_6, y2_6] /C={m_constrain6, w_constrain6}
			//
		elseif( varGWidthToggle == 1 &&  varGcoordToggle != 1 )  // hold center
			//
			make/o /n = ( 2 , 5 ) m_constrain6 = 0; 		m_constrain6[0][4] = -1; m_constrain6[1][4] = 1
			make/o /n = 2 w_constrain6 = {-0.001,cropSize*2}
			//
			FuncFitMD/H="00110"/N /NTHR=1 /G /W = 2 /Q gaus2dAllAtOnce W_coefGauss6  imageIn[x1_6, x2_6][y1_6, y2_6] /C={m_constrain6, w_constrain6}
			//
		elseif( varGWidthToggle != 1 &&  varGcoordToggle == 1 ) // hold width
			//
			make/o /n = ( 4 , 5 ) m_constrain6 = 0; 		m_constrain6[0][2] = -1; m_constrain6[1][2] = 1; m_constrain6[2][3] = -1; m_constrain6[3][3] = 1
			make/o /n = 4 w_constrain6 = {-x1_6,x2_6,-y1_6, y2_6}
			//
			FuncFitMD/H="00001"/N /NTHR=1 /G /W = 2 /Q gaus2dAllAtOnce W_coefGauss6  imageIn[x1_6, x2_6][y1_6, y2_6] /C={m_constrain6, w_constrain6}
			//
		else		// hold center and width
			FuncFitMD/H="00111"/N /NTHR=1 /G /W = 2 /Q gaus2dAllAtOnce W_coefGauss6  imageIn[x1_6, x2_6][y1_6, y2_6]
		endif
		duplicate/o W_sigma, W_sigma7
		// if fitt succeeded
		if( W_coefGauss6[ 1 ] != 0 )
			if( intGToggle == 1 )
				destW[ indexRow ][ indexCol ][ 0 ] = W_coefGauss6[ 1 ]
				destW[ indexRow ][ indexCol ][ 1 ] = W_sigma7[ 1 ]
			elseif( intGToggle == 2 )
				destW[ indexRow ][ indexCol ][ 0 ] = W_coefGauss6[ 1 ] * abs( W_coefGauss6[ 4 ] ^ 2 )
				destW[ indexRow ][ indexCol ][ 1 ] = W_sigma7[ 1 ]
			endif
			//
			if( varGWidthToggle == 1 )
				widthContainerSignal[ indexRow ][ indexCol ][ 0 ] = W_coefGauss6[ 4 ]
				widthContainerSignal[ indexRow ][ indexCol ][ 1 ] = W_sigma7[ 4 ]
			endif
			//
		else		// if fit failed
			destW[ indexRow ][ indexCol ][ 0 ]= 0
			destW[ indexRow ][ indexCol ][ 1 ] = 0
			//
			if( varGWidthToggle == 1 )
				widthContainerSignal[ indexRow ][ indexCol ][ 0 ] = 0
				widthContainerSignal[ indexRow ][ indexCol ][ 1 ] = 0
			endif
			//
		endif
		//
	endif
	//
end
// 2D gauss all at once
ThreadSafe function gaus2dAllAtOnce( pw, yw, xw1, xw2 ) : FitFunc
	WAVE pw, yw, xw1, xw2
	//
 	//pw[ 0 ] = z0
 	//pw[ 1 ] = amp
 	//pw[ 2 ] = x0
 	//pw[ 3 ] = y0
  	//pw[ 4 ] = xWidth
  	//
 	yw =  pw[0] + pw[1] * exp(- (( xw1 - pw[2] ) / pw[4] )^2 - (( xw2 - pw[3] ) / pw[4] )^2 )
 	//
 end
// ****    notebook for spot detection and co-localisation function    *******
Function Notes_spotDetect_TA_MT( )
	// loading structure variables
	Struct TA_preferences TAPrefs
	load_preferences_TA_MT( TAPrefs )
	// closing notebook if it exist
	DoWindow logWin
	if(V_flag==1)
		DoWindow/K logWin
	endif
	// making new notebook
	NewNoteBook/F=0/N=logWin
	// writing text on logWIn window
	NoteBook logWin text = "\r\rData treated with TAMT."
	NoteBook logWin text = "\rWritten by Marijonas Tutkus\r@ BioNano, KU and @ Department of Molecular Compound Physics, CPST."
	// data path information
	NoteBook logWin text = "\r\rData path information:"
	pathInfo path1; 	NoteBook logWin text = "\r1st ch. images loaded from:  " + S_path
	pathInfo path2;	NoteBook logWin text = "\r2nd ch. images loaded from: " + S_path
	pathInfo path4;	NoteBook logWin text = "\rResults stored at: " + S_path
	// image analysis information
	NoteBook logWin text = "\r\rImage analysis information: "
	// thresh.
	NoteBook logWin text = "\r\tP. Threshold 1st ch.:  " + num2str( TAPrefs.threshold[ 0 ] )
	NoteBook logWin text = "\r\tP. Threshold 2nd ch.:  " + num2str( TAPrefs.threshold[ 1 ] )
	NoteBook logWin text = "\r\tF. Threshold 1st ch.:  " + num2str( TAPrefs.threshold[ 2 ] )
	NoteBook logWin text = "\r\tF. Threshold 2nd ch.:  " + num2str( TAPrefs.threshold[ 3 ] )
	// min area
	NoteBook logWin text = "\r\tMin area of 2nd ch.: " + num2str( TAPrefs.minArea[ 0 ]) + " [pix.]"
	NoteBook logWin text = "\r\tMin area of 1st ch.: " + num2str( TAPrefs.minArea[ 1 ] )+ " [pix.]"
	//
	NoteBook logWin text = "\r\tMaximal distance of co-localisation: " + num2str( TAPrefs.lenghtLinkParticles ) + " pixels"
	NoteBook logWin text = "\r\tMaximum deviation from Gaussian intensity distribution ch1: " + num2str( TAPrefs.maxDeviation[0] ) + " %"
	NoteBook logWin text = "\r\tMaximum deviation from Gaussian intensity distribution ch2: " + num2str( TAPrefs.maxDeviation[1] ) + " %"
	// bckg removing from images
	if( TAPrefs.bckgSubtrVariables[ 1 ] == 1 )
		NoteBook logWin text = "\r\tRadius of rolling ball for 2nd ch images:\t" + num2str( TAPrefs.bckgSubtrVariables[ 3 ]  ) + " [pix.]"
	else
		NoteBook logWin text = "\r\tBckg subtraction from 2nd ch images:\toff" 
	endif
	if( TAPrefs.bckgSubtrVariables[ 0 ] == 1 )
		NoteBook logWin text = "\r\tRadius of rolling ball for 1st ch images:\t" + num2str( TAPrefs.bckgSubtrVariables[ 2 ]  ) + " [pix.]"
	else
		NoteBook logWin text = "\r\tBckg subtraction from 1st ch images:\toff" 
	endif
	// filtering of images
	// 1st image
	 NoteBook logWin text = "\r\tNumber of 1st channel images, which were accumulated:\t"+num2str( TAPrefs.imageFiltering[ 8 ] )
	 if( TAPrefs.imageFiltering[ 2 ] == 1 )
	  	NoteBook logWin text = "\r\t1st ch images filtering by low - pass filters:\ton, cut-off of low - pass filters:\t"+num2str( TAPrefs.imageFiltering[ 6 ] )
	  else
	  	NoteBook logWin text = "\r\t1st ch. images filtering by low - pass filters:\toff" 
	 endif
	 if( TAPrefs.imageFiltering[ 0 ] == 1 )
	  	NoteBook logWin text = "\r\t1st ch images filtering by Gaussian filters:\ton, size of Gaussian kernel:\t"+num2str( TAPrefs.imageFiltering[ 4 ] ) 
	  else
	NoteBook logWin text = "\r\t1st ch images filtering by Gaussian filters:\toff" 
	 endif
	// protein image
	  NoteBook logWin text = "\r\tNumber of 2nd channel images were accumulated:\t"+num2str( TAPrefs.imageFiltering[ 9 ] )
	 if( TAPrefs.imageFiltering[ 3 ] == 1 )
	  	NoteBook logWin text = "\r\t2nd ch images filtering by low - pass filters:\ton, cut-off of low - pass filters:\t"+num2str( TAPrefs.imageFiltering[ 7 ] ) 
	  else
	  	NoteBook logWin text = "\r\t2nd ch. images filtering by low - pass filters:\toff" 
	 endif
	 if( TAPrefs.imageFiltering[ 1 ] == 1 )
	  	NoteBook logWin text = "\r\t2nd ch. images filtering by Gaussian filters:\ton, size of Gaussian kernel:\t"+num2str( TAPrefs.imageFiltering[ 5 ] )
	  else
	  	NoteBook logWin text = "\r\t2nd ch. images filtering by Gaussian filters:\toff" 
	 endif
	// ROI of particle determination method
	NoteBook logWin text = "\r\tCrop size for 2D Gauss fit:\t" + num2str( TAPrefs.radiusVariables ) 
	// image splitting
	NoteBook logWin text = "\r\rImage splitting"
	if( TAPrefs.imageTypeTA[0] == 1 )
		//
		if( TAPrefs.imageTypeTA[3] == 1 )
			NoteBook logWin text = "\r\t1st channel: dual-view image set-up, orientation: horizontal."
		else
			NoteBook logWin text = "\r\t1st channel: dual-view image set-up, orientation: vertical"
		endif
		if( TAPrefs.imageTypeTA[1] == 1 )
			NoteBook logWin text = "\r\t1st channel: dual-view image set-up, location: top."
		else
			NoteBook logWin text = "\r\t1st channel: dual-view image set-up, location: bottom."
		endif
		//
		if( TAPrefs.imageTypeTA[3] == 1 )
			NoteBook logWin text = "\r\t2nd channel: dual-view image set-up, orientation: horizontal."
		else
			NoteBook logWin text = "\r\t2nd channel: dual-view image set-up, orientation: vertical"
		endif
		if( TAPrefs.imageTypeTA[2] == 1 )
			NoteBook logWin text = "\r\t2nd channel: dual-view image set-up, location: top."
		else
			NoteBook logWin text = "\r\t2nd channel: dual-view image set-up, location: bottom."
		endif
		//
		if( TAPrefs.imageTypeTA[4] == 1 )
			NoteBook logWin text = "\r\tNumber of folders containing image series: one."
		else
			NoteBook logWin text = "\r\tNumber of folders containing image series: two"
		endif
		//
	else
		NoteBook logWin text = "\r\tDual-cam image set-up."
	endif
	// image type
	if( TAPrefs.imageFileType == 1 )
		NoteBook logWin text = "\r\rImage type: TIFF stack."
	elseif( TAPrefs.imageFileType == 2 )
		NoteBook logWin text = "\r\rImage type: signed 32-bit binary."
	elseif( TAPrefs.imageFileType == 3 )
		NoteBook logWin text = "\r\rImage type: TIFF series."
	endif
	// align 2nd ch image
	if(  TAPrefs.regParams[ 0 ] == 1 )
		//
		NoteBook logWin text = "\r\rAligning of 2nd channel image enabled."
		//
		NoteBook logWin text = "\rdx: "+num2str( TAPrefs.regParams[ 1 ] )
		NoteBook logWin text = "\rdy: "+num2str( TAPrefs.regParams[ 2 ] )
		NoteBook logWin text = "\ra11: "+num2str( TAPrefs.regParams[ 3 ] )
		NoteBook logWin text = "\ra12: "+num2str( TAPrefs.regParams[ 4 ] )
		NoteBook logWin text = "\ra21: "+num2str( TAPrefs.regParams[ 5 ] )
		NoteBook logWin text = "\ra22: "+num2str( TAPrefs.regParams[ 6 ] )
		NoteBook logWin text = "\ra33: "+num2str( TAPrefs.regParams[ 7 ] )
		NoteBook logWin text = "\rOrigin X: "+num2str( TAPrefs.regParams[ 8 ] )
		NoteBook logWin text = "\rOrigin Y: "+num2str( TAPrefs.regParams[ 9 ] )
		//
	else
		//
		NoteBook logWin text = "\r\rAligning of 2nd channel image disabled."
		//
	endif
	// saving notebook
	SaveNoteBook/O/P= path4 /S=6 logWin as "LogBook1_spotDetection.txt"
	doWindow/K logWin
	//
end 		// end of notebook function
// ****    notebook function
Function Notes_signalExtraction_TA_MT( )
	// loading structure variables
	Struct TA_preferences TAPrefs
	load_preferences_TA_MT( TAPrefs )
	// closing notebook if it exist
	DoWindow logWin
	if(V_flag==1)
		DoWindow/K logWin
	endif
	// making new notebook
	NewNoteBook/F=0/N=logWin
	// writing text on logWIn window
	NoteBook logWin text = "\r\rData treated with TAMT."
	NoteBook logWin text = "\rWritten by Marijonas Tutkus\r@ BioNano, KU and @ Department of Molecular Compound Physics, CPST."
	// data path information
	NoteBook logWin text = "\r\rData path information:"
	pathInfo path1; 	NoteBook logWin text = "\r1st ch. images loaded from:  " + S_path
	pathInfo path2;	NoteBook logWin text = "\r2nd ch. images loaded from: " + S_path
	pathInfo path4;	NoteBook logWin text = "\rResults stored at: " + S_path
	// ROI of particle determination method
	NoteBook logWin text = "\r\rCrop size for 2D Gauss fit:\t" + num2str( TAPrefs.radiusVariables ) 
	// vary width and center of gauss
	NoteBook logWin text = "\rWidth of Gauss fit was:\t" + stringfromlist( TAPrefs.variableGWidth-1, "variable;not variable;", ";" )
	NoteBook logWin text = "\rCenter position of Gauss fit was:\t" + stringfromlist( TAPrefs.variableGcoord-1, "variable;not variable;", ";" )
	// make traces for these spots
	if( TAPrefs.paricleToggle == 1 )
		NoteBook logWin text = "\rIntensity traces were made for: non co-localized 1st ch spots only"
	elseif( TAPrefs.paricleToggle == 2 )
		NoteBook logWin text = "\rIntensity traces were made for: non-colocalized 2nd. spots only"
	elseif(  TAPrefs.paricleToggle == 3 )
		NoteBook logWin text = "\rIntensity traces were made for: co-localized spots only"
	elseif(  TAPrefs.paricleToggle == 4 )
		NoteBook logWin text = "\rIntensity traces were made for: all detected 1st ch. spots"
	elseif(  TAPrefs.paricleToggle == 5 )
		NoteBook logWin text = "\rIntensity traces were made for: all detected 2nd ch. spots"
	elseif(  TAPrefs.paricleToggle == 6 )
		NoteBook logWin text = "\rIntensity traces were made for: all detected spots."
	endif
	//
	if( TAPrefs.traceInt == 1 )
		NoteBook logWin text = "\rIntensity traces expressed by: Gauss amplitude."
	elseif( TAPrefs.traceInt == 2 )
		NoteBook logWin text = "\rIntensity traces expressed by: Gauss integral."
	endif
	// image splitting
	NoteBook logWin text = "\r\rImage splitting"
	if( TAPrefs.imageTypeTA[0] == 1 )
		//
		if( TAPrefs.imageTypeTA[3] == 1 )
			NoteBook logWin text = "\r\t1st channel: dual-view image set-up, orientation: horizontal."
		else
			NoteBook logWin text = "\r\t1st channel: dual-view image set-up, orientation: vertical"
		endif
		if( TAPrefs.imageTypeTA[1] == 1 )
			NoteBook logWin text = "\r\t1st channel: dual-view image set-up, location: top."
		else
			NoteBook logWin text = "\r\t1st channel: dual-view image set-up, location: bottom."
		endif
		//
		if( TAPrefs.imageTypeTA[3] == 1 )
			NoteBook logWin text = "\r\t2nd channel: dual-view image set-up, orientation: horizontal."
		else
			NoteBook logWin text = "\r\t2nd channel: dual-view image set-up, orientation: vertical"
		endif
		if( TAPrefs.imageTypeTA[2] == 1 )
			NoteBook logWin text = "\r\t2nd channel: dual-view image set-up, location: top."
		else
			NoteBook logWin text = "\r\t2nd channel: dual-view image set-up, location: bottom."
		endif
		//
		if( TAPrefs.imageTypeTA[4] == 1 )
			NoteBook logWin text = "\r\tFolder containing image series: first."
		elseif( TAPrefs.imageTypeTA[4] == 2 )
			NoteBook logWin text = "\r\tFolder containing image series: second"
		else
			NoteBook logWin text = "\r\tFolder containing image series: first and second."
		endif
		//
	else
		NoteBook logWin text = "\r\tDual-cam image set-up."
		//
		if( TAPrefs.imageTypeTA[1] == 1 )
			NoteBook logWin text = "\r\t1st channel: dual-cam image set-up, location: first folder."
		else
			NoteBook logWin text = "\r\t1st channel: dual-cam image set-up, location: second folder."
		endif
		//
		if( TAPrefs.imageTypeTA[2] == 1 )
			NoteBook logWin text = "\r\t2nd channel: dual-cam image set-up, location: first folder."
		else
			NoteBook logWin text = "\r\t2nd channel: dual-cam image set-up, location: second folder."
		endif
		//
		if( TAPrefs.imageTypeTA[4] == 1 )
			NoteBook logWin text = "\r\tFolder containing image series: first."
		elseif( TAPrefs.imageTypeTA[4] == 2 )
			NoteBook logWin text = "\r\tFolder containing image series: second"
		else
			NoteBook logWin text = "\r\tFolder containing image series: first and second."
		endif
		//
	endif
	//
	if( TAPrefs.excType == 1 )
		NoteBook logWin text = "\r\r\tExcitation type: ALEX."
		if( TAPrefs.alex_stLaser == 1 )
			NoteBook logWin text = "\r\tStarting laser: Red."
		else
			NoteBook logWin text = "\r\tStarting laser: Green."
		endif
	else
		NoteBook logWin text = "\r\r\tExcitation type: Single laser."
	endif
	//
	if( TAPrefs.noChToggle == 1 )
		NoteBook logWin text = "\r\tTraces were extracted from 1st ch. images."
	elseif( TAPrefs.noChToggle == 2 )
		NoteBook logWin text = "\r\tTraces were extracted from 2nd ch. images."	
	elseif( TAPrefs.noChToggle == 3 )
		NoteBook logWin text = "\r\tTraces were extracted from both ch. images."	
	endif
	// image type
	if( TAPrefs.imageFileType == 1 )
		NoteBook logWin text = "\r\rImage type: TIFF stack."
	elseif( TAPrefs.imageFileType == 2 )
		NoteBook logWin text = "\r\rImage type: signed 32-bit binary."
	elseif( TAPrefs.imageFileType == 3 )
		NoteBook logWin text = "\r\rImage type: TIFF series."
	endif
	// align 2nd ch image
	if(  TAPrefs.regParams[ 0 ] == 1 )
		//
		NoteBook logWin text = "\r\rAligning of 2nd channel image enabled."
		//
		NoteBook logWin text = "\rdx: "+num2str( TAPrefs.regParams[ 1 ] )
		NoteBook logWin text = "\rdy: "+num2str( TAPrefs.regParams[ 2 ] )
		NoteBook logWin text = "\ra11: "+num2str( TAPrefs.regParams[ 3 ] )
		NoteBook logWin text = "\ra12: "+num2str( TAPrefs.regParams[ 4 ] )
		NoteBook logWin text = "\ra21: "+num2str( TAPrefs.regParams[ 5 ] )
		NoteBook logWin text = "\ra22: "+num2str( TAPrefs.regParams[ 6 ] )
		NoteBook logWin text = "\ra33: "+num2str( TAPrefs.regParams[ 7 ] )
		NoteBook logWin text = "\rOrigin X: "+num2str( TAPrefs.regParams[ 8 ] )
		NoteBook logWin text = "\rOrigin Y: "+num2str( TAPrefs.regParams[ 9 ] )
		//
	else
		//
		NoteBook logWin text = "\r\rAligning of 2nd channel image disabled."
		//
	endif
	// # of image to make traces
	NoteBook logWin text = "\r\r# of images for signal extraction: "+num2str( TAPrefs.numImagesTA )
	// saving notebook
	SaveNoteBook/O/P= path4 /S=6 logWin as "LogBook2_signalExtraction.txt"
	doWindow/K logWin
	//
end 		// end of notebook function