#pragma rtGlobals=3		// Use modern global access method and strict wave access.
#include <FilterDialog> menus=0

function highPassDWT_filter_TA_MT( wInMain, cutOffFreq, outwName, killWavesToggle )
	wave wInMain
	variable cutOffFreq
	variable killWavesToggle
	string outwName
	//
	if( cutOffFreq > 0.5 || cutOffFreq < 0 )
		print "cutOffFreq should be 0 - 0.5."
		abort
	endif
	//
	variable aa
	variable threshVal = sqrt( 2 *mean( wInMain ) * log( dimsize( wInMain, 0 ) ) )
	// Low-pass and high-pass filtering of input wave.
	for( aa = 0 ; aa < dimsize(wInMain,0); aa +=1 )
		if( numtype(wInMain[aa]) != 0 )
			wInMain[aa]=0
		endif
	endFor
	//
	Duplicate/o wInMain, lowPassW, highPassW
	Make/O/D/N=0 coefs;		FilterFIR/DIM=0 /LO={ cutOffFreq, cutOffFreq, 101 } /COEF coefs, lowPassW
	Make/O/D/N=0 coefs;		FilterFIR/DIM=0 /HI={ cutOffFreq, cutOffFreq, 101 } /COEF coefs, highPassW
	// wavelet transformation of the low-pass and the high pass filtered wave
	DWT /P= 2 /T= 2 lowPassW; wave W_DWT; duplicate/o W_DWT, lowPassW_dwt
	DWT /P= 2 /T= 2 highPassW; duplicate/o W_DWT, highPassW_dwt
	// remove values above the threshold.
	for( aa = 0 ; aa < dimsize( highPassW_dwt, 0 ) ; aa += 1 )
		if( abs( highPassW_dwt[ aa ] ) > threshVal )
			if( sign( highPassW_dwt[ aa ] ) > 0 )
				highPassW_dwt[ aa ] = 0 
			else
				highPassW_dwt[ aa ] = 0 
			endif
		endif
	endfor
	// inverse wavelet transformation
	DWT /i /P= 2 /T= 2 lowPassW_dwt; duplicate/o W_DWT, lowPassW_Idwt
	DWT /i /P= 2 /T= 2 highPassW_dwt; duplicate/o W_DWT, highPassW_Idwt	
	// combine the output
	duplicate/o lowPassW_Idwt, outW_filtr
	outW_filtr = lowPassW_Idwt + highPassW_Idwt
	duplicate/o outW_filtr, $outwName
	//
	if( killWavesToggle == 1 )
		killwaves/z lowPassW, highPassW, coefs,  lowPassW_dwt, highPassW_dwt, lowPassW_Idwt, highPassW_Idwt, outW_filtr
		killvariables/z threshVal, aa
	endif
	//
end