#pragma rtGlobals=1		// Use modern global access method.
#pragma ModuleName = tracesAnalyzer2

// *********    defining paths to images series function   ******************
Function IL_TA_MT(ctrlNAme) : buttonControl
	string ctrlNAme
	// loading structure variables and preferences
	Struct TA_preferences TAPrefs
	load_preferences_TA_MT( TAPrefs )
	variable imageTypeTog = TAPrefs.imageFileType  // type of image file
	// defining folder paths
	if( TAPrefs.imageTypeTA[0] == 1 ) // dual-view set-up
		if( TAPrefs.imageTypeTA[4] == 1 )
			// defining folder containing membrane channel images
			print "Define a path containing images"
			NewPath/Q/M="Define a path containing images" /O/Z path1
			if (V_flag!=0)
				abort "Abort, because path has been not defined"
			endif
			//
			pathinfo path1;  	NewPath/o/Q/Z path2, s_path
			//
		else
			// defining folder containing membrane channel images
			print "Define a path containing 1st channel images (?FRET: donor)" 
			NewPath/Q/M="Define a path containing 1st channel images (?FRET: donor)" /O/Z path1
			if (V_flag!=0)
				abort "Abort, because 1st path has been not defined"
			endif
			//
			print "Define a path containing 2nd channel images (?FRET: acceptor)"
			NewPath/Q/M="Define a path containing 2nd channel images (?FRET: acceptor)" /O/Z path2
			if (V_flag!=0)
				abort "Abort, because 2nd path has been not defined"
			endif
			//
		endif
	else 						// dual-cam set-up
		// defining folder containing membrane channel images
		print "Define a path containing 1st channel images (?FRET: donor)"
		NewPath/Q/M="Define a path containing 1st channel images (?FRET: donor)" /O/Z path1
		if (V_flag!=0)
			abort "Abort, because 1st path has been not defined"
		endif
		//
		print "Define a path containing 2nd channel images (?FRET: acceptor)"
		NewPath/Q/M="Define a path containing 2nd channel images (?FRET: acceptor)" /O/Z path2
		if (V_flag!=0)
			abort "Abort, because 2nd path has been not defined"
		endif
		//	
	endif
	// defining excitation profile folder
	print "Define a path containing excitation profile images"
	NewPath/Q/M="Define a path containing excitation profile images" /O/Z path3
	if (V_flag!=0)
		abort "Abort, because path containing excitation profile images hasn't been defined"
	endif
	// defining results storing folder
	print "Define a path for results storing (outside image series directory)"
	NewPath/Q/M="Define a path for results storing (outside image series directory)" /O/Z path4
	if (V_flag!=0)
		abort "Abort, because path for storing results hasn't been defined"
	endif
	// reporting status
	State_GUI_TA_MT("Paths defined for\ranalyse single movie.")
	//
	save_preferences_TA_MT( TAPrefs )
	// kill all  local variables, strings and waves
	killVAriables/a/z;	killStrings/z/a;	killWaves/a/z
	//
end   // end of image loading function
// ************* thresholding  membrane image *************
Function ThM_TA_MT(ctrlNAme): buttonControl
	string ctrlNAme
	// make new windows for images
	dowindow/k ndChannel; dowindow/k stChannel; dowindow/k thresholdChannel; 	doWindow/k tempWind
	make/o/n = ( 1, 1 )  stChImage, ndChImage, thresholdImage
	newimage/k=2 /n = stChannel /s=0 stChImage
	newimage/K=2 /n = ndChannel /s=0 ndChImage
	newimage/K=2 /n = thresholdChannel /s=0 thresholdImage
	// arrange windows
	updateMCH_TAMT(  );		updatePCH_TAMT(  );		updateTrCH_TAMT(  )
	// loading structure
	Struct TA_preferences TAPrefs
	load_preferences_TA_MT( TAPrefs )
	// kill all  locals 
	killVAriables/a/z; killStrings/z/a; killWaves/a/z
	doWindow/k tempWind
	// 	recording values saved in structure preferences into local varaibles
	//	 radius of particle
	variable cropSizeGauss = TAPrefs.radiusVariables		// cropping size for 2D gauss fitting of particle
	//	bg subtraction
	variable flatteningToggle = TAPrefs.bckgSubtrVariables[ 0 ]	// background subbtraction from image by rolling ball algorithm
	variable ballRadius = TAPrefs.bckgSubtrVariables[ 2 ]		// ball radius for rolling ball algrorithm
	// 	fitting to 2D gauss
	variable gaussFitMembrLoc = TAPrefs.particleFitting[ 0 ]	// fitting each identified particle to 2D gaussian toggle
	// 	image filtering
	variable numberOfImagesAccum = TAPrefs.imageFiltering[ 8 ] 
	variable filtering2 = TAPrefs.imageFiltering[ 2 ]	// low pass filtering 
	variable filtering1 = TAPrefs.imageFiltering[ 0 ] 	// gaussian smooting
	variable filteringCuttOff = TAPrefs.imageFiltering[ 6 ]
	variable gaussianSize = TAPrefs.imageFiltering[ 4 ]
	//
	pathinfo path1
	if( V_flag == 0 )
		abort "Define paths!"
	endif
	print "***************************"
	//	list of images names in 1st ch.
	string nameList1UnSort =  indexedFIle ( path1 , -1 , "????" )  // list of 1st channel images names
	nameList1UnSort= RemoveFromList(".DS_Store", nameList1UnSort, ";" )	
	string nameList1 = SortList( nameList1UnSort, ";", 16 )
	// filtering membrane image
	make/o/n = ( 0 , 0 ) stChImage
	filterImage_TA_MT( nameList1, 0, ballRadius, flatteningToggle , numberOfImagesAccum, filtering1, filtering2, filteringCuttOff,  gaussianSize )
	wave stChImageAcc
	// identifying particles in the membrane image
	make/o/n = ( 0 , 9 ) particlePropertiesTable
	make/o /t /n = ( dimSIze( particlePropertiesTable , 1 ) ) labelsWave = {"index","xC","yC","amp","ampErr","xW","xWErr","avgRInt","radius","z0" }
	labeling_TA_MT( particlePropertiesTable , labelsWave , 1 )
	//
	make/o/n = ( 0 , 3 ) coordsBeforeFitting
	SFA_CP_TA_MT( stChImageAcc, particlePropertiesTable, 1 , cropSizeGauss, coordsBeforeFitting, stChImage, gaussFitMembrLoc)
	// recording coordinates into vectors
	make/o/n = ( dimSize( particlePropertiesTable ,  0 ) ) yCenterCoord, xCenterCoord, radiusW
	yCenterCoord[ ] = particlePropertiesTable[ p ][ %yC ]
	xCenterCoord[ ] = particlePropertiesTable[ p ][ %xC ]
	radiusW[] = particlePropertiesTable[ p ][ %xW ]; radiusW = radiusW[p]<1 ? 1 : radiusW[p]	// make radius to be more than 1
	make/o/n = ( dimSIze( coordsBeforeFitting , 0 ) )  xCoords1 , yCoords1, radiusW1
	xCoords1[ ] = coordsBeforeFitting[ p ][ 0 ]
	yCoords1[ ] = coordsBeforeFitting[ p ][ 1 ]
	radiusW1[] = coordsBeforeFitting[ p ][ 2 ]
	// drawing particles identified before gaussian fiting
	SetDrawLayer /W = stChannel /K ProgFront
	SetDrawLayer /W = thresholdChannel /K ProgFront
	//radiusW1 = 2
	DC_TA_MT(xCoords1, yCoords1, 0, 40000, 0, dimSize( yCoords1 , 0 ) , "thresholdChannel", dimSIze( stChImage, 1) , dimSIze(stChImage, 0) , "ProgFront" , 0, radiusW1 )
	DC_TA_MT(xCoords1, yCoords1, 0, 40000, 0, dimSize( yCoords1 , 0 ) , "stChannel", dimSIze( stChImage, 1) , dimSIze(stChImage, 0) , "ProgFront" , 0, radiusW1 )
	// drawing particles identified after gaussian fitting on the screens
	SetDrawLayer /W = stChannel /K userFront
	SetDrawLayer /W = thresholdChannel /K userFront
	//radiusW = 2
	DC_TA_MT(xCenterCoord, yCenterCoord, 50000, 0, 0, dimSize( yCenterCoord , 0 ) , "thresholdChannel", dimSIze( stChImage, 1) , dimSIze(stChImage, 0) , "userFront", 0, radiusW )
	DC_TA_MT(xCenterCoord, yCenterCoord, 50000, 0, 0, dimSize( yCenterCoord , 0 ) , "stChannel", dimSIze( stChImage, 1) , dimSIze(stChImage, 0) , "userFront", 0, radiusW )
	//
	State_GUI_TA_MT("Number of particles in the 1st ch.:\rPutative particles:  "+num2str( dimSize( yCoords1 , 0 ) )+"\rVerified particles:  "+num2str( dimSize( yCenterCoord , 0 ) )  )
	doupdate
	//
	save_preferences_TA_MT( TAPrefs )
	// releasing memory occupied by local waves 
	killVAriables/a/z; killStrings/z/a; killWaves/a/z
end
// ************  thresholding protein image   ***********************
Function ThP_TA_MT(ctrlName):buttonControl
	string ctrlName
	// make new windows for images
	dowindow/k ndChannel; dowindow/k stChannel; 	dowindow/k thresholdChannel; 	doWindow/k tempWind
	make/o/n = ( 1, 1 )  stChImage, ndChImage, thresholdImage
	newimage /k=2 /n = stChannel /s=0 stChImage
	newimage /K=2 /n = ndChannel /s=0 ndChImage
	newimage /K=2 /n = thresholdChannel /s=0 thresholdImage
	// arrange windows
	updateMCH_TAMT(  );		updatePCH_TAMT(  );		updateTrCH_TAMT(  )
	// loading structure 
	Struct TA_preferences TAPrefs
	load_preferences_TA_MT( TAPrefs )
	// kill all  locals 
	killVAriables/a/z; killStrings/z/a; killWaves/a/z
	// giving values stored in structure for local variables
	// radius of particle 
	variable cropSizeGauss =  TAPrefs.radiusVariables
	// bg subtraction
	variable flatteningToggle = TAPrefs.bckgSubtrVariables[ 1 ]						// toggle for bg subtraction from image by rolling ball algorithm
	variable ballRadius = TAPrefs.bckgSubtrVariables[ 3 ]							// ball radius for rolling ball algrorithm
	// 2D gauss fitting
	variable gaussFitProtLoc = TAPrefs.particleFitting[ 1 ]							// fitting each identified particle to 2D gaussian toggle
	// image filtering
	variable numberOfImagesAccum = TAPrefs.imageFiltering[ 9 ]
	variable filtering2 = TAPrefs.imageFiltering[ 3 ]	// low pass filtering 
	variable filtering1 = TAPrefs.imageFiltering[ 1 ] 	// gaussian smooting
	variable filteringCuttOff = TAPrefs.imageFiltering[ 7 ]
	variable gaussianSize = TAPrefs.imageFiltering[ 5 ]
	// list of image names
	pathinfo path2
	if( V_flag == 0 )
		abort "Define paths!"
	endif
	//
	print "***************************"
	string nameList1UnSort =  indexedFile ( path2 , -1 , "????" )  	// list of 2nd ch images names
	nameList1UnSort= RemoveFromList(".DS_Store", nameList1UnSort, ";" )	
	string nameList1 = SortList( nameList1UnSort, ";", 16 )
	// filtering protein channel image
	make/o/n = ( 0 , 0 )  ndChImage
	filterImage_TA_MT( nameList1, 1, ballRadius , flatteningToggle , numberOfImagesAccum, filtering1, filtering2, filteringCuttOff,  gaussianSize )
	wave ndChImageAcc
	// identifying particles in the protein image
	make/o/n = ( 0 , 9 ) particlePropertiesTable
	make/o /t /n = ( dimSIze( particlePropertiesTable , 1 ) ) labelsWave = {"index","xC","yC","amp","ampErr","xW","xWErr","avgRInt","radius","z0" }
	labeling_TA_MT( particlePropertiesTable , labelsWave , 1 )
	//
	make/o/n = ( 0 , 3 ) coordsBeforeFitting
	SFA_CP_TA_MT( ndChImageAcc, particlePropertiesTable, 2, cropSizeGauss, coordsBeforeFitting, ndChImage, gaussFitProtLoc )
	// recording coordinates from matrixes into vectors
	make/o/n = ( dimSize( particlePropertiesTable ,  0 ) ) yCenterCoord, xCenterCoord , radiusW
	yCenterCoord[ ] = particlePropertiesTable[ p ][ %yC ]
	xCenterCoord[ ] = particlePropertiesTable[ p ][ %xC ]
	radiusW[ ] = particlePropertiesTable[ p ][ %xW ]; radiusW = radiusW[p]<1 ? 1 : radiusW[p]
	make/o/n = ( dimSIze( coordsBeforeFitting , 0 ) )  xCoords1 , yCoords1, radiusW1
	xCoords1[ ] = coordsBeforeFitting[ p ][ 0 ]
	yCoords1[ ] = coordsBeforeFitting[ p ][ 1 ]
	radiusW1[ ] = coordsBeforeFitting[ p ][ 2 ]
	// drawing particles indentified before fitting of 2d gaussian to each particle
	SetDrawLayer /W = ndChannel /K ProgFront
	SetDrawLayer /W = thresholdChannel /K ProgFront
	//
	DC_TA_MT(xCoords1, yCoords1, 0, 40000, 0, dimSize(yCoords1,0) , "thresholdChannel", dimSIze(ndChImage,1) , dimSIze(ndChImage,0) , "ProgFront", 0 , radiusW1 )
	DC_TA_MT(xCoords1, yCoords1, 0, 40000, 0, dimSize(yCoords1,0) , "ndChannel", dimSIze(ndChImage,1) , dimSIze(ndChImage,0) , "ProgFront", 0 , radiusW1 )
	// drawing particles identified after gaussian fitting on the screen
	SetDrawLayer /W = ndChannel/K userFront
	SetDrawLayer /W = thresholdChannel/K userFront
	//
	DC_TA_MT(xCenterCoord, yCenterCoord, 50000, 0, 0, dimSize(yCenterCoord,0) , "thresholdChannel", dimSIze(ndChImage,1) , dimSIze(ndChImage,0) , "userFront", 0, radiusW )
	DC_TA_MT(xCenterCoord, yCenterCoord, 50000, 0, 0, dimSize(yCenterCoord,0) , "ndChannel", dimSIze(ndChImage,1) , dimSIze(ndChImage,0) , "userFront", 0, radiusW )
	//
	State_GUI_TA_MT("Number of particles in 2nd ch.:\rPutative particles:  "+num2str( dimSize( yCoords1 , 0 ) )+"\rVerified particles:  "+num2str( dimSize( yCenterCoord , 0 ) )  )
	doupdate
	save_preferences_TA_MT( TAPrefs )
	// releasing memory occupied by local waves 
	killVAriables/a/z; killStrings/z/a; killWaves/a/z
	//
end
//************* image filtering function  **************
function filterImage_TA_MT( nameString, channelNum, minSize , flatteningToggle,  numberOfImagesAccum, filtering1, filtering2, filteringCuttOff,  gaussianSize )
	// input 
	string nameString
	variable channelNum, minSize, flatteningToggle, numberOfImagesAccum , filtering1 , filtering2 , filteringCuttOff , gaussianSize
	//
	Struct TA_preferences TAPrefs
	load_preferences_TA_MT( TAPrefs )
	variable imageTypeTog = TAPrefs.imageFileType 		// 1 - TIFF stack, 2 - signed 32-bit, 3 - TIFF series.
	variable numImages = TAPrefs.numImagesTA			// number of image to be loaded for signals extraction.
	// local variables
	variable round1
	// referencing waves
	wave stChImage, ndChImage
	// identifying number of images in the images names string
	if( numImages < numberOfImagesAccum )
		numberOfImagesAccum =  numImages
	endif	
	//	
	make/o/d/n= ( 0, 0 ) tempImageLoc
	// accumulation of defined number of images into one image "tempImageLoc"
	for( round1 = 0 ; round1 <  numberOfImagesAccum ; round1 += 1 )
		//
		if(channelNum==0) 	// 1st channel
			//
			Wave/z localImage = $StringFromList( 0, loadImage_TA_MT( nameString, round1, 1, imageTypeTog , 0 ),";")
			//
		elseif(channelNum==1)	// 2nd channel
			//
			Wave/z localImage = $StringFromList(0,  loadImage_TA_MT( nameString, round1, 2, imageTypeTog , 0 ),";")	
			//
		endif
		//
		if( round1 <= 0 )
			redimension/n=( dimsize( localImage , 0 ) , dimSize( localImage , 1 ) ) tempImageLoc
		endif
		//
		tempImageLoc[ ][ ] += localImage[ p ][ q ]
		//
		killwaves/z localImage
		//
	endFor
	//
	print "Number of images accumulated:  "+num2str( numberOfImagesAccum )
	// normalizing image to the numbe rof accumulations
	tempImageLoc /= numberOfImagesAccum	
	//
	if(channelNum == 0)
		//
		print "1st channel image"
		cropIm_dualVDualC_ta_mt( tempImageLoc, TAPrefs.imageTypeTA[0], TAPrefs.imageTypeTA[1], TAPrefs.imageTypeTA[3], "croppedInW" ); wave/z croppedInW
		//
	elseif(channelNum == 1)
		//
		print "2nd channel image"
		cropIm_dualVDualC_ta_mt( tempImageLoc, TAPrefs.imageTypeTA[0], TAPrefs.imageTypeTA[2], TAPrefs.imageTypeTA[3], "croppedInW" ); wave/z croppedInW
		//
	endif
	//
	// renaming image
	if(channelNum == 0)
		// renaming 1st ch image
		duplicate/o croppedInW, stChImageAcc
		//
	elseif(channelNum == 1)
		// align image
		if( TAPrefs.regParams[ 0 ]  == 1 )
			//
			make/o /d /n = ( 22 ) parmW = 0
			parmW[0] = TAPrefs.regParams[ 1 ] // dx
			parmW[1] = TAPrefs.regParams[ 2 ] // dy
			parmW[3] = TAPrefs.regParams[ 3 ] // a11
			parmW[4] = TAPrefs.regParams[ 4 ] // a12
			parmW[6] = TAPrefs.regParams[ 5 ] //a21
			parmW[7] = TAPrefs.regParams[ 6 ] //a22
			parmW[11] = TAPrefs.regParams[ 7 ] //a33
			parmW[17] = TAPrefs.regParams[ 8 ] // originX
			parmW[18] = TAPrefs.regParams[ 9 ] // originY
			//
			print "Aligning of 2nd channel image enabled"
			print "with params: "+num2str(parmW[0])+num2str(parmW[1])+num2str(parmW[3])+num2str(parmW[4])+num2str(parmW[6])+num2str(parmW[7])+num2str(parmW[11])+num2str(parmW[17])+num2str(parmW[18])
			//
			alignImage2_paramsGiven_TA_MT( croppedInW, parmW ); duplicate/o M_RegOut, ndChImageAcc
			//
		else
			//renaming 2nd ch image
			duplicate/o croppedInW, ndChImageAcc
			//
		endif
	endif
	// removing background
	if( flatteningToggle == 1 )
		subtractBackround( croppedInW, minSize )
		print "Background was subtracted, ballsize:  "+num2str( minSize )
	endif
	// Gaussian filtering
	if(filtering1 == 1 )
		matrixFilter/N=( gaussianSize ) /O gauss croppedInW
		print "Image fltered by convolving it with Gaussian Kernel of size (pix.):  "+num2str( gaussianSize )
	endif
	// low pass filtering
	if(filtering2 == 1)
		//
		wave/z imageFilt1 = croppedInW
		wave/z imageFilt2 = croppedInW
		//
		FilterFIR/DIM=1/lo={filteringCuttOff, filteringCuttOff + 0.01 , 50 }/E=1 imageFilt1	// filters rows 
		FilterFIR/DIM=0/lo={filteringCuttOff, filteringCuttOff + 0.01 , 50 }/E=1 imageFilt2	// filters columns
 		print "Image fltered by hi-pass filters of cutt-off Nyquist frequency:  "+num2str( filteringCuttOff )
 		//
 		croppedInW[ ][ ] = ( imageFilt1[p][q] + imageFilt2[p][q] ) / 2		// make average image from filtered rows iomage and filtered columns image
		//
	endif
	// renaming image
	if(channelNum == 0)
		// renaming 1st ch image
		duplicate/o croppedInW, stChImage
		//
	elseif(channelNum == 1)
		// align image
		if( TAPrefs.regParams[ 0 ]  == 1 )
			//
			make/o /d /n = ( 22 ) parmW = 0
			parmW[0] = TAPrefs.regParams[ 1 ] // dx
			parmW[1] = TAPrefs.regParams[ 2 ] // dy
			parmW[3] = TAPrefs.regParams[ 3 ] // a11
			parmW[4] = TAPrefs.regParams[ 4 ] // a12
			parmW[6] = TAPrefs.regParams[ 5 ] //a21
			parmW[7] = TAPrefs.regParams[ 6 ] //a22
			parmW[11] = TAPrefs.regParams[ 7 ] //a33
			parmW[17] = TAPrefs.regParams[ 8 ] // originX
			parmW[18] = TAPrefs.regParams[ 9 ] // originY
			//
			print "Aligning of 2nd channel image enabled"
			print "with params: "+num2str(parmW[0])+num2str(parmW[1])+num2str(parmW[3])+num2str(parmW[4])+num2str(parmW[6])+num2str(parmW[7])+num2str(parmW[11])+num2str(parmW[17])+num2str(parmW[18])
			//
			alignImage2_paramsGiven_TA_MT( croppedInW, parmW );  duplicate/o M_RegOut, ndChImage
			//
		else
			//renaming 2nd ch image
			duplicate/o croppedInW, ndChImage
			//
		endif
	endif
	// releasing memory occupied by local variables
	killWaves/z tempImageLoc, localImage, imageFilt1,imageFilt2
	killVAriables/z round1
	//
end  // end of image filtering function
// *******
Function alignImage2_paramsGiven_TA_MT( imW, parmW )
	wave imW
	wave parmW
	//
	redimension /s imW, imW
	ImageRegistration /USER= parmW /MSKC=2 /REFM=0 /TSTM=0 /ASTP=3 /STRT=20 /INTR=2 /FLVL=2 /TRNS={1,1,0} /MING=0 /SKEW={1,1,0} /CONV=1 /ROT={0,0,0} /Q  testWave = imW, refWave = imW
	wave M_RegOut
	//	
end
//**********
// giving names for a columns or rows of the input wave
function labeling_TA_MT( inputWave , labelsWaveInput , dimension )
	// defining input waves
	wave inputWave		// wave which colums or rows should be labeled
	wave/t labelsWaveInput 	// wave containg labels
	// defining input variables
	variable dimension
	// defining local variables
	variable aa   // counter
	string labelString = ""
	// labeling
	for( aa = 0 ; aa  < dimSIze( inputWave , dimension ) ; aa += 1 )
		labelString = labelsWaveInput[ aa ]
		SetDimLabel dimension , aa , $labelString , inputWave
	endFor
	// releasing memory occupied by local variables
	killVariables/z aa
	killStrings/z labelString
end		// end of labeling function


function load32BitImage_MT( size, imageIndex, numByteToSkip, pathIndex, nameString, indexNameString )
	variable size				// size of image in x and y dims.
	variable imageIndex		// which image from the array to load
	variable numByteToSkip	// number of bytes to skip from the biggining
	variable pathIndex			// pathIndex indicating is it path1, path2 or path3 images should be load from.
	string nameString			// string contating list of image files in the path
	variable indexNameString	// which image from the nameString to load.
	// load a wave
	if( pathIndex == 1 )	// 1st channel path
		GBLoadWave/O /B /N = imWIn /T={32,4} /S= ( numByteToSkip  + abs( imageIndex * abs( size ^ 2 ) * 4  ) ) /W = 1 /U = ( abs( size ^ 2 ) ) /P = path1 /Q stringFromList( indexNameString , nameString , ";" )
	elseif( pathIndex == 2 )
		GBLoadWave/O /B /N = imWIn /T={32,4} /S= ( numByteToSkip + abs(  imageIndex * abs( size ^ 2 ) * 4  ) ) /W = 1 /U = ( abs( size ^ 2 ) ) /P = path2 /Q stringFromList( indexNameString , nameString , ";" )
	elseif( pathIndex == 3 )
		GBLoadWave/O /B /N = imWIn /T={32,4} /S= ( numByteToSkip + abs(  imageIndex * abs( size ^ 2 ) * 4  ) ) /W = 1 /U = ( abs( size ^ 2 ) ) /P = path3 /Q stringFromList( indexNameString , nameString , ";" )
	elseif( pathIndex == 4 )
		GBLoadWave/O /B /N = imWIn /T={32,4} /S= ( numByteToSkip + abs(  imageIndex * abs( size ^ 2 ) * 4  ) ) /W = 1 /U = ( abs( size ^ 2 ) ) /P = path4 /Q stringFromList( indexNameString , nameString , ";" )
	endif
	//
end


function/S loadImage_TA_MT( namesStr, index, channelIndex, imageTypeTog, loadFullStackTog )
	string namesStr // image file name in the folder.
	variable index
	variable channelIndex
	variable imageTypeTog
	variable loadFullStackTog
	//
	string outString = ""
	//
	if( channelIndex == 1 ) 		// 1st channel
		//
		if( imageTypeTog == 1 )		// TIFF stack
			//
			if( itemsinlist( StringFromList( 0 , namesStr, ";") ) <= 0 )
				abort
			endif
			//
			ImageLoad /s = ( index ) / c = 1 /O /T = tiff /n = imWIn /Q /P=path1 StringFromList( 0 , namesStr, ";")
			//
		elseif( imageTypeTog == 2 )		// signed 32-bit image file
			//
			load32BitImage_MT( 512, index , 8, 1, namesStr, 0 )
			//
		elseif( imageTypeTog == 3 )		// TIFF image series
			//
			if( itemsinlist( StringFromList( index , namesStr, ";") ) <= 0 )
				abort
			endif
			//
			ImageLoad /o /T = tiff /Q /n = imWIn /P=path1 StringFromList( index , namesStr, ";")
			//
		endif
	elseif( channelIndex == 2 )	// 2nd channel
		//
		if( imageTypeTog == 1 )		// TIFF stack
			//
			if( itemsinlist( StringFromList( 0 , namesStr, ";") ) <= 0 )
				abort
			endif
			//
			ImageLoad/LR3D /s = ( index ) / c = 1 /O /T = tiff /n = imWIn /Q /P=path2 StringFromList( 0 , namesStr, ";")
			//
		elseif( imageTypeTog == 2 )		// signed 32-bit image file
			//
			load32BitImage_MT( 512, index , 8, 2, namesStr, 0 )
			//
		elseif( imageTypeTog == 3 )		// TIFF image series
			//
			if( itemsinlist( StringFromList( index , namesStr, ";") ) <= 0 )
				abort
			endif
			//
			ImageLoad /o /T = tiff /Q /n= imWIn /P=path2 StringFromList( index , namesStr, ";")
			//
		endif
	endif
	//
	if( index > 0 )
		killwaves/z $"imWIn"+num2str(index-1)
	endif
	//
	outString = S_waveNames
	//
	return outString
	//
end