#pragma rtGlobals=1		// Use modern global access method.


function ROI_TA_MT()

	DoWindow/F WMImageROIPanel
	if( V_Flag==1 )
		return 0
	endif

	String igName= "ndChannel"
	if( strlen(igName) == 0 )
		DoAlert 0,"No image plot found"
		return 0
	endif

	NewPanel /K=1 /W=(563,327,744,434) as "Define ROI"
	DoWindow/C WMImageROIPanel
	AutoPositionWindow/E/M=1/R=$igName
	ModifyPanel fixedSize=1
	
	Button StartROI,pos={14,9},size={150,20},proc=ROI2_TA_MT,title="Start ROI Draw"
	Button StartROI,help={"Adds drawing tools to top image graph. Use rectangle, circle or polygon."}
	Button clearROI,pos={14,35},size={150,20},proc=ROI2_TA_MT,title="Erase ROI"
	Button clearROI,help={"Erases previous ROI. Not undoable."}
	Button FinishROI,pos={14,65},size={150,20},proc=ROI2_TA_MT,title="Finish ROI"
	Button FinishROI,help={"Click after you are finished editing the ROI"}

end



//////// opens drawing procedure  //////////////

Function ROI2_TA_MT(ctrlName)
	String ctrlName

	String ImGrfName= "ndChannel"
	if( strlen(ImGrfName) == 0 )
		return 0
	endif
	
	DoWindow/F $ImGrfName
	if( CmpStr(ctrlName,"StartROI") == 0 )
		ShowTools/A rect
		SetDrawLayer ProgFront
		Wave w= $WMGetImageWave(ImGrfName)		// the target matrix
		String iminfo= ImageInfo(ImGrfName, NameOfWave(w), 0)
		String xax= StringByKey("XAXIS",iminfo)
		String yax= StringByKey("YAXIS",iminfo)
		SetDrawEnv linefgc= (3,52428,1),fillpat= 0,xcoord=$xax,ycoord=$yax,save
	endif
	if( CmpStr(ctrlName,"FinishROI") == 0 )
		
		
		String topWave=WMGetImageWave( "ndChannel")
		WAVE/Z ww=$topWave
		if(WaveExists(ww)==0)
			return 0
		endif
		
		ImageGenerateROIMask/e=1/I=0 ndChImage
		wave M_ROIMask
		duplicate/o M_ROIMask, maskROITemp
		
		GraphNormal
		HideTools/A
		SetDrawLayer UserFront
		DoWindow/F WMImageROIPanel
		dowindow/k WMImageROIPanel
	endif
	if( CmpStr(ctrlName,"clearROI") == 0 )
		GraphNormal
		SetDrawLayer/K ProgFront
		SetDrawLayer UserFront
		DoWindow/F WMImageROIPanel
	endif
End