#pragma rtGlobals=1		// Use modern global access method.
//*************  single frame analysis funcion ************
Function SFA_CP_TA_MT( arbitraryImage , outputWave , imageIndicator, coefRadius , coordsBeforeFitting,  flatenedImage, gaussFittingTogle )
	// defining input waves
	Wave arbitraryImage, outputWave , coordsBeforeFitting, flatenedImage
	// defining input varaibles
	variable imageIndicator		// which image shold be analyzed (1 - ch1, 2- ch2)
	variable coefRadius 		// coeficient for auto size radius o particle
	variable gaussFittingTogle
	// defining structure variables
	Struct TA_preferences TAPrefs
	load_preferences_TA_MT( TAPrefs )
	variable thresholdStCh = TAPrefs.threshold[ 0 ]
	variable thresholdStCh2 = TAPrefs.threshold[ 2 ]
	variable thresholdNdCh = TAPrefs.threshold[ 1 ]
	variable thresholdNdCh2 = TAPrefs.threshold[ 3 ]
	variable minAreaStCh = TAPrefs.minArea[ 0 ]
	variable minAreaNdCh = TAPrefs.minArea[ 1 ]
	variable cropSize = TAPrefs.radiusVariables			// size of crop for fitting
	//
	if( imageIndicator == 1 )
		print TAPrefs.maxDeviation[0], ": maximal deviation for Gaussian fit ch1."
	else
		print TAPrefs.maxDeviation[1], ": maximal deviation for Gaussian fit ch2."
	endif
	//
	print cropSize, ":crop size for Gaussian fit."
	//
	if( imageIndicator <= 1  ) //1st channel
		print thresholdStCh, ": prob. threshold for ch1, "+num2str(thresholdStCh2)+": filt. threshold."
		print minAreaStCh, ": min area for ch1"
	elseif( imageIndicator > 1 ) // 2nd channel
		print thresholdNdCh, ": prob. threshold for ch2, "+num2str(thresholdNdCh2)+": filt. threshold."
		print minAreaNdCh, ": min area for ch2"
	endif
	// defining local variables
	variable numberOfParticlesAccepted = 0 , jj = 0, startCoord = 0 , endCoord = 0 , kk = 0 
	// thresholding image and identifying particles
	if(imageIndicator <= 1 ) 	// 1st channel image
		//
		Hi_calculation( minAreaStCh, 2 , flatenedImage, "thresholdImage" )
		wave thresholdImage
		//
		particleProb_image( thresholdImage, thresholdStCh2, "thresholdImage" )
		wave thresholdImage
		//
		redimension/b/u thresholdImage
		duplicate/o thresholdImage, stChImage
		//
		partProb2_image( minAreaStCh, thresholdImage, "thresholdImage1" , thresholdStCh )
		wave thresholdImage1, pProbImage
		//
		duplicate/o pProbImage, thresholdImage
		redimension/b/u thresholdImage1
		//
		ImageAnalyzeParticles/m=3 /Q /EBPC /A=( minAreaStCh - 1 )/E stats thresholdImage1
		//
		Wave W_imageObjArea, W_circularity, M_moments	 // waves coming from ImageAnalyzeParticles
		make/o/n = ( dimSize( M_moments, 0 ) ) xCenterCoord  = M_moments[ p ][ 0 ]
		make/o/n = ( dimSize( M_moments, 0 ) ) yCenterCoord  = M_moments[ p ][ 1 ]
		make/o/n = ( dimSize( M_moments, 0 ) ) radiusOfParticle = max( M_moments[ p ][ 2 ] , M_moments[ p ][ 3 ] ) * 0.5	// half of major axis of ellipse
		duplicate/o W_imageObjArea , areaOfParticleWave		// area of ellipse
		duplicate/o W_circularity , circularityOfParticle			// circularity of ellipse
		//
	elseif(imageIndicator > 1)	// 2nd channel image
		//
		Hi_calculation( minAreaNdCh, 2, flatenedImage, "thresholdImage" )
		wave thresholdImage
		//
		particleProb_image( thresholdImage, thresholdNdCh2, "thresholdImage" )
		wave  thresholdImage
		//
		redimension/b/u thresholdImage
		duplicate/o thresholdImage, ndChImage
		//
		partProb2_image( minAreaNdCh, thresholdImage, "thresholdImage1",  thresholdNdCh )
		wave thresholdImage1, pProbImage
		//
		duplicate/o pProbImage, thresholdImage
		redimension/b/u thresholdImage1
		//
		ImageAnalyzeParticles/m=3 /Q /EBPC /A=( minAreaNdCh - 1 )/E stats thresholdImage1
		//
		Wave W_imageObjArea, W_circularity, M_moments	 // waves coming from ImageAnalyzeParticles
		make/o/n = ( dimSize( M_moments, 0 ) ) xCenterCoord  = M_moments[ p ][ 0 ]
		make/o/n = ( dimSize( M_moments, 0 ) ) yCenterCoord  = M_moments[ p ][ 1 ]
		make/o/n = ( dimSize( M_moments, 0 ) ) radiusOfParticle = max( M_moments[ p ][ 2 ] , M_moments[ p ][ 3 ] ) * 0.5	// half of major axis of ellipse
		duplicate/o W_imageObjArea , areaOfParticleWave		// area of ellipse
		duplicate/o W_circularity , circularityOfParticle			// circularity of ellipse
		//
	endif
	//
	if(dimsize(xCenterCoord,0) <= 0 )
		//
		print " no spots were detected!"
		//
	else
		// recording coordinates of before fitting identified particles
		insertPoints/m = 0 0 , dimSize( yCenterCoord , 0 ) , coordsBeforeFitting 
		coordsBeforeFitting[ ][ 0 ] = xCenterCoord[ p ]
		coordsBeforeFitting[ ][ 1 ] = yCenterCoord[ p ]
		coordsBeforeFitting[ ][ 2 ] = radiusOfParticle[ p ]
		print "# of detected particles in image CPAT function: "+num2str( dimSize( xCenterCoord , 0 ) )
		// analysing particle by particle
		make/o /n = 4 fittingErrorWave = 0
		numberOfParticlesAccepted = 0
		//
		if( gaussFittingTogle == 0 )
			print "Particles will not be fitted to 2D gaussian"
		else
			print "Particles will be fitted to 2D gaussian"
		endif
		//
		for( jj = 0 ; jj < DimSize( xCenterCoord , 0 )  ; jj += 1 )
			// making empty wave which will be fillted in the following function
			make/d /o /n = 9 outputWave2
			//
			SParticle_TA_MT( arbitraryImage , xCenterCoord[ jj ] , yCenterCoord[ jj ], outputWave2 , radiusOfParticle[ jj ] , gaussFittingTogle, fittingErrorWave, imageIndicator )
			//
			if( outputWave2[ 8 ] < 1 )
				//
				insertPoints/m=0 numberOfParticlesAccepted , 1 , outputWave
				// particle properties
				outputWave[ numberOfParticlesAccepted ][ %index ] = numberOfParticlesAccepted		// index of a particle
				outputWave[ numberOfParticlesAccepted ][ %xC ] = outputWave2[ 3 ]					// x center coord of a particle
				outputWave[ numberOfParticlesAccepted ][ %yC ] = outputWave2[ 4 ]					// y center coord of a particle
				outputWave[ numberOfParticlesAccepted ][ %amp ] = outputWave2[ 1 ]				// amplitude of a particle from gaussian fit
				outputWave[ numberOfParticlesAccepted ][ %ampErr ] = outputWave2[ 2 ]				// amplitude error
				outputWave[ numberOfParticlesAccepted ][ %xW ] = outputWave2[ 5 ]				// x width of a gaussian fitted to a particle
				outputWave[ numberOfParticlesAccepted ][ %xWErr ] = outputWave2[ 6 ]				// x width error of a gaussian fitted to a particle	 
				outputWave[ numberOfParticlesAccepted ][ %avgRInt ] = outputWave2[ 0 ]				// intensity of a particle by ROI average
				outputWave[ numberOfParticlesAccepted ][ %z0 ] = outputWave2[ 7 ]					// baseline of Gaussian fit
				// updating number of identified particles
				numberOfParticlesAccepted+=1
			endIf
			//
		endfor
		// remove spots which are closer than the crop distance.
		jj = 0
		do	
			kk = jj + 1
			startCoord = 0
			// calculate distances between spot jj and all kk
			do
				//
				endCoord = abs( outputWave[ jj ][ %xC ] - outputWave[ kk ][ %xC ] ) + abs( outputWave[ jj ][ %yC ] - outputWave[ kk ][ %yC ] )
				// if distance is lower than the cropsize delete that point represented by kk, else update the kk counter. cal
				if( endCoord <= cropSize && jj != kk )
					deletepoints/m=0 kk, 1, outputWave
					startCoord = 1
				else
					kk += 1
				endif
				// check if kk reached the last spot in the table
				if( kk >= dimsize( outputWave, 0 ) )
					// if any of kk spots were deleted then also delete the jj spot.
					if( startCoord == 1 )
						deletepoints/m=0 jj, 1, outputWave
					else
						jj += 1
					endif
					//
					break
					//
				endif
				//
			while( 1 )
			//
			if( jj  >= dimsize( outputWave, 0 ) )
				break
			endif
			//
		while( 1 )
		//
		print "Number of  identified paticles after 2D Gaussian fitting: "+num2str( dimSize( outputWave , 0 ) )
		print num2str(fittingErrorWave[ 0 ])+"  particles rejected, because of fitting failure."
		print num2str(fittingErrorWave[ 1 ])+"  particles rejected, because Gaussian has too high error."
		print num2str(fittingErrorWave[ 2 ])+"  particles rejected, because Gaussian width exceeds boundaries."
		print num2str( startCoord )+"  particles rejected, because they were overlapping."
		//	
	endif
	//
end
//*******   single particle analysis function    *************
function SParticle_TA_MT( inputImage, xCoordInput, yCoordInput, inputWave, radiusInput, gaussianFitting, fittingErrorWave, channelToggle )
	// defining input variables and waves
	wave inputImage    // image with particles
	wave inputWave 	 // wave from results storing
	wave fittingErrorWave
	variable xCoordInput , yCoordInput   // coords of a particle of interest in the image
	variable radiusInput   // radius of a particle
	variable gaussianFitting // toggle of particle fitting with 2D gaussian , if gaussianFitting = 1 -> on ; if gaussianFitting = 2 -> off
	variable channelToggle
	// defining global variables
	Struct TA_preferences TAPrefs
	load_preferences_TA_MT( TAPrefs )
	variable maxDeviation
	if( channelToggle == 1 )
		maxDeviation = TAPrefs.maxDeviation[0]   // maximal allowed dev of particle fitt ch1
	else
		maxDeviation = TAPrefs.maxDeviation[1]   // maximal allowed dev of particle fitt	 ch2
	endif
	//
	variable cropSize = TAPrefs.radiusVariables	// size of crop for fitting
	// defining local variables
	variable xStart , xEnd , yStart , yEnd  // corner coordinates of ROI square
	variable/G V_fitError = 0 			 // fit error from fitting fucntion
	variable errorFit1, errorFit2			 // fit error calculated manualy from fitting parameter errors.
	//  ROI coordinates		
	xStart = max( 0, round( xCoordInput - cropSize ) )
	xEnd = min( dimsize( inputImage, 0 ) - 1 ,  round( xCoordInput + cropSize ) )
	//
	yStart = max( 0, round( yCoordInput - cropSize ) )
	yEnd = min( dimsize( inputImage, 1 ) - 1 ,  round( yCoordInput + cropSize ) )
	// check radius
	if( radiusInput < 1 )
		radiusInput = 1
	endif
	//
	if( gaussianFitting == 0 )  // do not perform 2D gaussian fitting to particle
		//
		ImageStats/G={ xStart, xEnd, yStart, yEnd } inputImage
		inputWave[ 0 ] = V_avg					// ROI avg intensity
		inputWave[ 1 ]  = V_max				// amplitude 
		inputWave[ 2 ]  = 0					// amplitude error
		inputWave[ 3 ] = round( xCoordInput )	// x center position of a particle
		inputWave[ 4 ] = round( yCoordInput )	// y center position of a particle
		inputWave[ 5 ] = round( radiusInput * 2 )	// x width of a particle
		inputWave[ 6 ] = 0						// x width error of a particle
		inputWave[ 7 ] = V_min				// baseline
		inputWave[ 8 ] = 0						// error of fit
		//
	else 				// 	perform 2D gaussian fitting to particle
		// 	initial guesses
		ImageStats/G={ xStart, xEnd, yStart, yEnd } inputImage
		inputWave[ 0 ] = V_avg		// average ROI intensity of spot.
		make/o /d /n = 9 W_coef = { V_min, inputImage[xCoordInput][yCoordInput] - V_min, xCoordInput, yCoordInput, radiusInput , xCoordInput, yCoordInput, radiusInput * 2, cropSize }
		make/o /d /n = 9 W_sigma = 0 
		//
		FuncFitMD/H="000001111"/N /NTHR=0 /G /W =2 /Q gaus2dAllAtOnce W_coef  inputImage[ xStart, xEnd ][ yStart, yEnd ]
		if( V_fitError == 0 )   // if fitting was without problems 
			//	recording information from Gaussian fit
			inputWave[ 1 ]  = W_coef[ 1 ]						// amplitude 
			inputWave[ 2 ]  = W_sigma[ 1 ]						// amplitude error
			inputWave[ 3 ] = W_coef[ 2 ]						// x center position of a particle
			inputWave[ 4 ] = W_coef[ 3 ]						// y center position of a particle
			inputWave[ 5 ] = W_coef[ 4 ]						// x width of a particle
			inputWave[ 6 ] = W_sigma[ 4 ]						// x width error of a particle
			inputWave[ 7 ] = W_coef[ 0 ]						// baseline of Gaussian fit
			// error of gaussian fit calculation
			errorFit1 = abs( W_sigma[ 4 ] * 100 ) / W_coef[ 4 ]	// width error
			errorFit2 = abs( W_sigma[ 1 ] * 100 ) / W_coef[ 1 ]	// width error
			// propagated error of the fit is higher than the threshold error.
			if( min( errorFit1, errorFit2 ) > maxDeviation )
				fittingErrorWave[ 1 ] += 1
				inputWave[ 8 ] = 1
			else
				inputWave[ 8 ] = 0
			endif
			//
			if( inputWave[ 8 ] == 0 )
				if( round( W_coef[ 4 ] ) > cropSize * 2 )
					fittingErrorWave[ 2 ] += 1
					inputWave[ 8 ] = 1
				endif
			endif
			//
		else			// particle fit to 2D gaussian was unsuccessful
			fittingErrorWave[ 0 ] += 1
			inputWave[ 8 ] = 1
		endif
	endif
	//
end  // end of single particle analysis