#pragma rtGlobals=1		// Use modern global access method.
#pragma ModuleName = tracesAnalyzer6

//	function which characterize detected states. last time update on 2015-10-28 by MT.

function TEclusion_TA_MT(ctrlName):buttoncontrol
	string ctrlName
	//
	print "************************************************"
	print "Sorting of states, initiated: "+time( )
	//	kill names potentially containing needed waves
	doWindow/k graph1; doWindow/k graph2; dowindow/k graph3; dowindow/k reportType; dowindow/k graphTemp
	// clean the current data folder
	killWaves/a/z; killStrings/a/z; killWaves/z/a
	// defining global variables
	Struct TA_preferences TAPrefs
	load_preferences_TA_MT( TAPrefs )							// load structure
	// loading structure variables into local variables
	variable/G blStateStatus = TAPrefs.blStateToggle				// exclude from  state info table: 1 - none, 2 - first, 3 - last, 4 - first & last.
	variable/G blStateToggle = TAPrefs.blStateToggle2			// exclude bleaching state: FRET, not FRET, disabled.
	variable/G nSdev = TAPrefs.nSdevBleach							// # of sDev for bleaching state detection in not FRET signals
	variable/G rejAccToggle = 1											// output variable of the sorting function: 1 - accepted, 0 - rejected.
	variable analyseSelAllTraces = TAPrefs.IdSelAllTrStateChar	// use selected or all signals
	variable silentICP = TAPrefs.silentICPDetection
	// local variables and strings
	variable gg = 0						// counters
	// report parameter values
	print nSdev, ": # of sdev for bleaching state detection."
	print "Exclude from state info table "+stringfromlist( blStateStatus-1, "none;first;last;first & last;", ";" )+" state."
	print "Exclude bleaching state: "+stringfromlist( blStateToggle-1, "FRET;Not FRET;Disabled;",";" )
	print "Analyse: "+stringfromlist( analyseSelAllTraces-1, "selected traces;all traces;", ";")
	print silentICP, ": report generation toggle."
	// check if the path4 for loading waves exsists
	pathInfo path4
	if( V_flag == 0 )
		abort "Path to data does not exsist, define path4!"
	endif
	// load required waves from path4
	loadWExclusion_TA_MT( analyseSelAllTraces )
	wave trNormCont, trIdCont, trFRETCont
	wave coordsTable
	wave accRejIndicatorTable
	//	make table for storing detected states info and add labels of columns
	make/o /n = ( 1, 9 )  stateInfoTable
	make/o /t /n = ( dimSize( stateInfoTable, 1 ) ) labelsWaveInput = {"index","startX","endX","dur","currInt","fwInt","amp","sdev","currEfret"};
	labeling_TA_MT( stateInfoTable , labelsWaveInput , 1 )		// add labels
	//****************************************************************************************************************************
	for( gg = 0 ; gg < dimSize( trNormCont, 1 ) ; gg += 1 )
		// report status on the main panel
		State_GUI_TA_MT ( "Trace # "+num2str( gg + 1 )+" from: "+num2str( dimSize( trNormCont, 1 ) )  )
		// check whether signal was accepted.
		if( accRejIndicatorTable[ gg ] != 0 )
			// make single waves.
			make/o /n = ( dimSize( trNormCont, 0 ) ) normW = trNormCont[ p ][ gg ]
			make/o /n = ( dimSize( trIdCont, 0 ) ) idW = trIdCont[ p ][ gg ]
			make/o /n = ( dimSize( trFRETCont, 0 ) ) fretW = trFRETCont[ p ][ gg ]
			// returns ICP location table, which states are of the rigth duration
			makeICPtable( );	wave icpTableOut
			// make ideal trace
			makeIdealTrace_SITChar_TA_MT( normW, icpTableOut ); duplicate/o idealTraceOutput, idealTraceOutputRaw
			// make a state info table	
			fillStateInfoTableFRET_TA_MT( gg, blStateStatus )
			//
			makeIdealTrace_SITChar_TA_MT( normW, icpTableOut )
			//
			if( silentICP == 1 ) // dislay result of state char.
				displayOutput_SITChar_TA_MT( normW, idealTraceOutputRaw, idealTraceOutput )
			endif
			//
		endif
		//
	endFor // end of for loop - gg reaches total number of signals
	//
	deletepoints/m=0 0,1, stateInfoTable
	//	Saving state info table
	Save/C/O/P=path4 stateInfoTable as "050_stateInfoTable.ibw"
	Save/C/O/P=path4 accRejIndicatorTable as "051a_TrExcl_stateInfoTable.ibw"
	//	saving preferences
	save_preferences_TA_MT( TAPrefs )
	//	saving notebook with parameters
	Notes_stateChar_TA_MT(   )
	//  	print final status notifer
	State_GUI_TA_MT("\tStates were characterized!\r"+time() )
	print "State characterization done!"
	// 	releasing memory occupied by local variables and strings and waves
	killWaves/a/z; 	killStrings/a/z; 	killWaves/z/a
	//
end  // end of SM traces analysis function
//
function/D fretAccCorr_SITChar_TA_MT( fretSignal, accSignal, fretThresh, accThresh )
	wave  fretSignal, accSignal
	variable fretThresh, accThresh
	//
	variable countFRET = 0,	countAcc = 0, endP = 0, kk, outVar = 0
	// find bleaching point in FRET
	for( kk = 0 ; kk < dimsize( fretSignal, 0 ) ; kk += 1 )
		//
		if( fretSignal[kk] > 1.2 || fretSignal[kk] < -0.2 || accSignal[kk] < 0.5 )
			endP = kk
			break
		endif
		//
	endFor
	// find correspondance between high FRET and high Acc.
	for( kk = 0 ; kk < endP ; kk += 1 )
		//
		if( fretSignal[kk] > fretThresh )
			//
			countFRET += 1
			//
			if( accSignal[kk] > accThresh )
				countAcc += 1
			endif
			//
		endif
		//
	endfor
	//
	if( countAcc > 0 && countFRET > 0 )
		outVar = countAcc / countFRET
	else
		outVar = 0
	endif
	//
	return outVar
	//
end
//
function makeIdealTrace_SITChar_TA_MT( intensityWaveOrg, icpList )
	wave intensityWaveOrg, icpList
	//
	variable currentIndex, meanVal, startPoint
	//
	make/o/d/n = ( dimSize( intensityWaveOrg, 0 ) ) idealTraceOutput = 0
	// assign avg intensity for detected states and make ideal trajectory
	for( currentIndex = 0 ; currentIndex + 1 < dimSIze( icpList , 0 ) ; currentIndex +=1 )
		// estimate average intensity by fitting a line to this part of trajectory
		meanVal = mean( intensityWaveOrg, icpList[ currentIndex ] +1, icpList[ currentIndex + 1 ] -1)
		//assign this average value to part of ideal trajetory
		for( startPoint = icpList[ currentIndex ]; startPoint <= icpList[ currentIndex + 1 ] ; startPoint += 1 )
			idealTraceOutput[ startPoint ] = meanVal
		endFor
		//
	endFor
	//
end
// dislays output of state char table
function displayOutput_SITChar_TA_MT( intensityWaveIn, idealTraceOutputRaw, idealTraceOutput )
	wave intensityWaveIn, idealTraceOutputRaw, idealTraceOutput
	//
	//wave fretWave
	//
	variable stopvar
	//
	doWindow/k graphTemp
	display /n = graphTemp intensityWaveIn, idealTraceOutput, idealTraceOutputRaw
	//appendtograph/w = graphTemp /r fretWave
	ModifyGraph /w = graphTemp mode(idealTraceOutput)=6,rgb(idealTraceOutput)=(0,0,0), rgb(idealTraceOutputRaw)=(0,40000,0) , lsize(idealTraceOutput)=1.5//, axisEnab(left)={0.45,1}, rgb(fretWave)=(0,40000,0), axisEnab(right)={0,0.5}
	//SetAxis/w = graphTemp right -0.1,1.1
	execute " TileWindows/G=5/A=(1,1)/W=(42,18,786,468) graphTemp"
	//
	doUpdate
	stopvar = 2
	prompt stopvar, "Stop: ", popUp, "yes;no"
	doprompt "Choose", stopvar
	if( stopvar == 1 )
		abort
	endif
	doWindow/k graphTemp
	//
end
// load waves from the folder
function loadWExclusion_TA_MT( analyseSelAllTraces )
	// input variables
	variable analyseSelAllTraces
	// defining local vaiables and strings
	string fileNAme
	//
	fileNAme = ListMatch( (indexedFIle ( path4 , -1 , ".ibw" )) , "*032_0_*" )
	LoadWave/H/O/N = wave1/P = path4/Q stringFromList(0 , fileName )		// loading filtered and normalised trajectories container.
	duplicate/o $stringFromlist( 0 , S_wavenames ), trNormCont
	s_wavenames = ""
	//
	fileNAme = ListMatch( (indexedFIle ( path4 , -1 , ".ibw" )) , "*033_0_*" )
	LoadWave/H/O/N = wave1/P = path4/Q stringFromList(0 , fileName )		// loading ideal trajectories container.
	duplicate/o $stringFromlist( 0 , S_wavenames ), trIdCont
	s_wavenames = ""
	//
	fileNAme = ListMatch( (indexedFIle ( path4 , -1 , ".ibw" )) , "*040_*" )
	LoadWave/H/O/N = wave1/P = path4/Q stringFromList(0 , fileName )		// loading spot info. container.
	duplicate/o $stringFromlist( 0 , S_wavenames ), coordsTable
	s_wavenames = ""
	//
	if( analyseSelAllTraces == 1 )
		fileNAme = ListMatch( (indexedFIle ( path4 , -1 , ".ibw" )) , "*051_*" )
		LoadWave/H/O/N = wave1/P = path4/Q stringFromList(0 , fileName )		// loading accepted rejected indicator table.
		duplicate/o $stringFromlist( 0 , S_wavenames ), accRejIndicatorTable
		s_wavenames = ""	
	else
		make/o /n = ( dimSize( trIdCont, 1 ) ) accRejIndicatorTable = 1
	endif
	//
	fileNAme = ListMatch( (indexedFIle ( path4 , -1 , ".ibw" )) , "*030_0_*" )
	LoadWave/H/O/N = wave1/P = path4/Q stringFromList(0 , fileName )		
	duplicate/o /r = [*,*][*,*][0,0] $stringFromlist( 0 , S_wavenames ), trFRETCont
	s_wavenames = ""
	//
end
// make ICP table from the idealised trace
function makeICPtable( )
	// referencing wave
	wave idW	// idealized trace
	//
	variable hh = 0, mm = 0, nn = 1	 // counter for while loop
	variable startPoint = 0
	//
	make/o /n = 2 icpTableOut
	// first and last ICP.
	icpTableOut[ 0 ] = 0
	do
		if( idW[hh] == -1 )
			icpTableOut[ 1 ] = hh
			break
		else
			hh += 1
		endif
		//
		if( hh >= dimsize( idW,  0 ) )
			icpTableOut[ 1 ] = hh - 1
			break
		endif
	while(1)
	//
	hh = 0
	// identify other ICPs.
	do
		//
		mm = hh
		//**********
		do
			//
			if( idW[ mm ] != idW[ mm + 1 ] )
				insertPoints/m=0 nn, 1, icpTableOut
				icpTableOut[nn] = mm		// ICP loc.
				nn += 1
				break
			else
				mm += 1
			endif
			//
			if( mm + 1 >= icpTableOut[ dimsize( icpTableOut, 0 ) - 1 ] )
				break
			endif
			//
		while( 1 )
		//
		hh = mm + 1
		if( hh >= icpTableOut[ dimsize( icpTableOut, 0 ) - 1 ]  )
			break
		endif
		//
	while(1)
	//
end
// fill tate ino table with taking care of anti-correlation info.
function fillStateInfoTableFRET_TA_MT( indexTrace, blStateStatus )
	// 	input
	variable indexTrace
	variable blStateStatus 		// 1 - exlude none, 2 - first, 3 - last, 4 - first & last.
	// referencing waves
	wave stateInfoTable
	wave icpTableOut
	wave normW
	wave fretW
	// global variables
	NVAR nSdev, blStateToggle
	// local variables
	variable pp = dimSize( icpTableOut, 0 ) - 1
	variable kk = 0
	variable amp1, amp2
	variable sDev1
	variable distStateInt = 0
	variable endPointTable = dimSize( icpTableOut, 0 ) - 1
	variable avgInt, sdInt
	//***************************************************************************************
	// detect last emitting state, by checking amplitudes of ICPs ad sDev of them.
	if( blStateToggle == 2 )  // not FRET signal
		//
		avgInt = mean( normW, dimsize(normW,0)*0.9,inf )
		sdInt = sqrt( variance( normW, dimsize(normW,0)*0.9,inf ) ) * nSdev
		//
		do
			//
			amp1 = abs( mean( normW, icpTableOut[pp-2], icpTableOut[pp-1] ) - mean( normW, icpTableOut[pp-1], icpTableOut[pp] ) ) // previous - current state
			//
			if( amp1 > avgInt + sdInt )	// if amplitude of step is higher than the the defined value.
				//
				endPointTable = pp - 1
				break
				//
			else
				pp -= 1
			endif
			//
			if( pp-2 < 0 )
				endPointTable = 1
				break
			endif
			//
		while( 1 )
		//
	elseif( blStateToggle == 1 ) // FRET signal
		//
		endPointTable = remBlFRET_stateChar_TA_MT( fretW, icpTableOut ) - 2
		//
	endif
	// fill state info table.
	for( pp = 0; pp < endPointTable; pp += 1 )
		//***************
		// column name of state Info table {"index","startX","endX","dur","currInt","fwInt","amp","sdev"};
		// insert a row into the state info table
		insertpoints/m=0 dimsize( stateInfoTable, 0  ), 1, stateInfoTable
		// fill characteristics of states
		// trace index
		stateInfoTable[ dimsize(stateInfoTable,0)-1][%index] = indexTrace
		// start end end point of state
		stateInfoTable[ dimsize(stateInfoTable,0)-1][%startX] = icpTableOut[ pp ] 		// start point of the state
		stateInfoTable[ dimsize(stateInfoTable,0)-1][%endX] = icpTableOut[ pp + 1 ]   	// end point of the state
		// duration of state in points
		if( pp == 0  )  							// first state
			if( blStateStatus == 2 || blStateStatus == 4 ) // exclude first or first & last.
				stateInfoTable[ dimsize(stateInfoTable,0)-1][%dur] = nan   // duration of state in points
			else
				stateInfoTable[ dimsize(stateInfoTable,0)-1][%dur] = abs( icpTableOut[ pp + 1 ] - icpTableOut[ pp ] )   // duration of state in points
			endif
		elseif( pp >= endPointTable - 1 )  	// last state.
			if( blStateStatus == 3 || blStateStatus == 4 ) // exclude last or first & last.
				stateInfoTable[ dimsize(stateInfoTable,0)-1][%dur] = nan   // duration of state in points
			else
				stateInfoTable[ dimsize(stateInfoTable,0)-1][%dur] = abs( icpTableOut[ pp + 1 ] - icpTableOut[ pp ] )
			endif
		else
			stateInfoTable[ dimsize(stateInfoTable,0)-1][%dur] = abs( icpTableOut[ pp + 1 ] - icpTableOut[ pp ] )
		endif
		//  avg. intensity of current state.
		stateInfoTable[ dimsize(stateInfoTable,0)-1][%currInt] = mean( normW, icpTableOut[ pp ] + distStateInt, icpTableOut[ pp + 1 ] - distStateInt)
		//  Efret of current state.
		stateInfoTable[ dimsize(stateInfoTable,0)-1][%currEfret] = mean( fretW, icpTableOut[ pp ] + distStateInt, icpTableOut[ pp + 1 ] - distStateInt)		
		// avg. intensity of following state and step amplitude
		if( pp >= endPointTable - 1 )
			stateInfoTable[ dimsize(stateInfoTable,0)-1][%fwInt] = Nan
			stateInfoTable[ dimsize(stateInfoTable,0)-1][%amp] = Nan
		else
			stateInfoTable[ dimsize(stateInfoTable,0)-1][%fwInt] = mean( normW, icpTableOut[ pp + 1 ] + distStateInt, icpTableOut[ pp + 2 ] - distStateInt )
			stateInfoTable[ dimsize(stateInfoTable,0)-1][%amp] = stateInfoTable[ dimsize(stateInfoTable,0)-1][%fwint] - stateInfoTable[ dimsize(stateInfoTable,0)-1][%currInt]	
		endif
		// standard deviation of current state intensity.
		stateInfoTable[ dimsize(stateInfoTable,0) - 1 ][ %sdev ] = sqrt( Variance( normW, icpTableOut[ pp ] + distStateInt , icpTableOut[ pp + 1 ] - distStateInt ) )
		//
	endfor
	// remove bleach state from ICP table
	if( endPointTable != dimSize( icpTableOut, 0 ) - 1 )
		//
		deletepoints/m=0 endPointTable+1, abs( dimSize( icpTableOut, 0 ) ) - endPointTable, icpTableOut
		//
	endif
	//
end
//************************************************************************************************************
function/d remBlFRET_stateChar_TA_MT( inW, icpTableW )
	wave inW // fret signal
	wave icpTableW // icp location table
	//
	variable bb = 0, cc = 0, countBleach = 0
	variable whenBleach = 0
	//
	do
		// ***********
		countBleach = 0
		//
		for( cc = icpTableW[ bb ] ; cc < icpTableW[ bb + 1 ] ; cc += 1 )
			if( inW[ cc ] > 1.2 || inW[ cc ] < -0.2 )
				countBleach += 1
			endif
		endFor
		//
		if( countBleach > 2 )
			whenBleach = bb
			break
		else
			bb += 1
		endif
		//***********
		if( bb + 1 >= dimsize( icpTableW, 0 ) )
			whenBleach = bb
			break
		endif
		//
	while(1)
	//
	return whenBleach
	//
end
// ****    notebook function
Function Notes_stateChar_TA_MT( )
	// loading structure variables
	Struct TA_preferences TAPrefs
	load_preferences_TA_MT( TAPrefs )
	// closing notebook if it exist
	DoWindow logWin
	if(V_flag==1)
		DoWindow/K logWin
	endif
	// making new notebook
	NewNoteBook/F=0/N=logWin
	// writing text on logWIn window
	NoteBook logWin text = "\r\rData treated with TAMT."
	NoteBook logWin text = "\rWritten by Marijonas Tutkus\r@ BioNano, KU and @ Department of Molecular Compound Physics, CPST."
	// data path information
	NoteBook logWin text = "\r\rData path information:"
	pathInfo path4; 	NoteBook logWin text = "\rResults stored at: " + S_path
	//
	if( TAPrefs.blStateToggle == 1 )
		NoteBook logWin text = "\r\rNone of states will be excluded from the state info table."
	elseif( TAPrefs.blStateToggle == 2 )
		NoteBook logWin text = "\r\rFirst state will be excluded from the state info table."
	elseif( TAPrefs.blStateToggle == 3 )
		NoteBook logWin text = "\r\rLast state will be excluded from the state info table."	
	elseif( TAPrefs.blStateToggle == 4 )
		NoteBook logWin text = "\r\rFirst and last state will be excluded from the state info table."
	endif
	//
	if( TAPrefs.blStateToggle2 == 1 )
		NoteBook logWin text = "\r\rExclusion of bleaching statein FRET signals: enabled"
	elseif( TAPrefs.blStateToggle2 == 1 )
		NoteBook logWin text = "\r\rExclusion of bleaching state in not FRET signals: enabled, SD for detection of bleaching state: "+num2str(TAPrefs.nSdevBleach)
	else
		NoteBook logWin text = "\r\rExclusion of bleaching state: disabled"
	endif
	//
	NoteBook logWin text = "\r\rAnalyse: "+stringfromlist( TAPrefs.IdSelAllTrStateChar-1, "selected traces;all traces;", ";")
	// saving notebook
	SaveNoteBook/O/P= path4 /S=6 logWin as "LogBook7_stateChar.txt"
	doWindow/K logWin
	//
end 		// end of notebook function


//*************************************************************
// define intensity groups 
function grouping_Tex_TA_MT(ctrlName):buttoncontrol
	string ctrlName
	//
	variable aa, bb, cc, ngroups, markovGroupToggle
	//
	prompt ngroups, "# of groups/states"
	doprompt "Enter the value", ngroups
	if( V_flag != 0 )
		abort
	endif
	//
	make/o /n = ( ngroups, 2 ) groupsTable
	//
	for( aa = 0; aa < dimsize( groupsTable, 0 ); aa +=1 )
		//
		bb = cc
		prompt bb, "Minimal intensity of group #: "+num2str(aa+1)
		prompt cc, "Maximal intensity of group #: "+num2str(aa+1)
		doprompt "Enter the values", bb, cc
		if( V_flag != 0 )
			abort
		else
			//
			print bb, cc, ": minimal and maximal intensity of the group # "+num2str(aa+1)
			//
			groupsTable[aa][0] = bb
			groupsTable[aa][1] = cc
			//
		endif
		//
	endFor
	//
	newpath/o/c/m="Navigate to the results folder where program will save the table" path5
	if( V_flag != 0 )
		abort
	endif
	//
	Save/C/O/P=path5 groupsTable as "000_groupsInfoTable.ibw"
	//
end
////*****for reporting
//function displayResult_Tex_TA_MT( )
//
//	NVAR rejAccToggle
//	
//	wave  filtW, idW, antiCorrTrace
//	
//	print rejAccToggle , " :rej toggle."
//	dowindow/k graphM; 		dowindow/k graphM1
//	display/n=graphM filtW, idW, trAntiCorrContAcc[ ][ dimsize( trAntiCorrContAcc, 1 ) - 1 ]
//	APPENDTOGRAPH/L=LEFT1 filtW1, filtW2
//	SetAxis left -0.1,1.1
//	modifygraph rgb(idW)=(0,0,0),  rgb(trAntiCorrContAcc)=(1,12815,52428),mode(trAntiCorrContAcc)=3,marker(trAntiCorrContAcc)=8, axisEnab(left)={0,0.45}, axisEnab(left1)={0.45,1}, freePos(LEFT1)={0,bottom}, rgb(filtW1)=(2,39321,1)
//	execute "TileWindows/G=5/A=(1,1)/W=(40,40,500,500) graphM"
//	doupdate
//	variable stopVar = 2 
//	prompt stopVar, "Stop", popup, "Yes;No;"
//	doprompt "Choose", stopVar
//	if( stopVar == 1 || V_flag == 1 )
//		abort
//	else
//		dowindow/k graphM
//	endif
//
//end
//
//
//function checkGroups_Tex_TA_MT( icpTableOut, idTrace, filtTrace, rawW , normW  )
//	wave icpTableOut, idTrace, filtTrace, rawW, normW 
//	wave groupsW
//	//
//	NVAR minAmpVar
//	//
//	variable nn = 0, gg, kk
//	//
//	duplicate/o icpTableOut, groupTable; 	groupTable = 0
//	// identify which intensity grop the detected state belong to
//	for( gg = 1 ; gg < dimsize( icpTableOut, 0 )-1; gg += 1 )
//		//
//		groupTable[ gg ] = mean( normW, icpTableOut[gg-1], icpTableOut[gg] ) - mean( normW, icpTableOut[gg], icpTableOut[gg+1] )
//		//
//	endFor
//	// remove ICPs separating same intensity groups
//	nn = 1
//	do
//		if( abs( groupTable[nn] ) < minAmpVar )
//			deletepoints/m=0 nn, 1, groupTable
//			deletepoints/m=0 nn, 1, icpTableOut
//		else
//			nn += 1
//		endif
//		//
//		if( nn >= dimsize( groupTable, 0 ) - 1 )
//			break
//		endif
//		//
//	while(1)
//	//
//end
// fill intensity of idealzed trajectories
//function  idealTraceFill( w1, w2, w3 )
//	wave w1 		// icp location table
//	wave w2		// idealized trace
//	wave w3		// filtered trace
//	//
//	variable distStateInt = 3
//	variable countRows = 0, count2
//	//
//	for( countRows = 0 ; countRows < dimSIze( w1, 0 ) - 1 ; countRows += 1 )
//		//
//		for( count2 = w1[ countRows ] ; count2 <= w1[ countRows + 1 ] ; count2 += 1 )
//			w2[ count2 ] = mean( w3, w1[countRows] + distStateInt, w1[countRows + 1 ] - distStateInt)
//		endFor
//		//
//	endFor
//	//
//end

//// removes fraction of Efret trace, which is above 1.5 or below -0.5.
//function removeBleachedFRET2_TA_MT( )
//	// referencing waves
//	wave rawW, filtW, normW, idW
//	//
//	variable bb = 0, cc = 0, countBleach = 0
//	variable minY = -0.2 , maxY = 1.2
//	variable nPntsBleach = 1
//	variable lengthToAnalyse = 5
//	//
//	do	
//		// ***********
//		if( rawW[bb] > maxY || rawW[bb] < minY  )
//			//
//			cc = bb + 1
//			countBleach = 0
//			do
//				if( rawW[cc] > maxY || rawW[cc] < minY  )
//					countBleach += 1
//				endif
//				//
//				cc += 1
//				if( cc >= dimSize( rawW, 0 ) )
//					break
//				endif
//				//
//				if( cc - bb > lengthToAnalyse  )
//					break
//				endif
//				//
//			while( 1 )
//			//
//		endif
//		//***********
//		if( countBleach > nPntsBleach )
//			//
//			do
//				//
//				if( bb < dimsize( rawW, 0 ) )
//					deletepoints/m=0 bb, 1, rawW,  filtW, normW, idW
//				else
//					break
//				endif
//				//
//			while(1)
//			//
//			break
//		else
//			bb += 1
//		endif
//		//***********
//		if( bb >= dimsize( rawW, 0 ) )
//			break
//		endif
//		//
//	while(1)
//	//
//end