#pragma rtGlobals=1		// Use modern global access method.
#pragma ModuleName = tracesAnalyzer8

//	function which automatically selects SM trajectories based o given parameters.
// 	written by MT @ BioNano and MDFL.

function TEclusionAuto_TA_MT(ctrlName):buttoncontrol
	string ctrlName
	//
	dowindow/k graphTemp
	//
	print "************************************************"
	print "Auto sorting of traces, initiated: "+time( )
	//	kill names potentially containing needed waves
	doWindow/k graph1; doWindow/k graph2; dowindow/k graph3; dowindow/k reportType
	// clean the current data folder
	killWaves/a/z; killStrings/a/z; killWaves/z/a
	// defining global variables
	Struct TA_preferences TAPrefs
	load_preferences_TA_MT( TAPrefs )							// load structure
	// loading structure variables into local variables
	variable/G numMolMaxToggle =  TAPrefs.levelsSM[ 0 ]			// MM exclusion toggle: 1 - on, else - off.
	variable/G numMolMax1 = TAPrefs.levelsSM[ 1 ]					// MM intensity level 1st channel
	variable/G numMolMaxPnts = TAPrefs.levelsSM[ 3 ]				// # of pnts above max int.
	variable/G emtyTrajToggle = TAPrefs.neverBleach[ 0 ]		// empty trajectory detection.
	variable/G nSDemptyTraj = TAPrefs.neverBleach[ 1 ]			// # SD for empty traj. detection.
	variable/G rejAccToggle = 1											// output variable of the sorting function: 1 - accepted, 0 - rejected.
	variable silentToggle = TAPrefs.silentICPDetection			// if = 1: window with results will appear, else - does not appear.
	variable indexIdTr = TAPrefs.IdTrName							// index to name of table to idealise.
	string namesIdTrTable1 = "030_0_;030_1_;030_2_;030_6_;030_7_;"
	string namesIdTrTableSingle = stringFromList(indexIdTr-1, namesIdTrTable1, ";")
	// signals comming from this ROI of image will be analysed.
	variable/g xForCropping1 = TAPrefs.sizeImage[ 2 ]				// x0
	variable/g xForCropping2 = TAPrefs.sizeImage[ 3 ]				// x1
	variable/g yForCropping1 = TAPrefs.sizeImage[ 4 ]				// y0
	variable/g yForCropping2 = TAPrefs.sizeImage[ 5 ]				// y1
	// local variables
	variable gg = 0	// counters
	// check if the path4 for loading waves exsists
	pathInfo path4
	if( V_flag == 0 )
		abort "Path to data does not exsist, define path4!"
	endif
	//
	if( numMolMaxToggle == 1 )
		print numMolMax1, ": max intensity value"
		print numMolMaxPnts, ": number of points for average intensity calculation."
	else
		print "Maximal intensity will not be checked."
	endif
	//
	if( emtyTrajToggle == 1 )
		print "Empty trajectories will be detected. # SD: "+num2str(nSDemptyTraj)
	else
		print "Empty trajectories will not be detected."
	endif
	//
	print namesIdTrTableSingle, ": name of table to idealise."
	//
	print xForCropping1, xForCropping2, yForCropping1, yForCropping2,": traces from this region of image will be accepted (x0,x1,y0,y1)."
	//
	loadWExclusionAuto_TA_MT( namesIdTrTableSingle )
	wave trContIn
	wave coordsTable
	//	make accepted trajectories table
	make/o /n = ( dimsize( trContIn, 1 ) ) acceptRejIdicatorW_TExc = 1
	make/o /n = ( dimsize( trContIn, 0 ) ) normW = 0
	//
	for( gg = 0 ; gg < dimSize( trContIn, 1 ) ; gg += 1 )
		// report status on the main panel
		state_GUI_TA_MT ( "Auto trace sorting\rTrace # "+num2str( gg + 1 )+" from: "+num2str( dimSize( trContIn, 1 ) )  )
		// crop trace
		normW[] = trContIn[p][gg]
		// reset the toggle, 1- acc, 0 - rejected.
		rejAccToggle = 1
		// check coordinates of the molecule.
		checkCoords_TA_MT( coordsTable, gg , 1 )
		// check out maximal intensity of norm trace.
		if( numMolMaxToggle == 1 )
			MMcheck_TA_MT( normW )
		endif
		// empty trajectory detection
		if( emtyTrajToggle == 1 )
			emptyTrajDet_TEA_TA_MT( normW, silentToggle )
		endif
		//
		acceptRejIdicatorW_TExc[ gg ] = rejAccToggle
		//
		if( silentToggle == 1 )
			displayOutput_TEAuto_TA_MT( normW, rejAccToggle, gg )
		endif
		//
	endFor // end of for loop - gg reaches total number of signals
	//
	Save/C /O /P = path4 acceptRejIdicatorW_TExc as "051_accRejIndic.ibw"
	//
	print "Auto trace sorting done."
	state_GUI_TA_MT ( "Auto trace sorting done"  )
	//
	Notes_refinement_TA_MT( )
	//
end
//************************************************************************************************
// displays output of the current trace analysis.
function displayOutput_TEAuto_TA_MT( intensityWaveIn, rejAccToggle, index )
	wave intensityWaveIn
	variable rejAccToggle, index
	//
	variable stopvar
	//
	doWindow/k graphTemp
	display /n = graphTemp intensityWaveIn
	execute " TileWindows/G=5/A=(1,1)/W=(42,18,786,468) graphTemp"
	//
	print rejAccToggle, index ,": rejected toggle, current trace index."
	//
	doUpdate
	stopvar = 2
	prompt stopvar, "Stop: ", popUp, "yes;no"
	doprompt "Choose", stopvar
	if( stopvar == 1 )
		abort
	endif
	doWindow/k graphTemp
	//
end
//************************************************************************************************
// load waves from the folder
function loadWExclusionAuto_TA_MT( tableNameIn )
	//
	string tableNameIn
	//
	string fileNAme
	//
	fileNAme = ListMatch( (indexedFIle ( path4 , -1 , ".ibw" )) , "*"+tableNameIn+"*" )
	LoadWave/H/O/N = wave1/P = path4/Q stringFromList(0 , fileName )		// loading raw trajectories container
	duplicate/o $stringFromlist( 0 , S_wavenames ), trContIn
	s_wavenames = ""
	fileNAme = ListMatch( (indexedFIle ( path4 , -1 , ".ibw" )) , "*040_*" )
	LoadWave/H/O/N = wave1/P = path4/Q stringFromList(0 , fileName )		// loading ideal trajectories container
	duplicate/o $stringFromlist( 0 , S_wavenames ), coordsTable
	s_wavenames = ""
	//
end
//************************************************************************************************
// checks if the molecule is within the region of the main ROI.
function checkCoords_TA_MT( inW, countVar, channelToggle )
	wave inW
	variable countVar
	variable channelToggle
	//
	NVAR xForCropping1, xForCropping2
	NVAR yForCropping1, yForCropping2
	NVAR rejAccToggle
	//
	variable x1=0, y1=0
	//
	if( channelToggle == 1 )
		x1 = inW[ countVar ][ %xC1 ]
		y1 = inW[ countVar ][ %yC1 ] 
	else
		x1 = inW[ countVar ][ %xC2 ]
		y1 = inW[ countVar ][ %yC2 ]
	endif
	// check whether spot falls into the main ROI of image.
	if( x1 > xForCropping1 && x1 < xForCropping2 && y1 > yForCropping1 && y1 < yForCropping2  )
		rejAccToggle = 1
	else
		rejAccToggle = 0
	endif
	//
end
//************************************************************************************************
function MMcheck_TA_MT( normW )
	// input signal
	wave normW
	// referencing global variables
	NVAR numMolMax1, numMolMaxPnts
	NVAR rejAccToggle
	//
	variable numPntsAboveThrCount = 0, ff, outvar
	// check maximal intensity of normalised trace
	for( ff = 0 ; ff < dimsize( normW, 0 ) ; ff += 1 )
		if( normW[ ff ] > numMolMax1 )
			numPntsAboveThrCount += 1
		endif
	endFor
	//
	if( numPntsAboveThrCount > numMolMaxPnts )
		rejAccToggle = 0
	endif
	//
end
//************************************************************************************************
Function/D emptyTrajDet_TEA_TA_MT( normW, silentToggle )
	// input signals
	wave normW
	//
	variable silentToggle
	// referencing global variables
	NVAR nSDemptyTraj, numMolMaxPnts
	NVAR rejAccToggle
	// local variables
	variable rr
	variable nPnts = min( dimSize(normW,0)*0.9, 10 )
	variable avgIntEnd = mean( normW, dimSize(normW,0)-nPnts, dimSize(normW,0)-1 )
	variable sdIntEnd = sqrt( variance( normW, dimSize(normW,0)-nPnts, dimSize(normW,0)-1 ) ) * nSDemptyTraj
	variable notEmpty = 0
	//
	for( rr = dimSize( normW, 0 ) - 2; rr > -1 ; rr -= 1 )
		//
		if( normW[rr] > avgIntEnd + sdIntEnd || normW[rr] < avgIntEnd - sdIntEnd )
			notEmpty += 1
		endif
		//
		if( notEmpty > numMolMaxPnts )
			break
		endif
		//
	endFor
	//
	if( notEmpty < numMolMaxPnts ) 
		rejAccToggle = 0
	endif
	//
	if( silentToggle == 1 )
		print avgIntEnd, sdIntEnd, notEmpty ,": avg int, sd of int, emptyNotEmpty toggle."
	endif
	//
	return notEmpty
	//
End
// ****    notebook function		*************************************************************
Function Notes_refinement_TA_MT( )
	// loading structure variables
	Struct TA_preferences TAPrefs
	load_preferences_TA_MT( TAPrefs )
	// closing notebook if it exist
	DoWindow logWin
	if(V_flag==1)
		DoWindow/K logWin
	endif
	// making new notebook
	NewNoteBook/F=0/N=logWin
	// writing text on logWIn window
	NoteBook logWin text = "\r\rData treated with TAMT."
	NoteBook logWin text = "\rWritten by Marijonas Tutkus\r@ BioNano, KU and @ Department of Molecular Compound Physics, CPST."
	// data path information
	NoteBook logWin text = "\r\rData path information:"
	pathInfo path4; 	NoteBook logWin text = "\rResults stored at: " + S_path
	// dimension of image
	NoteBook logWin text = "\r\rDimensions of ROI image ( X0,  X1, Y0 , Y1 ): " + num2str( TAPrefs.sizeImage[ 2 ] ) + " ; "+ num2str( TAPrefs.sizeImage[ 3 ] )+ " ; "+ num2str( TAPrefs.sizeImage[ 4 ] ) + " ; "+ num2str( TAPrefs.sizeImage[ 5 ] )
	// MM exclusion
	if( TAPrefs.levelsSM[ 0 ] == 1 )
		NoteBook logWin text = "\rMulti-molecule traces will be exluded."
		NoteBook logWin text = "\rMulti-molecule intensity level: "+num2str(  TAPrefs.levelsSM[ 1 ] )
		NoteBook logWin text = "\r# points above multi-molecule intensity level: "+num2str(  TAPrefs.levelsSM[ 3 ] )
	else
		NoteBook logWin text = "\rMulti-molecule traces will be included."
	endif
	// rejection of empty trajectories
	if( TAPrefs.neverBleach[ 0 ] == 1 )
		NoteBook logWin text = "\rEmpty traces will be excluded."
		NoteBook logWin text = "\r# SD: "+num2str(  TAPrefs.neverBleach[ 1 ] )
		NoteBook logWin text = "\r# points above defined SD threshold level: "+num2str(  TAPrefs.levelsSM[ 3 ] )
	else
		NoteBook logWin text = "\rEmpty traces will no be excluded."
	endif
	//
	variable indexIdTr = TAPrefs.IdTrName							// index to name of table to idealise.
	string namesIdTrTable1 = "030_0_;030_1_;030_2_;030_6_;030_7_;"
	string namesIdTrTableSingle = stringFromList(indexIdTr-1, namesIdTrTable1, ";")
	NoteBook logWin text = "\rUnique fraction of name of traces table to analise: "+namesIdTrTableSingle
	// saving notebook
	SaveNoteBook/O/P= path4 /S=6 logWin as "LogBook6_autoSelection.txt"
	doWindow/K logWin
	//
end 		// end of notebook function



		//
//		if( numCh != 3 )		//     signal extracted from single channel 
//			// 	crop currrent trajectory from the filtered trajectory container.
//			make/o /n = ( dimSize( trNormCont, 0 ) ) normW = trNormCont[ p ][ gg ]
//			make/o /n = ( dimSize( trIdCont, 0 ) ) idW = trIdCont[ p ][ gg ]
//			// check duration, maximal intensity (norm trace) and amplitude of states
//			MMcheck_TA_MT( )
//			// returns ICP location table, which states are of the rigth duration
//			//makeICPtable( );	wave icpTableOut
//			//
//		elseif( numCh == 3 )   //    FRET data
//			//	Efret trace:  crop currrent trajectory from the filtered trajectory container.
//			make/o /n = ( dimSize( trRawCont, 0 ) ) rawW = trRawCont[ p ][ gg ][ 0 ]
//			make/o /n = ( dimSize( trFiltCont, 0 ) ) filtW = trFiltCont[ p ][ gg ]
//			make/o /n = ( dimSize( trNormCont, 0 ) ) normW = trNormCont[ p ][ gg ]
//			make/o /n = ( dimSize( trIdCont, 0 ) ) idW = trIdCont[ p ][ gg ]
//			//	1st channel trace:	crop currrent trajectory from the filtered trajectory container.
//			make/o /n = ( dimSize( trRawCont1, 0 ) ) rawW1 = trRawCont1[ p ][ gg ][ 0 ]
//			make/o /n = ( dimSize( trFiltCont1, 0 ) ) filtW1 = trFiltCont1[ p ][ gg ]
//			make/o /n = ( dimSize( trNormCont1, 0 ) ) normW1 = trNormCont1[ p ][ gg ]
//			//	2nd channel trace: crop currrent trajectory from the filtered trajectory container.
//			make/o /n = ( dimSize( trRawCont2, 0 ) ) rawW2 = trRawCont2[ p ][ gg ][ 0 ]
//			make/o /n = ( dimSize( trFiltCont2, 0 ) ) filtW2 = trFiltCont2[ p ][ gg ]
//			make/o /n = ( dimSize( trNormCont2, 0 ) ) normW2 = trNormCont2[ p ][ gg ]
//			// stochiometry check
//			if( numMolMaxToggle ==1 )
//				if( excitationType == 1 )
//					make/o /n = ( dimSize( trStochCont, 0 ) ) stochW = trStochCont[ p ][ gg ][ 0 ]
//					stochCheck_TA_MT( )
//				elseif( excitationType != 1 )
//					// check max intensity of ch1 and ch2 
//					MMcheck_TA_MT(  )
//				endif
//			endif
//			// returns ICP location table, which states are of the rigth duration
//			makeICPtable( );	wave icpTableOut
//			//
//		endif
//		//
//		
//		
//		
//function  stochCheck_TA_MT( )
//	//
//	wave stochW
//	//
//	NVAR numMolMax1, numMolMax2
//	NVAR numMolMaxPnts
//	NVAR rejAccToggle
//	//
//	wavestats/q /r = [ 0, min( dimsize( stochW, 0 ) , numMolMaxPnts )] stochW
//	// compare the average value with the set threshold values of stochiometry 
//	if( V_avg > numMolMax1 && V_avg < numMolMax2 )	// accepted.
//		rejAccToggle = 1
//	else						// rej.
//		rejAccToggle = 0
//	endif
//	//
//end
//
//Function antiCorrCheck_TA_MT(indexTrace, blStateStatus, antiCorToggle, numCh )
//	// 	input
//	variable indexTrace
//	variable antiCorToggle
//	variable blStateStatus 		// 1 - exlude none, 2 - first, 3 - last, 4 - first & last.
//	variable numCh
//	// referencing waves
//	wave trAntiCorrContAcc
//	wave acceptRejIdicatorW_TExc
//	wave stateInfoTable
//	wave icpTableOut
//	wave normW
//	if( numCh == 3 )
//		wave normW1, normW2
//	endif
//	// global variables
//	NVAR minAmp_TA1, minAmp_TA2
//	NVAR rejAccToggle, nSdev
//	// local variables
//	variable pp = 0 , kk = 0
//	variable antiCorrVar = 0
//	variable amp1, amp2
//	variable sDev1
//	variable distStateInt = 0
//	variable endPointTable = dimSize( icpTableOut, 0 ) - 1
//	// if 1, check anti-correlation.
//	if( antiCorToggle == 1 )
//		// insert a column for trace
//		insertpoints/m=1 dimsize( trAntiCorrContAcc, 1 ), 1, trAntiCorrContAcc
//		trAntiCorrContAcc[ ][ dimsize( trAntiCorrContAcc, 1 ) - 1 ] = Nan
//		// make trace and table for anti-corr representation.
//		duplicate/o icpTableOut, antiCorrFretW; antiCorrFretW = 1
//		// check anti-correlation
//		for( pp = 1 ; pp < dimSize( icpTableOut, 0 ) - 1 ; pp += 1 )
//			//
//			amp1 = mean( normW1, icpTableOut[pp] + 2 ,  icpTableOut[pp] + 5 ) - mean( normW1, icpTableOut[pp] - 2 ,  icpTableOut[pp] - 5 )
//			amp2 = mean( normW2, icpTableOut[pp] + 2 ,  icpTableOut[pp] + 5 ) - mean( normW2, icpTableOut[pp] - 2 ,  icpTableOut[pp] - 5 )
//			//
//			if( sign( amp1 ) + sign( amp2 ) == 0 && abs( amp1 ) > minAmp_TA1 && abs( amp2 ) > minAmp_TA2 )
//				//
//				antiCorrFretW[ pp ] = 1
//				//
//				trAntiCorrContAcc[ icpTableOut[ pp ] ][ dimsize( trAntiCorrContAcc, 1 ) - 1 ] = mean( normW, icpTableOut[ pp ] +distStateInt, icpTableOut[ pp + 1 ] - distStateInt) 
//				//
//			else
//				antiCorrFretW[ pp ] = 0
//			endif
//			//
//		endfor		
//		// fill single anti-correlation indicators trace.
//		make/o/n=( dimsize( trAntiCorrContAcc, 0 ) ) antiCorrTrace;	antiCorrTrace = trAntiCorrContAcc[ p ][ dimsize( trAntiCorrContAcc, 1 ) - 1 ]
//		//
//	endif
//	// fill accept reject trace indicator table
//	acceptRejIdicatorW_TExc[ indexTrace ] = rejAccToggle
//	//
//	// check anti-correlation.
//	if( antiCorToggle == 1 )
//		// check anti-correlation var.
//		antiCorrVar = 0
//		 if( antiCorrFretW[ pp ] == 1 && antiCorrFretW[ pp+ 1 ] == 1 )
//			 antiCorrVar = 1
//		 endif
//		//
//	endif
//	//
//end
	