#pragma rtGlobals=3		// Use modern global access method and strict wave access.

function histWeightNearestNeighbor( inTable, accRejWave, nBins, minX, maxX, minY, maxY, exposureT, nBins2)
	wave inTable			// state info table
	wave accRejWave
	variable nBins, minX, maxX, minY, maxY
	variable exposureT
	variable nBins2			 // for normal histogram
	//
	variable aa , bb, ii, jj
	variable particleCount = 0
	variable binWidth = maxX-minX; binWidth /= nBins
	variable binWidth2 = maxX-minX; binWidth2 /= nBins2
	//
	make/o /n=0 inData
	for( ii = 0 ; ii + 1 < dimSize( inTable, 0 ) ; ii += 1 )
		
		if( inTable[ii][%currInt] >= minY && inTable[ii][%currInt] < maxY && accRejWave[particleCount] == 1 )
		
			insertpoints/m=0 dimsize(inData,0),1, inData
			inData[dimsize(inData,0)-1] = inTable[ii][%dur]
			
		endif
		
		
		if( inTable[ii][%index] != inTable[ii+1][%index]  )
			particleCount += 1
		endif
		
	endfor
	//
	inData *= exposureT
	//
	make/o/n=(nBins2) inHist2
	make/o/n=(nBins) inHist
	histogram/c/b={minX,binWidth, nBins} inData, inHist
	histogram/c/b={minX,binWidth2, nBins2} inData, inHist2
	wavestats/q inHist2; inHist2 /= V_sum
	//
	duplicate/o inHist, distWa, distWb, distW; distWa = 0; distWb = 0;  distW = 0
	//
	wavestats/q inHist; print V_Sum; inHist /= V_sum
	//
	for( ii = 0 ; ii < dimSize( inHist, 0 ) ; ii += 1 )
		//
		if( inHist[ii] > 0 )
			//
			if( ii == 0 ) // first state
				aa = 1 
				jj = ii + 1
				do
					if( inHist[ jj ] > 0 )
						break
					else
						jj += 1
					endif
					//
					if( jj >= dimSize( inHist, 0 ) )
						break
					endif
					//
				while(1)
				//
				bb = jj - ii
				//
			elseif( ii  >= dimSize( inHist, 0 ) - 1 ) // last state
				bb = ii
				jj = ii - 1
				do
					if( inHist[ jj ] > 0 )
						break
					else
						jj -= 1
					endif
					//
					if( jj < 0 )
						break
					endif
					//
				while(1)
				//
				aa = ii - jj
				//
			else
				//
				jj = ii - 1
				do
					if( inHist[ jj ] > 0 )
						break
					else
						jj -= 1
					endif
					//
					if( jj < 0 )
						break
					endif
					//
				while(1)
				//
				aa = ii - jj
				//
				jj = ii + 1
				do
					if( inHist[ jj ] > 0 )
						break
					else
						jj += 1
					endif
					//
					if( jj >= dimSize( inHist, 0 ) )
						break
					endif
					//
				while(1)
				//
				bb = jj - ii
				//		
			endif
			//
			distW[ ii ] = abs( aa + bb ) / 2
			distWa[ ii ] = aa
			distWb[ ii ] = bb
			//
		endif
		//
	endFor
	//
	distW *= binWidth
	//
	for( ii = 0 ; ii < dimSize( inHist, 0 ) ; ii += 1 )
		if( inHist[ii] > 0 )
			inHist[ii] /= distW[ii]
		endif
	endFor
	//
	// take the bootstrap average  and sDev of the outW
	statsresample/ITER = 100 /n = ( dimsize( inData, 0 ) - 1 )/WS = 1  inData
	wave M_WaveStatsSamples
	make/o /n = ( dimsize( M_WaveStatsSamples, 1 ) ) meanW = M_WaveStatsSamples[3][p]
	print mean( meanW ), ": average value, "+num2str( sqrt ( variance( meanw ) ) )+": Standard deviation."
	//
end