#pragma rtGlobals=3		// Use modern global access method and strict wave access.


function tempF( numImages, threshVal, x1, x2, y1, y2 )
	
	variable numImages, threshVal
	variable x1, x2, y1, y2
	
	newpath/o path1
	if( V_flag != 0 )
		abort
	endif
	
	string listFiles = indexedfile( path1, -1, "????" )
	listFiles = RemoveFromList( "ImageAccW.tif", listFiles, ";" )
	listFiles = RemoveFromList( "avgintROItable.ibw", listFiles, ";" )
	listFiles = RemoveFromList( "avgintROIwave.ibw", listFiles, ";" )
	listFiles = RemoveFromList( "sdevROIwave.ibw", listFiles, ";" )
	
	print listFiles
	
	variable aa, bb
	
	make/o/n=(512,512) ImageAccW = 0
	
	make/o/n=( numImages, itemsinlist( listFiles, ";" ) ) avgintROItable = 0
	make/o/n=( numImages ) avgintROIwave = 0
	make/o/n=( numImages ) sdevROIwave = 0
	
	for( aa = 0; aa < itemsinlist( listFiles, ";" ) ; aa += 1 )
		
		for( bb = 0 ; bb < numImages ; bb += 1 )
	
			load32BitImage_MT( 512, bb, 8, 1, listFiles, aa ); string S_waveNames; wave/z ImageW = $StringFromList(0, S_waveNames,";")	
			
			ImageW = ImageW[p][q] <= threshVal ? 0 : ImageW[p][q]
			
			ImageAccW[][] += ImageW[p][q] / abs( itemsinlist( listFiles, ";" ) * numImages )
			
			imagestats/q/g={x1,x2,y1,y2} ImageW
			
			avgintROItable[ bb ][ aa ] = V_avg
		
		endFor
		
		doupdate
	
	endFor
	
	
	for( aa = 0; aa < numImages ; aa += 1 )
				
		imagestats/m=2/q/g={aa,aa,0,itemsinlist( listFiles, ";" )-1} avgintROItable
	
		avgintROIwave[ aa ] = V_avg
		sdevROIwave[ aa ] = V_sdev
		
	endFor	
	
	dowindow/k graph1
	newimage/f /n=graph1  ImageAccW
	
	ImageSave/O/F/T="TIFF"/p=path1 ImageAccW as "ImageAccW.tif"
	
	Note avgintROItable , "ROI coords x1, x2,y1,y2: "+num2str(x1)+", "+num2str(x2)+", "+num2str(y1)+", "+num2str(y2)
	
	Save/C/O/p=path1 avgintROItable as "avgintROItable.ibw"
	Save/C/O/p=path1 avgintROIwave as "avgintROIwave.ibw"
	Save/C/O/p=path1 sdevROIwave as "sdevROIwave.ibw"

end