#pragma rtGlobals=3		// Use modern global access method and strict wave access.
#pragma ModuleName = tracesAnalyzer7

// image registration build on this text: http://bigwww.epfl.ch/publications/thevenaz9801.pdf

function regisrationThresholdIma_TA_MT( ctrlName ) :BUTTONCONTROL
	string ctrlName
	// local variables
	variable DVorDCToggle		  // dual-view or dual-cam set-up.
	variable orentationDV		  // dual-view orientation horizontal - 1, vertical - 2
	variable typeOfImageFile 	 // 1 - tiff file, 2 - signed 32-bit image
	variable swapChToggle 	 // 1 - align 2nd to first, 2 - align 1st to 2nd.
	variable alignScheme 		 // 0 - align 1st to first ch, 1 - align 2nd to 2nd, align 1st to 2nd.
	variable numCh			// number of folders with images.
	// local variables and string
	string imageNameList1 = ""
	string subFolderList = ""
	string subSubFolderList = ""
	variable aa, bb
	variable thVal1, thVal2, stopValue
	variable numImages = 1
	variable alexToggle = 1
	variable increase = -1
	variable startCh1 = 0, startCh2 =0
	variable threshCh1, threshCh2
	// set a path where the dual-view calibaration image sits
	newpath/q /z /o /m="navigate to the main folder" path0
	if( V_flag != 0 )
		abort
	endif
	// ask for parameters
	prompt DVorDCToggle, "Image set-up: ", popup, "dual-view;dual-camera;"
	prompt orentationDV, "Orientation of dual-view: ", popup, "Horizontal;vertical;"
	prompt typeOfImageFile, "Type of image file: ", popup, "Tiff stack;Signed 32-bit binary;Tiff series;"
	prompt swapChToggle, "Alignment scheme: ", popup, "Align 2nd channel to 1st;Align 1st channel to 2nd;"
	prompt alignScheme, "What images to use: ", popup, "1st channel image for 1st and 2nd;2nd channel image for 1st and 2nd;1st channel for 1st and 2nd channel for 2nd;"
	prompt numCh, "Which folder with images per position to use", popup, "1st;2nd;both;"
	prompt numImages, "How many images to load from sub-sub-folder?"
	prompt alexToggle, "Excitation type:", popup, "ALEX;Single laser;"
	prompt threshCh1, "Threshold ch1"
	prompt threshCh2, "Threshold ch2"
	doprompt "Choose", DVorDCToggle, orentationDV, typeOfImageFile, swapChToggle, alignScheme, numCh, numImages, alexToggle, threshCh1, threshCh2
	if( V_flag != 0 )
		abort
	endif
	//
	print "*********************************************************"
	print "Images will be aligned using these parameters:"
	print "Image set-up: "+stringfromlist( DVorDCToggle-1, "dual-view;dual-camera;", ";" )
	print "Orientation of dual-view: "+stringfromlist( orentationDV-1, "Horizontal;vertical;", ";" )
	print "Type of image file: "+stringfromlist( typeOfImageFile-1, "Tiff stack;Signed 32-bit binary;Tiff series;", ";" )
	print "What images to use: "+stringfromlist( alignScheme-1, "1st channel image for 1st and 2nd;2nd channel image for 1st and 2nd;1st channel for 1st and 2nd channel for 2nd;", ";" )
	print stringfromlist( alexToggle-1, "ALEX;Single laser;", ";" ), ": excitation type."
	print stringfromlist( numCh-1, "1st;2nd;both;", ";" ), ": which folder with images per position to use"
	print numImages, ": number of image in sub-sub-folder."
	print threshCh1, threshCh2, "; threshold ch1, ch2."
	print "*********************************************************"
	//
	subFolderList = indexedDir( path0, -1, 0 )  // all subfolders names in the main directory.
	print subFolderList
	//
	if( alexToggle == 1 )
		increase = 2
		startCh1 = 1
		startCh2 = 0
	else
		increase = 1
		startCh1 = 0
		startCh2 = 0
	endif
	//
	make/o/n=( numImages, itemsinlist( subfolderList, ";" ) ) ch1Left_AvgWave, ch1Rigth_AvgWave
	make/o/n=( numImages, itemsinlist( subfolderList, ";" ) ) ch2Left_AvgWave, ch2Rigth_AvgWave
	// run through each of the subfolder
	for( aa = 0 ; aa < itemsinlist( subfolderList, ";" ) ; aa += 1 )
		// *******   define paths to subSubFolders   ********
		print aa+1, ": # of subFolder."
		//
		pathinfo path0; 	newpath/o path0a,  s_path+stringfromlist( aa, subFolderList, ";" )
		subSubFolderList = SortList( indexedDir( path0a, -1, 0 ), ";", 16 ); 		print subSubFolderList, ": subSubFolderList"
		if( numCh == 1 )
			pathinfo path0a; 	newpath/o path1,  s_path+stringfromlist( 0, subSubFolderList, ";" )		// path to the first suSubFolder
			pathinfo path0a; 	newpath/o path2,  s_path+stringfromlist( 0, subSubFolderList, ";" )		// path to the second suSubFolder
		elseif( numCh == 2 )
			pathinfo path0a; 	newpath/o path1,  s_path+stringfromlist( 1, subSubFolderList, ";" )		// path to the first suSubFolder
			pathinfo path0a; 	newpath/o path2,  s_path+stringfromlist( 1, subSubFolderList, ";" )		// path to the second suSubFolder		
		else
			pathinfo path0a; 	newpath/o path1,  s_path+stringfromlist( 0, subSubFolderList, ";" )		// path to the first suSubFolder
			pathinfo path0a; 	newpath/o path2,  s_path+stringfromlist( 1, subSubFolderList, ";" )		// path to the second suSubFolder		
		endif
		//
		// ******    load image from the first suSubFolder    **********
		// identify name of image file in the directory 
		imageNameList1 = IndexedFile( path1, -1, "????" );	 imageNameList1= RemoveFromList(".DS_Store", imageNameList1, ";" )	
		imageNameList1 = sortlist( imageNameList1,";" , 16 )
		print stringFromList( 0 , imageNameList1 , ";" ), ": name of image file for dual-view calibration in the first subSubFolder."
		// average several images
		for( bb = startCh1; bb < numImages ; bb += increase )
			// load image file
			wave/z localImage = $StringFromList(0, loadImage_TA_MT( imageNameList1, bb, 1, typeOfImageFile , 0 ),";")
			//
			imagestats/q /g={0,255,0,512} localImage
			ch1Left_AvgWave[bb][aa] = V_avg
			imagestats/q /g={256,512,0,512} localImage
			ch1Rigth_AvgWave[bb][aa] = V_avg
			// apply threshold
			localImage[][] = localImage[p][q]<threshCh1 ? 0 : localImage[p][q]
			localImage /= abs( numImages * itemsinlist( subfolderList, ";" ) )
			//
			if( bb == startCh1 && aa == 0 ) 
				duplicate/o localImage, localImageAvg1
			else
				localImageAvg1 += localImage
			endif
			//
		endFor
		//
		// ******    load image from the second suSubFolder    **********
		// identify name of image file in the directory 
		imageNameList1 = IndexedFile( path2, -1, "????" );	 imageNameList1= RemoveFromList(".DS_Store", imageNameList1, ";" )	
		imageNameList1 = sortlist( imageNameList1,";" , 16 )
		print stringFromList( 0 , imageNameList1 , ";" ), ": name of image file for dual-view calibration in the second subSubFolder."
		// average several images
		for( bb = startCh2; bb < numImages ; bb += increase )
			// load image file
			wave/z localImage = $StringFromList(0, loadImage_TA_MT( imageNameList1, bb, 2, typeOfImageFile, 0 ),";")
			//
			imagestats/q /g={0,255,0,512} localImage
			ch2Left_AvgWave[bb][aa] = V_avg
			imagestats/q /g={256,512,0,512} localImage
			ch2Rigth_AvgWave[bb][aa] = V_avg	
			// apply threshold
			localImage[][] = localImage[p][q]<threshCh2 ? 0 : localImage[p][q]
			localImage /= abs( numImages * itemsinlist( subfolderList, ";" ) )
			//
			if( bb == startCh2 && aa == 0 ) 
				duplicate/o localImage, localImageAvg2
			else
				localImageAvg2 += localImage
			endif
			//
		endFor
		//
	endFor
	// dual-view or dual-cam set-up images
	if( DVorDCToggle == 1 ) // dual-view
		// crop two channels
		if( orentationDV == 1 ) 		// dual-view horizontal
			if( alignScheme == 1 )		// 1st to first
				duplicate/o /r =[ *, * ][ 0, round( dimsize( localImage, 1 ) * 0.5 ) - 1 ] localImageAvg1, image1st; wave image1st
				duplicate/o /r =[ *, * ][ 0, round( dimsize( localImage, 1 ) * 0.5 ) - 1 ] localImageAvg2, image2nd; wave image2nd		
			elseif( alignScheme == 2 )	// 2nd to 2nd
				duplicate/o /r =[ *, * ][ round( dimsize( localImage, 1 ) * 0.5 ), * ] localImageAvg1, image1st; wave image1st
				duplicate/o /r =[ *, * ][ round( dimsize( localImage, 1 ) * 0.5 ), * ] localImageAvg2, image2nd; wave image2nd		
			else						// 1st to 2nd
				duplicate/o /r =[ *, * ][ 0, round( dimsize( localImage, 1 ) * 0.5 ) - 1 ] localImageAvg1, image1st; wave image1st
				duplicate/o /r =[ *, * ][ round( dimsize( localImage, 1 ) * 0.5 ), * ] localImageAvg2, image2nd; wave image2nd
			endif
		else						// dual-view vertical
			if( alignScheme == 1 )		// 1st to first
				duplicate/o /r =[ 0, round( dimsize( localImage, 0 ) * 0.5 ) - 1 ][ *, * ] localImageAvg1, image1st; wave image1st
				duplicate/o /r =[  0, round( dimsize( localImage, 0 ) * 0.5 ) - 1 ][ *, * ] localImageAvg2, image2nd; wave image2nd		
			elseif( alignScheme == 2 )	// 2nd to 2nd
				duplicate/o /r =[ round( dimsize( localImage, 0 ) * 0.5 ), * ][ *, * ] localImageAvg1, image1st; wave image1st
				duplicate/o /r =[ round( dimsize( localImage, 0 ) * 0.5 ), * ][ *, * ] localImageAvg2, image2nd; wave image2nd	
			else
				duplicate/o /r =[ 0, round( dimsize( localImage, 0 ) * 0.5 ) - 1 ][ *, * ] localImageAvg1, image1st; wave image1st
				duplicate/o /r =[ round( dimsize( localImage, 0 ) * 0.5 ), * ][ *, * ] localImageAvg2, image2nd; wave image2nd
			endif
		endif
	else		// dual-camera.
		//
		if( alignScheme == 1 )		// 1st to first
			duplicate/o localImageAvg1, image1st
			duplicate/o localImageAvg1, image2nd
		elseif( alignScheme == 2 ) 	// 2nd to 2nd
			duplicate/o localImageAvg2, image1st
			duplicate/o localImageAvg2, image2nd	
		else						// 1st to 2nd
			duplicate/o localImageAvg1, image1st
			duplicate/o localImageAvg2, image2nd		
		endif
		//
	endif
	//**************************************************************
	// let used to adjust the thresholds.
	duplicate/o image1st, localImageAvg1_copy, temp1
	duplicate/o image2nd, localImageAvg2_copy, temp2
	dowindow/k graph1; 	dowindow/k graph2
	newimage/f /n= graph1 temp1
	newimage/f /n= graph2 temp2
	execute/Q/Z "TileWindows/G=5/A=(1,1)/W=(0,0,450,470) Graph1"
	execute/Q/Z "TileWindows/G=5/A=(1,1)/W=(500,0,950,470) Graph2"
	wavestats/q temp1; 	thVal1 = V_avg;	thVal2 = V_avg
	//
	do
		//
		ImageThreshold /i /m=0  /q /t=(thVal1) localImageAvg1_copy; wave M_ImageThresh
		duplicate/o M_ImageThresh, temp1
		ImageThreshold /i /m=0  /q /t=(thVal2) localImageAvg2_copy; wave M_ImageThresh
		duplicate/o M_ImageThresh, temp2
		//
		ModifyImage/w=graph1 temp1 ctab= {0,100,Grays,0}
		ModifyImage/w=graph2 temp2 ctab= {0,100,Grays,0}
		doUpdate
		//
		prompt stopValue, "Threshold is good?", popup, "yes;no"
		doprompt "Choose", stopValue
		//
		if( V_flag == 1 )
			dowindow/k graph1; dowindow/K graph2
			abort
		endif
		//
		if( stopValue == 1 )
			break
		else
			//
			prompt thVal1, "Threshold is of the first ch."
			prompt thVal2, "Threshold is of the second ch."
			doprompt "Enter values", thVal1, thVal2
			//
			if( V_flag == 1 )
				dowindow/k graph1; dowindow/K graph2
				abort
			endif
			//
		endif
		//
	while(1)
	dowindow/k graph1; dowindow/k graph2
	//*******************************************************************
	// threshold images and detect spots with given parameters
	// 1st channel
	print thVal1, ": threshold value ch1, "+num2str(thVal2)+": threshold value ch2."
	ImageThreshold /i /m=0  /q /t=(thVal1) image1st; wave M_ImageThresh;						duplicate/o M_ImageThresh, image1st_thresh
	ImageAnalyzeParticles/m=3 /Q /A=(0.1)/E stats image1st_thresh;	wave M_Particle;	duplicate/o M_Particle, image1st_particle
	// 2nd channel
	ImageThreshold /i /m=0  /q /t=(thVal2) image2nd; 								duplicate/o M_ImageThresh, image2nd_thresh
	ImageAnalyzeParticles/m=3 /Q /A=(0.1)/E stats image2nd_thresh; 	duplicate/o M_Particle, image2nd_particle	
	// the following operation accepts single precision float point images
	redimension /s image1st_particle; 	redimension /s image2nd_particle; 
	//  The operation adjusts the test image wave, to match the reference image wave
	// short explanation of the flags:
	// /MSKC=  mask combination - and,
	// /REFM /TSTM - masks of refernce and test images are first blank, then every pixel is taken into account,
	// /ASTP adaptation step for the Levenberg-Marquardt algorithm.
	// /STRT first value of the adaptation parameter in the Levenberg-Marquardt algorithm.
	// /INTR interpolation method, Tricubic.
	// /FLVL	Specifies the finest level on which the optimization is to be performed
	// /TRNS - translation in x and y is enabled
	// /MING - minimal gain at which computation stops
	// /SKEW - skewness in x and y directions is enabled
	// /CONV - convergence method = Marquardt.
	// /ROT - rotation in all directions is dissabed.
	if( swapChToggle == 1 )
		ImageRegistration /MSKC=2 /REFM=0 /TSTM=0 /ASTP=3 /STRT=20 /INTR=2 /FLVL=2 /TRNS={1,1,0} /MING=0 /SKEW={1,1,0} /CONV=1 /ROT={0,0,0} /Q refWave= image1st_particle, testWave= image2nd_particle
	else
		ImageRegistration /MSKC=2 /REFM=0 /TSTM=0 /ASTP=3 /STRT=20 /INTR=2 /FLVL=2 /TRNS={1,1,0} /MING=0 /SKEW={1,1,0} /CONV=1 /ROT={0,0,0} /Q refWave= image2nd_particle, testWave= image1st_particle
	endif
	// output waves of imageRegistration
	wave M_RegOut; 	duplicate/o M_RegOut, outW; 	wave W_RegParams
	//
	print W_RegParams[0], W_RegParams[1], ": translation in x and y directions."
	print  W_RegParams[3], W_RegParams[4], W_RegParams[6], W_RegParams[7], ": Elements in the skewing transformation matrix ( a11, a12, a21, a22)."
	print W_RegParams[20], "mean square error."
	duplicate/o W_RegParams, W_RegParams_man
	// make a folder inside the input image folder
	pathinfo path0
	newpath /c /q /z /o path0a,   S_path+"results_imageAlign:"; print S_path+"results_imageAlign:", ": results saved here."
	// save output images into the newly made folder.
	ImageSave/O /F /T="TIFF" /p=path0a image1st as "1stCh_split.tif"
	ImageSave/O /F /T="TIFF" /p=path0a image2nd as "2ndCh_split.tif"	
	ImageSave/O /F /T="TIFF" /p=path0a image1st_particle as "1stCh_processed.tif"
	ImageSave/O /F /T="TIFF" /p=path0a image2nd_particle as "2ndCh_processed.tif"
	if( swapChToggle == 1 )
		ImageSave/O /F /T="TIFF" /p=path0a outW as "2ndCh_alligned.tif"
	else
		ImageSave/O /F /T="TIFF" /p=path0a outW as "1stCh_alligned.tif"
	endif
	Save/G/M="\r\n"/O/U={1,0,1,0}/P=path0a W_RegParams_man as "regParams.txt"
	//
	killwaves/z image1st, image2nd, image1st_thresh, image2nd_thresh, image1st_particle, image2nd_particle, W_RegParams_man, localImageAvg2, localImageAvg1
	killstrings/z imageNameList1, subFolderList, subSubFolderList
	killVariables/z aa, bb
	killpath/z path0
	killpath/z path0a
	//
end

Function/wave alignImage_paramsGIven_TA_MT( imW, parmW  )
	wave imW
	wave parmW
	//
	redimension /s imW, imW
	ImageRegistration /USER= parmW /MSKC=2 /REFM=0 /TSTM=0 /ASTP=3 /STRT=20 /INTR=2 /FLVL=2 /TRNS={1,1,0} /MING=0 /SKEW={1,1,0} /CONV=1 /ROT={0,0,0} /Q  testWave = imW, refWave = imW
	wave M_RegOut
	return M_RegOut
	//	
end