#pragma rtGlobals=1		// Use modern global access method.
#pragma ModuleName = tracesAnalyzer10

// botton control functio nfor initialization many movies analysis.
//1.  Define the main directory in which folders of single bleaching movie are stored
//2. Structure of folders in the main directory: E.g. 0_file, 1_file....etc.
//3. Structure of the subfolders:. E.g. 0_membraneImages, 1_proteinImages
// last update: 05 - 06 - 12 	- procedure kills all the locals in the begining of each function and in the end of it.
// last update: 07 - 06 - 12 	- concatenates results tables of each movie into the signed integer type tables

function manyMoviesAnalysis( ctrlName ) : BUTTONCONTROL
	String ctrlName
	//
	Struct TA_preferences TAPrefs
	load_preferences_TA_MT( TAPrefs )
	// local variables/ strings
	variable analComb = 1, numFolders,  loopCounter1 = 0 , indLoop = 0, concatToggle = 0, cycleCount, saveMovieToggle = 1, signalTypeToggle = 1 
	string subFoldersList,  subFolder, subSubFolder, subSubFolderList, fileName, resFolderName, listOfFolders = "", nameTable = ""
	// ckeck which button was clicked: analyse or combine.
	strswitch(ctrlName)
		//
		case "button1":	// analyse data
			analComb = 1
			break
			//
		case "button2":	// combine result tables
			analComb = 2
			break
			//
	endswitch
	// define main directory
	if( analComb == 1 )
		killPath/z mainPath
		NewPath/M="Define main directory, containg all movies"/Q/Z mainPath
		if( V_flag != 0 )
			abort "Path was not defined."
		endif
		//
		subFoldersList =  IndexedDir( mainPath, -1, 1 )
		numFolders = itemsInList( subFoldersList, ";" );
		//
	endif
	// define directory for storing results folders
	killPath/z resPath
	NewPath/M="Define results directory"/Q/Z resPath
	if( V_flag != 0 )
		abort "Path was not defined."
	endif
	// define threshold for each single movie
	if( analComb == 1 )
		// ********************************		main loop , where analysis of all movie one by one takes place
		print "***************   Analysis of multiple movies initiated   ************"
		print num2str( numFolders ), ": # of folders in the main directory"
		//
		for( loopCounter1 = 0 ; loopCounter1 < numFolders ; loopCounter1 += 1 )
			// print progress message
			print "********   analysis of movie #  "+num2str(loopCounter1 + 1)
			//********************************************************************************************
			// make a path to subfolder
			subFolder = stringFromList( loopCounter1, subFoldersList )
			NewPath/o/Q/Z subPAth , subFolder
			// make a list of subsubfolders in the current subfolder
			subSubFolderList = sortList(  IndexedDir( subPAth , -1 , 1 ), ";", 16 )
			//*****************************************************************************************
			// define paths to folders containing image series
			if( TAPrefs.imageTypeTA[4] == 1 ) 			// 1st folder contains image series
				//
				subSubFolder = stringFromList(  0 , subSubFolderList, ";" )
				NewPath/o/Q/Z path1, subSubFolder
				print "1st channel path: " + subSubFolder  
				//
				subSubFolder = stringFromList(  0 , subSubFolderList, ";" )
				NewPath/o/Q/Z path2, subSubFolder
				print "2nd channel path: " + subSubFolder 
				//
			elseif( TAPrefs.imageTypeTA[4] == 2 )		// 2nd folder contains image series
				//
				subSubFolder = stringFromList(  1 , subSubFolderList, ";" )
				NewPath/o/Q/Z path1, subSubFolder
				print "1st channel path: " + subSubFolder  
				//
				subSubFolder = stringFromList(  1 , subSubFolderList, ";" )
				NewPath/o/Q/Z path2, subSubFolder
				print "2nd channel path: " + subSubFolder 
				//
			elseif( TAPrefs.imageTypeTA[4] == 3 )		// 3rd folder contains image series
				//
				subSubFolder = stringFromList(  0 , subSubFolderList, ";" )
				NewPath/o/Q/Z path1, subSubFolder
				print "1st channel path: " + subSubFolder  
				//
				subSubFolder = stringFromList(  1 , subSubFolderList, ";" )
				NewPath/o/Q/Z path2, subSubFolder
				print "2nd channel path: " + subSubFolder 
				//
			endif
			// excitation profile path
			if( TAPrefs.normaliseToggle == 1  )		// normalisation switched on
				subSubFolder = stringFromList(  TAPrefs.normFolder - 1 , subSubFolderList, ";" )
				NewPath/o/Q/Z path3, subSubFolder
				print "Excitation profile path: " + subSubFolder
			elseif( TAPrefs.normaliseToggle == 2  )	// normalisation switched off
				print "Excitation profile path: none - normalisation disabled." 
			endif
			//  a path for results subfolder
			resFolderName = stringfromlist( itemsinlist(subFolder,":")-1 , subFolder , ":" )
			PathInfo resPath	; 	newPath/q/C/o path4, S_Path+resFolderName+"_results"
			pathinfo path4; 		print "Results path: " + S_Path
			//************************************************************************************************** 	
			// 	detect spots.
			if( TAPrefs.partsAnalysis[ 0 ] == 1 )
				CP_TA_MT( "string1" )
			endif
			// 	extract traces.
			if( TAPrefs.partsAnalysis[1] == 1 )
				PM_TA_MT( "string1" )
			endif
			//		auto select traces
			if( TAPrefs.partsAnalysis[5] == 1)
				TEclusionAuto_TA_MT("string1")
			endif	
			// 	detect ICP.
			if( TAPrefs.partsAnalysis[3] == 1)
				ICPdet_TA_MT( "string1" )
			endif		
			//		characterize detected states
			if( TAPrefs.partsAnalysis[4] == 1)
				TEclusion_TA_MT("string1")
			endif
			//
		endFor
		//
	elseif( analComb == 2 )
		//
		print "***************   Concatenation of results tables from multiple movies initiated   ************"
		//
		print num2str( itemsInList( IndexedDir( resPath , -1 , 1 ), ";" ) ), ": # of folders in the results directory"
		// sort folder names alphanumerically
		listOfFolders = sortlist( IndexedDir( resPath , -1 , 1 ) , ";", 16 )
		// remove concatenatedTables folder from the list of folders
		loopCounter1 = 0
		do
			if( StringMatch( stringFromList( loopCounter1, listOfFolders, ";" ),  "*concatenatedTables*" ) == 1 )
				//print stringFromList( loopCounter1, listOfFolders, ";" ), ": this folder was removed from conatenated folder list."
				listOfFolders = RemoveListItem( loopCounter1 , listOfFolders, ";" )
			else
				loopCounter1 += 1
			endif
			//
			if( loopCounter1 >= itemsinlist(listOfFolders, ";" ) )
				break
			endif
			//
		while( 1 )
		// reset values of counters to null
		TAPrefs.manyMovVar[0] = 0; 		TAPrefs.manyMovVar[1] = 0
		// ask whic tables concatenate, containing: icp or traces 
		prompt concatToggle, "Table to concatenate", popup, "State info;Traces;"
		prompt nameTable, "Common fraction of table name to concat."
		doprompt "Slect", concatToggle, nameTable
		if( V_flag == 1 )
			abort
		else
			print nameTable, ": common fraction of table name to be concatenated."
			print stringfromlist(concatToggle-1,"State info;Traces;",";"), ": type of table to concatenate."
		endif
		//
		if( V_flag == 0 && concatToggle == 1 )  // concatenating ICP tables
			//
			make/o/n=(0,0) icpTable_full
			cycleCount = 0;	loopCounter1 = 0
			//
			for( loopCounter1 = 0 ; loopCounter1 < itemsInList( listOfFolders, ";" ) ; loopCounter1 += 1 )
				//
				if( StringMatch( stringFromLisT( loopCounter1, listOfFolders ), "*concatenatedTables*" ) == 0 )
					// report status of concatenation of results tables
					//print "Combining ICP tables for movie: " +num2str( loopCounter1 + 1 )+ " from: "+num2str( itemsInList( IndexedDir( resPath , -1 , 1 ), ";" ) )
					// access the directory of results from movie # loopCounter1
					NewPath/O/Z/q path4, stringFromLisT( loopCounter1, listOfFolders );		pathinfo path4;		//print "Results foder no. "+num2str( loopCounter1 + 1 )+": " + S_Path
					// icp table SM states
					loadAndConcatenate( icpTable_full, "*"+nameTable+"*", 0, cycleCount );			//print dimsize( icpTable_full, 0 ), ": size of concatenated ICP table"
					//
					cycleCount += 1
					//
				else
					//print "this was a concatenated table folder, therefore tables were not taken for concatenation."
				endif
				//
			endFor
			// make a new directory in the main directory for storing concatenated tables
			pathInfo resPath
			NewPath/C/O/Z/q path4, S_path+"concatenatedTables"
			// saving concatenated tables into the new directory
			Save/C/O/P=path4 icpTable_full as nameTable+"icpTable_full.ibw"
			//
		elseif( V_flag == 0 && concatToggle == 2 )  // concatenating traces tables
			//
			make/o/n=(0,0)  trTable_full
			cycleCount = 0
			//
			for( loopCounter1 = 0 ; loopCounter1 < itemsInList( listOfFolders, ";" ) ; loopCounter1 += 1 )
				//
				if( StringMatch( stringFromLisT( loopCounter1, listOfFolders ), "*concatenatedTables*" ) == 0 )
					// report status of concatenation of results tables
					//print "Combining traces tables for movie: " +num2str( loopCounter1 + 1 )+ " from: "+num2str( itemsInList( IndexedDir( resPath , -1 , 1 ), ";" ) )
					// access the directory of results from movie # loopCounter1
					NewPath/O/Z/q path4, stringFromLisT( loopCounter1, listOfFolders );		pathinfo path4;		//print "Results foder no. "+num2str( loopCounter1 + 1 )+": " + S_Path
					// filtered traces of SM
					loadAndConcatenate( trTable_full, "*"+nameTable+"*", 1, cycleCount );			//print dimsize( trTable_full, 1 ), ": size of concatenated trajectories table"
					//
					cycleCount += 1
					//
				else
					//print "this was a concatenated table folder, therefore tables were not taken for concatenation."
				endif
				//
			endFor
			// make a new directory in the main directory for storing concatenated tables
			pathInfo resPath
			NewPath/C/O/Z/q path4, S_path+"concatenatedTables"
			// saving concatenated tables into the new directory
			Save/C/O/P=path4 trTable_full as nameTable+"trTable_full.ibw"
			//
		endif
		//
		print "Tables concatenated."
		//
	endif
	// releasing memory occupied by local variables
	KillWaves/z/a; killStrings/a/z; killVariables/z/a
	//
end
//	
function loadAndConcatenate( inWave2 , matchText , dim1, firstToggle )
	wave inWave2	// wave name to concatenate into
	string matchText	// string from loading wave
	variable dim1		// dimensions for redimensioning of both tables
	variable firstToggle
	// local variables
	variable aa, bb
	//
	string fileName =  ListMatch( (indexedFIle ( path4 , -1 , ".ibw" )) , matchText )
	if( itemsInList(fileName,";") != 1 )
		pathinfo path4
		print s_path, "misses the specified file."
		abort
	endif
	LoadWave/H/O/N = wave0/P = path4/Q stringFromList( 0, fileName, ";" )
	duplicate/o $stringFromList( 0, S_wavenames, ";" ), wave1
	//print stringFromList( 0, S_wavenames, ";" ), ": name of the loaded wave"
	if( firstToggle == 0 )
		duplicate/o wave1, inWave2
	else
		//
		if( dim1 == 0 )	// fill rows
			//
			for( aa = 0 ; aa < dimSize( wave1, 0 ) ; aa += 1 )	// rows
				insertPoints/m = 0 dimsize(inWave2, 0 ) , 1, inWave2
				if( dimSize( inWave2, 1 ) > 1 )
					for( bb = 0 ; bb < dimSize( wave1, 1 ) ; bb += 1 )
						inWave2[ dimsize(inWave2, 0 ) - 1 ][ bb ] = wave1[ aa ][ bb ]
					endFor
				else
					inWave2[ dimsize(inWave2, 0 ) - 1 ] = wave1[ aa ]
				endif
				//
			endFor	
			//
		else // fill columns
			//
			for( aa = 0 ; aa < dimSize( wave1, 1 ) ; aa += 1 )	// rows
				insertPoints/m = 1 dimsize(inWave2, 1 ) , 1, inWave2
				for( bb = 0 ; bb < dimSize( wave1, 0 ) ; bb += 1 )
					//
					if( bb >= dimsize( inWave2, 0 ) )
						insertPoints/m=0 dimsize(inWave2,0), 1, inWave2
					endif
					//
					inWave2[ bb ][ dimsize(inWave2, 1 ) - 1 ] = wave1[ bb ][ aa ]
					//
				endFor
				//
			endFor	
			//
		endif
		//
	endif
	//
end