#pragma rtGlobals=1		// Use modern global access method.
#pragma ModuleName = tracesAnalyzer15
// function for 2D histogram plot drawing

function fabricate2DHistPlots(ctrlName):buttonControl
	string ctrlName
	//	clean the root directory
	killWaves/a/z; killStrings/a/z
	//
	print "********  2D plot procedure initiated   *******"
	//	local variables
	variable deltaT = 1, type2DPlot = 1, plotToggle = 1, numBins = 100, nBinsX, nBinsY, minInt, maxInt, normToggle
	string nameWave = "", nameWave1 = "", mapName = "", columnNames = ""
	variable xAxisNum = 0, yAxisNum = 0, aa = 0, bb = 0
	variable selectionWToggle = 0
	variable autoManSelect = 0
	variable useOldPathTog = 0
	variable indexResFolder = 0
	variable durThresh = 0
	variable lipIntMin, lipIntMax, lipChIndicator
	variable bleachedLevel, max1stGauss
	string subFolderList = ""
	//
	prompt useOldPathTog , "Redefine main results folder path", popup, "No;Yes;"
	Doprompt "Select", useOldPathTog
	if( V_flag == 1 )
		abort
	endif
	//
	if( useOldPathTog == 2 ) // redefine path
		// ask for a path to the main results folder
		newpath/o/m="Define main results directory" pathMainResults
		if( V_flag != 0 )
			abort "you did not selected the path"
		endif
	else
		pathinfo pathMainResults
		if( V_flag == 0 )
			// ask for a path to the main results folder
			newpath/o/m="Since path does not exist redefine main results directory" pathMainResults
		endif
	endif
	// make list of all these folders.
	subFolderList = indexedDir( pathMainResults, -1 , 0)
	// ask which of the folder to use for plots.
	prompt indexResFolder , "Which of the sub-folder to use", popup, subFolderList
	Doprompt "Select", indexResFolder
	if( V_flag == 1 )
		abort
	endif
	// define current results folder path
	pathinfo pathMainResults
	newpath/o path4, S_Path+stringfromlist(indexResFolder-1,subFolderList,";")
	// ask what type of plot to be drawn: 2D histogram / postsynch. traj.
	prompt plotToggle, "Type of plot", popup, "State info;Population traces;Stochiometry vs Efret;Population traces of given lip. size;"
	prompt deltaT, "Exposure time of CCD camera [s]"
	doPrompt "Select and enter value", plotToggle, deltaT
	if( V_flag == 1 )
		abort
	else
		print deltaT, ": exposure time of EMCCD camera"
		print stringfromlist( plotToggle - 1,   "State info;Population traces;Stochiometry vs Efret;Population traces of given lip. size;", ";") , ": type of plot."
	endif
	// wave names
	if( plotToggle != 3 )
		prompt nameWave, "unique fraction table's name to be loaded"
		doPrompt "Select and enter value", nameWave
		if( V_flag == 1 )
			abort
		else
			print nameWave, ": unique fraction of table's name."
		endif	
	else
		prompt nameWave, "unique fraction of Efret table's name  to be loaded"
		prompt nameWave1, "unique fraction od stochiometry table's name to be loaded"
		doPrompt "Select and enter value", nameWave, nameWave1
		if( V_flag == 1 )
			abort
		else
			print nameWave, ": unique fraction of Efret table's name."
			print nameWave1, ": unique fraction of stochiometry table's name."
		endif
	endif
	// in case of drawinf traces plots ask whther to load the acc/reject indicator wave
	if( plotToggle != 1 )
		prompt autoManSelect, "Selection of traces: ", popup, "Use accept/reject indicators;Selected fragments of trace;Use all traces"
		prompt selectionWToggle "Plot states or traces indicated by this tag"
		doPrompt "Select value", autoManSelect, selectionWToggle
		if( V_flag == 1 )
			abort
		endif
	endif
	// loading waves from a results folder
	wave loadedW = loadWMap_TA_MT( nameWave, nameWave1, autoManSelect, plotToggle )
	if( autoManSelect == 1 )
		wave accRejW_Tex
	elseif( autoManSelect == 2 )
		wave selFrTrW_Tex
	endif
	if( plotToggle == 3 )
		wave stochTable
	endif
	if( plotToggle == 4 )
		wave spotInfoTable
	endif
	// make plots
	if( plotToggle == 1 )  // 2D histogram plot
		// make a list with titles of columns in the loaded wave
		for( aa = 0 ; aa < dimSIze( loadedW, 1 ); aa += 1 )
			columnNames += GetDimLabel( loadedW, 1, aa )+";"
		endfor
		// adjust state duration by the exposure time
		loadedW[ ][ %dur ] *= deltaT
		// plot for SM states
		do
			aa = 1
			if( bb > 0 ) // start inquiring to stop or continue from second iteration.
				prompt aa, "draw a SM levels charcteristics map? " , popup , "yes;no"
				doPrompt "choose" ,  aa
				//
				if( V_flag == 1 )
					abort
				endif
			endif
			//
			if( aa == 1 )
				xAxisNum += 1
				yAxisNum += 1
				prompt xAxisNum , "x Axis",  popup, columnNames
				prompt yAxisNum , "y Axis", popup, columnNames
				prompt mapName, "Title of plot"
				prompt type2DPlot, "Type of state info plot", popup, "Pixelated;Gaussian;"
				prompt numBins, "# of bins for the state info plot."
				prompt durThresh, "State duration threshold"
				doPrompt "enter the value" ,  xAxisNum, yAxisNum, mapName, type2DPlot, numBins, durThresh
				// if cancel clicked
				if( V_flag == 1 )
					abort
				else
					if( xAxisNum == yAxisNum )
						abort "the same axis picked up twice."
					endif
					//
					xAxisNum -= 1
					yAxisNum -= 1
					// drawing a map
					MDF_TA_MT( loadedW, xAxisNum, yAxisNum, numBins, columnNames, mapName, type2DPlot, selectionWToggle, durThresh )
					doUpdate
					//
				endif
				//
			endif
			bb += 1
		while( aa < 2)
		//
	elseif( plotToggle == 2 ) // population traces plot
		// ask for values of input parameters for the postsynch. traj plot.
		prompt nBinsX, "# of X bins for the population traces plot."
		prompt nBinsY, "# of Y bins for the population traces plot."
		prompt minInt, "minimal Y axis value."
		prompt maxInt, "maximal Y axis value."
		prompt mapName, "Plot title"
		prompt normToggle, "Normalise trace", popup, "To avg. minimum;Double Gauss fit;No"
		doPrompt "Enter a values", nBinsX, nBinsY, minInt, maxInt, mapName, normToggle
		if( V_flag == 1 )
			abort
		else
			print mapName, ": plot title."
			print nBinsX, " :# of X bins for the overlaid traces plot."
			print nBinsY, " :# of Y bins for the overlaid traces. plot."
			print minInt, " :minimal Y axis value."
			print maxInt, " :maximal Y axis value"
			print stringfromlist(normToggle-1, "To avg. minimum;Double Gauss fit;No", ";"),  " : normalisation of signals"
			//
			if( normToggle == 1 )
				//
				prompt bleachedLevel, "max. int. of bleached part."
				doPrompt "Enter a values", bleachedLevel
				if( V_flag == 1 )
					abort
				else
					print bleachedLevel, ": max. int. of bleached part."
				endif
				//
			elseif( normToggle == 2 )
				//
				prompt bleachedLevel, "max. int. of bleached part."
				prompt max1stGauss, "max. int. of the first peak for Gauss fitting."
				doPrompt "Enter a values", bleachedLevel, max1stGauss
				if( V_flag == 1 )
					abort
				else
					print bleachedLevel, ": max. int. of bleached part."
					print max1stGauss, ": max. int. of the first peak for Gauss fitting."
				endif
				//			
			endif
			//
		endif
		// make the plot
		wave psTrajPlot = tr2DPlot_ta_mt( loadedW, nBinsX, nBinsY, minInt, maxInt, deltaT, normToggle, selectionWToggle, autoManSelect, bleachedLevel, max1stGauss );	wave trajTable, countSpotsPSP
		// add notes to the 2D plot
		note/k psTrajPlot , "# of X bins: "+num2str(nBinsX)+"; # of Y bins: "+num2str(nBinsY)+"; minimal Y axis value: "+num2str(minInt)+"; maximal Y axis value: "+num2str(maxInt)
		//
		duplicate/o psTrajPlot, $mapName
		//
		dowindow $"graph_"+mapName
		if( V_flag == 0 )	// there was no such a window
			newimage/f /n= $"graph_"+mapName $mapName
		else
			dowindow/f $"graph_"+mapName
		endif
		//
		wavestats/q $mapName
		ModifyImage $mapName ctab= {*,V_avg,Geo32,0}
		Label left "intensity, a.u.";	Label bottom "time, s"
		ModifyGraph margin(left)=28,margin(bottom)=28,margin(top)=28,margin(right)=85, fStyle=1
		ColorScale/C/N=text0 /A=RC /X=0 /Y=-3 /E=2 lblMargin=10, "Prob."
		TextBox/C/N=text1/A=MC /x=75 /y=50 "# of traces: "+num2str( countSpotsPSP[1] )
		setaxis left minInt, maxInt; setaxis bottom 0, deltaT* nBinsX
		//
		execute/z/q "tilewindows/a=(1,1)/w=(0,0,450, 380) "+"graph_"+mapName
		//
		doupdate
		//
	elseif( plotToggle == 3 ) // Stochiometry vs Efret
		// ask for values of input parameters for the postsynch. traj plot.
		prompt numBins, "# of bins for the stoch vs Efret plot."
		prompt mapName, "Plot title"
		doPrompt "Enter a values", numBins, mapName
		if( V_flag == 1 )
			abort
		else
			print numBins, "# of bins for the stoch vs Efret plot."
			print nBinsX, ": bin duration in frames."
			print mapName, "Plot title."
		endif
		// make the plot
		wave stochEfretPlot = SEfret2DPlot_ta_mt( loadedW, stochTable, numBins, selectionWToggle, autoManSelect );	wave countSpotsPSP
		//
		duplicate/o stochEfretPlot, $mapName
		//
		dowindow $"graph_"+mapName
		if( V_flag == 0 )	// there was no such a window
			newimage/f /n= $"graph_"+mapName $mapName
		else
			dowindow/f $"graph_"+mapName
		endif
		//
		wavestats/q $mapName
		ModifyImage $mapName ctab= {*,V_avg,Rainbow,1}
		Label left "Stochiometry";	Label bottom "Efret"
		ModifyGraph margin(left)=28,margin(bottom)=28,margin(top)=28,margin(right)=113, fStyle=1
		ColorScale/C/N=text0 /A=RC /X=5 /Y=-17 /E=2 lblMargin=10, "Prob."
		TextBox/C/N=text1/A=MC /y=50 /x=75 "# of traces: "+num2str( countSpotsPSP[1] )
		setaxis left -0.1, 1.1; setaxis bottom -0.1, 1.1
		//
		execute/z/q "tilewindows/a=(1,1)/w=(0,0,450, 380) "+"graph_"+mapName
		//
		doupdate
		//
	//
	elseif( plotToggle == 4 ) // population traces of given lip. size
		// ask for values of input parameters for the postsynch. traj plot.
		prompt nBinsX, "# of X bins for the overlaid traces plot."
		prompt nBinsY, "# of Y bins for the overlaid traces plot."
		prompt minInt, "minimal Y axis value."
		prompt maxInt, "maximal Y axis value."
		prompt lipIntMin, "Minimal liposome intensity"
		prompt lipIntMax, "Maximal liposome intensity"
		prompt lipChIndicator, "Liposome channel", popup, "1st;2nd;"
		prompt mapName, "Plot title"
		prompt normToggle, "Normalise to begining of trace", popup, "yes;no;"
		doPrompt "Enter a values", nBinsX, nBinsY, minInt, maxInt, mapName, normToggle,lipIntMin, lipIntMax,lipChIndicator
		if( V_flag == 1 )
			abort
		else
			print nBinsX, " :# of X bins for the overlaid traces plot."
			print nBinsY, " :# of Y bins for the overlaid traces. plot."
			print minInt, " :minimal Y axis value."
			print maxInt, " :maximal Y axis value"
			print lipIntMin, lipIntMax, lipChIndicator, " minimal, maximal liposome intensity (amp*width^2) and liposome channel indicator."
			print stringfromlist(normToggle, "Enabled;Disabled;", ";"),  " : normalisation of signals."
		endif
		// make the plot
		wave psTrajPlot = tr2DPlot_lipSize_ta_mt( loadedW, nBinsX, nBinsY, minInt, maxInt, deltaT, normToggle, selectionWToggle, autoManSelect , lipIntMin, lipIntMax, lipChIndicator );	wave trajTable, countSpotsPSP
		// add notes to the 2D plot
		note/k psTrajPlot , "# of X bins: "+num2str(nBinsX)+"; # of Y bins: "+num2str(nBinsY)+"; minimal Y axis value: "+num2str(minInt)+"; maximal Y axis value: "+num2str(maxInt)
		note  psTrajPlot , "min liposome int:"+ num2str(lipIntMin) + ", max liposome int:"+ num2str(lipIntMax) +", liposome ch:"+ num2str(lipChIndicator)
		//
		duplicate/o psTrajPlot, $mapName
		//
		dowindow $"graph_"+mapName
		if( V_flag == 0 )	// there was no such a window
			newimage/f /n= $"graph_"+mapName $mapName
		else
			dowindow/f $"graph_"+mapName
		endif
		//
		wavestats/q $mapName
		ModifyImage $mapName ctab= {*,V_avg,Rainbow,1}
		Label left "intensity, a.u.";	Label bottom "time, s"
		ModifyGraph margin(left)=28,margin(bottom)=28,margin(top)=28,margin(right)=85, fStyle=1
		ColorScale/C/N=text0 /A=RC /X=5 /Y=-17 /E=2 lblMargin=10, "Prob."
		TextBox/C/N=text1/A=MC /y=50 /x=75 "# of traces: "+num2str( countSpotsPSP[1] )
		setaxis left minInt, maxInt; setaxis bottom 0, deltaT* nBinsX
		//
		execute/z/q "tilewindows/a=(1,1)/w=(0,0,450, 380) "+"graph_"+mapName
		//
		doupdate
		//	
	endif
	// clean the memory from locals
	killStrings/a/z
	killWaves/z outW, icpTable_full, accRejW_Tex, xWave, yWave, trajIndexWave, durWave, histPlot, histPlotNStates, histPlotBinned
	killwaves/z limits, infoForPlot, hist1, tempWave, meanW
	//
end
// load required waves from the path4
function/wave loadWMap_TA_MT( nameWave, nameWave1, autoManSelect, plotToggle )
	//
	string nameWave, nameWave1
	variable autoManSelect, plotToggle
	//
	string fileName
	//
	if( autoManSelect == 1 ) // acc/reject trace indicators.
		//
		fileName = ListMatch( (indexedFIle ( path4 , -1 , ".ibw" )) , "*051*" )
		if( itemsinlist(fileName,";") <= 0 )
			abort
		endif
		LoadWave/H/O/P = path4/Q stringFromList( 0 , fileName, ";" )
		duplicate/o $stringFromlist( 0 , S_wavenames ), accRejW_Tex
		wave accRejW_Tex
		//
	elseif( autoManSelect == 2 ) // selected fragment indicators.
		//
		fileName = ListMatch( (indexedFIle ( path4 , -1 , ".ibw" )) , "*052*" )
		if( itemsinlist(fileName,";") <= 0 )
			abort
		endif
		LoadWave/H/O/P = path4/Q stringFromList( 0 , fileName, ";" )
		duplicate/o $stringFromlist( 0 , S_wavenames ), selFrTrW_Tex
		wave selFrTrW_Tex
		//
	endif
	//
	if( plotToggle == 3 )
		//
		fileName = ListMatch( (indexedFIle ( path4 , -1 , ".ibw" )) , "*"+nameWave1+"*" )
		if( itemsinlist(fileName,";") <= 0 )
			abort
		endif
		LoadWave/H/O/P = path4/Q stringFromList( 0 , fileName, ";" )
		duplicate/o $stringFromlist( 0 , S_wavenames ), stochTable
		wave stochTable
		//
		fileName = ListMatch( (indexedFIle ( path4 , -1 , ".ibw" )) , "*030_0_*" )
		if( itemsinlist(fileName,";") <= 0 )
			abort
		endif
		LoadWave/H/O/P = path4/Q stringFromList( 0 , fileName, ";" )
		duplicate/o $stringFromlist( 0 , S_wavenames ), eFRET_table
		wave eFRET_table
		//
	elseif( plotToggle == 4 )
		//
		fileName = ListMatch( (indexedFIle ( path4 , -1 , ".ibw" )) , "*"+nameWave+"*" )
		if( itemsinlist(fileName,";") <= 0 )
			abort
		endif
		LoadWave/H/O/P = path4/Q stringFromList( 0 , fileName, ";" )
		duplicate/o $stringFromlist( 0 , S_wavenames ), outW
		wave outW
		//
		fileName = ListMatch( (indexedFIle ( path4 , -1 , ".ibw" )) , "*040_*" ) // spot info table
		if( itemsinlist(fileName,";") <= 0 )
			abort
		endif
		LoadWave/H/O/P = path4/Q stringFromList( 0 , fileName, ";" )
		duplicate/o $stringFromlist( 0 , S_wavenames ), spotInfoTable
		wave spotInfoTable
		//			
	else
		//
		fileName = ListMatch( (indexedFIle ( path4 , -1 , ".ibw" )) , "*"+nameWave+"*" )
		if( itemsinlist(fileName,";") <= 0 )
			abort
		endif
		LoadWave/H/O/P = path4/Q stringFromList( 0 , fileName, ";" )
		duplicate/o $stringFromlist( 0 , S_wavenames ), outW
		wave outW
		//	
	endif
	//
	return outW
	//
end
//**************    2D histogram plot displaying function      ***********************
function MDF_TA_MT( inW , xAxis , yAxis, numStep, columns, outputMap, type2DPlot, selectionWToggle, durThresh )
	// inputWaves
	wave inW		// wave containing information about all the levels in traces
	//inputVariables
	variable xAxis , yAxis, numStep, type2DPlot, selectionWToggle, durThresh
	//input Strings
	string columns, outputMap
	// defining local variables
	variable windowInidcator = 0 , killVariable, bb = 0
	// making a map
	ISCM_TA_MT( numStep, xAxis, yAxis, columns, outputMap, inW, type2DPlot, selectionWToggle, durThresh )
	wave histPlot, infoForPlot, limits, histPlotBinned
	wave histTableX, histTableY
	// asking whether the window is present
	do
		doWindow $outputMap+"_Wind"
		// if the 	nameOfWindowInput    is present V_flag == 1
		if(V_flag == 1)
			// asking if user wants to kill the window
			killVariable = 2
			prompt killVariable , "Option: ", popup , "do not kill it;Kill the window"
			doPrompt " The window whit such a name exisist", killVariable
			// if cancell clicked
			if( V_flag == 1 )
				abort
			endif
			// else
			if(killVariable == 2)
				doWindow/k $outputMap+"_Wind"
			elseif(killVariable == 1)
				prompt outputMap, "window name"
				doPrompt " Enter other name for a window", outputMap
			endif
		elseif(V_flag == 0)
			windowInidcator = 1			
		endif
	while(windowInidcator < 1)
	// copy the 2D histogram plot
	duplicate/o histPlot, $outputMap
	duplicate/o histPlotBinned, $outputMap+"_binned"
	// showing map on the nameOfWindowInput   window and append all the histograms
	string wName = outputMap+"_Wind" 
	Display/n=$wName
	AppendImage/w=$wName $outputMap
	//
	for( bb = 0 ; bb < dimsize(histTableX, 1) ; bb += 1 )
		make/o/n=(dimsize(histTableX,0)) hist1 = histTableX[p][bb]
		wavestats/q hist1; hist1 /= V_sum
		CopyScales/I histTableX, hist1
		duplicate/o hist1, $"hist1_"+num2str(bb)+"_"+outputMap
		appendtograph/w=$wName /l=left1 $"hist1_"+num2str(bb)+"_"+outputMap
		ModifyGraph/w=$wName rgb($"hist1_"+num2str(bb)+"_"+outputMap)=(65535-abs(65535/dimsize(histTableX, 1)) * bb,0,0)
	endfor
	//
	for( bb = 0 ; bb < dimsize(histTableY, 1) ; bb += 1 )
		make/o/n=(dimsize(histTableY,0)) hist1 = histTableY[p][bb]
		wavestats/q hist1; hist1 /= V_sum
		CopyScales/I histTableY, hist1
		duplicate/o hist1, $"hist2_"+num2str(bb)+"_"+outputMap
		appendtograph/w=$wName /b=bottom1/vert $"hist2_"+num2str(bb)+"_"+outputMap
		ModifyGraph/w=$wName rgb($"hist2_"+num2str(bb)+"_"+outputMap)=(65535-abs(65535/dimsize(histTableY, 1)) * bb,0,0)
	endfor
	// apppend a binned 2D histogram for indication of # of trajectories per bin.
	AppendImage/w = $wName /L = left2 /B = bottom2 $outputMap+"_binned"
	ModifyGraph/w = $wName axisEnab(left2)={0.7,1},axisEnab(bottom2)={0.7,1}
	ModifyGraph/w = $wName tick(left2)=3,noLabel(left2)=2, tick(bottom2)=3,noLabel(bottom2)=2
	ModifyGraph/w = $wName freePos(left2)={0,bottom1},freePos(bottom2)={0,left1}
	ModifyGraph/w = $wName lblPos(left2)=35,lblPos(bottom2)=35, lblPosMode(left)=1, lblPosMode(left)=1
	ModifyImage/w = $wName $outputMap+"_binned" ctab= {*,*,Rainbow,1}
	ColorScale/c /n=text0_binned /f = 0 /b = 1 /a = rt /x = 0.00 /y = 0/e = 2 width = 7,height = 40, image = $outputMap+"_binned",lblMargin = -5,  "# of states"
	// arrange layout of the graph
	ModifyGraph /w = $wName axisEnab(left)={0,0.65},axisEnab(left1)={0.7,1}, freePos(left1)={limits[0],bottom}
	ModifyGraph /w = $wName axisEnab(bottom)={0,0.65},axisEnab(bottom1)={0.7,1}, freePos(bottom1)={limits[2],left}
	// set the margins right and adjust the size of graph
	modifyGraph /w = $wName margin(right)=70, margin(top)=28
	ModifyGraph /w = $wName mirror=0,standoff(left)=0,standoff(bottom)=0
	execute/z/q "tilewindows/a=(1,1)/w=(0,0,400,375)  "+wName
	//
	ModifyGraph /w = $wName lblPosMode(left1)=1, lblPosMode(bottom1)=1
	Label /w = $wName left1 "Probability";	 Label /w = $wName bottom1 "Probability"
	ModifyGraph /w = $wName grid(bottom)=1,gridRGB(bottom)=(34952,34952,34952), grid(left)=1,gridRGB(left)=(34952,34952,34952), zero(left1)=2,zero(bottom1)=1
	SetAxis /w = $wName /N=1 left1 0,*; SetAxis/w=$wName/N=1 bottom1 0,*
	// label axes
	label /w = $wName bottom stringFromList( xAxis, columns )
	label /w = $wName left stringFromList( yAxis, columns )
	// set colour scale of image plot
	wavestats/q $outputMap
	ModifyImage /w = $wName $outputMap ctab= {V_max/10,V_max,Geo32,0}			// colour scale of image: inverted rainbow
	ModifyImage /w = $wName $outputMap minRGB=(0,2,26214),maxRGB=0 	// colour before minimal level: light grey
	// adding color scale and information about # of particles and # of states included 
	TextBox /w = $wName/C/N=text1/E=2/A=MT/F= 0/x=-10/y=0 "# trajectories: "+num2str( infoForPlot[ 1 ] ) + ", # states: "+num2str( infoForPlot[ 0 ] )+", "+outputMap
	// add color scale to non normalized plot
	ColorScale /w = $wName/e=2/C/N=text0/A=RC/F = 0/B=1/H=0/X=0/Y=0 lblMargin=20,height=100, width=7, "%" 
	// release memory occupied by local variables and waves
	killVariables/z windowInidcator , killVariable
	//
end    // end of map displaying function
//**************   2D histogram plot making procedure      ************************
function ISCM_TA_MT( numStep, xAxis, yAxis, columns, mapName, inW1, type2DPlot, selectionWToggle, durThresh )
	// defining input
	wave inW1				// icp table
	variable numStep			// number of bins for 2D histogram plot
	variable xAxis, yAxis 		// index of   columns from which map will be drawn
	variable type2DPlot		// type of 2D hist plot: 1 - pixelated, 2  - gaussian
	variable selectionWToggle
	variable durThresh
	string columns, mapName	// labels of axis
	// defining local variables
	variable aa, bb, cc, pp			// counters for loops
	variable xCoord, yCoord	// coordinates of center position of point in the 2D histogram plot
	variable xCoord1, xCoord2	// x limits of the point in the 2d histogram plot
	variable yCoord1, yCoord2	// y limits of the point in the 2d histogram plot
	variable wGX, wGY		// width of Gauss for filling the 2D histogram plot
	variable amp1				// togle of normalisation to duration
	variable antiCorVar = 0
	variable trCount = 0
	variable minX, maxX, minY, maxY
	// crop waves from input table and limit # of trajectories included in the plots, if necessary
	make/o /n=( dimsize( inW1, 0 ) ) xWave = inW1[ p ][ xAxis ]
	make/o /n=( dimsize( inW1, 0 ) ) yWave = inW1[ p ][ yAxis ]
	make/o /n=( dimsize( inW1, 0 ) ) trajIndexWave = inW1[ p ][ %index ]
	make/o /n=( dimsize( inW1, 0 ) ) durWave = inW1[ p ][ %dur ]
	// asking for confirmation of minimal and maximal values for maps
	wavestats/q xWave; 	minX = V_min; maxX = V_max
	wavestats/q yWave;	minY = V_min; maxY= V_max
	// asking user to define limits of the axes and the error of point in x and y directions.
	if( type2DPlot == 1 ) 
		prompt minX, "xAxis("+stringFromList (xAxis, columns )+") min value"
		prompt maxX, "xAxis("+stringFromList( xAxis, columns )+") max value"
		prompt minY, "yAxis("+stringFromList( yAxis, columns )+") min value"
		prompt maxY, "yAxis("+stringFromList( yAxis, columns )+") max value"
		doPrompt "Enter values for 2D histograms" , minX, maxX, minY , maxY
	else
		prompt minX, "xAxis("+stringFromList (xAxis, columns )+") min value"
		prompt maxX, "xAxis("+stringFromList( xAxis, columns )+") max value"
		prompt wGX, "xAxis("+stringFromList( xAxis, columns )+") error value."
		prompt minY, "yAxis("+stringFromList( yAxis, columns )+") min value"
		prompt maxY, "yAxis("+stringFromList( yAxis, columns )+") max value"
		prompt wGY, "xAxis("+stringFromList( yAxis, columns )+") error value."
		doPrompt "Enter values for 2D histograms" , minX, maxX , wGX, minY , maxY, wGY
	endif
	// if cancel clicked
	if( V_flag == 1 )
		abort
	else // check entered values
		if( minX >= maxX )
			abort "minmal value of X axis cannot be higher that maximal"
		endif
		if( minY >= maxY )
			abort "minmal value of X axis cannot be higher that maximal"
		endif
		if(  type2DPlot != 1 )
			if( wGY <= 0 )
				abort "x width can not be lower or equal to 0"
			endif
			if( wGX <= 0 )
				abort "x width can not be lower or equal to 0"
			endif	
		endif
	endif
	// report values of parameters, which user entered.
	if( type2DPlot == 1 ) 
		print num2str(minX)+": minimal and "+num2str(maxX)+" maximal value of "+stringFromList (xAxis, columns )
		print num2str(minY)+": minimal and "+num2str(maxY)+" maximal value of "+stringFromList (yAxis, columns )
	else
		print num2str(minX)+": minimal and "+num2str(maxX)+" maximal value of "+stringFromList (xAxis, columns )+" axis, and error values: "+num2str( wGX)
		print num2str(minY)+": minimal and "+num2str(maxY)+" maximal value of "+stringFromList (yAxis, columns )+" axis, and error values: "+num2str( wGY)
	endif
	//
	print durThresh, ": duration threshold."
	// output 2D histogram plot
	make/o/n=( numStep, numStep ) histPlot = 0 
	make/o/n=( numStep, numStep ) histPlotNStates = 1
	make/o/n=( numStep, numStep ) histPlotBinned = 0
	// set scale for 2D histograms.
	setscale/i x, minX, maxX, histPlot, histPlotBinned, histPlotBinned
	setscale/i y, minY, maxY, histPlot, histPlotBinned, histPlotBinned
	//
	if( type2DPlot == 1 ) 
		note/k histPlot , num2str(numStep)+": # of bins; "+num2str(minX)+": minimal and "+num2str(maxX)+" maximal value of "+stringFromList (xAxis, columns )+", durThresh: "+num2str(durThresh)
	else
		note/k histPlot , num2str(numStep)+": # of bins; "+num2str(minY)+": minimal and "+num2str(maxY)+" maximal value of "+stringFromList (yAxis, columns )+" axis, and error values: "+num2str( wGY)+", durThresh: "+num2str(durThresh)
	endif
	// making index wave for xAxis and yAxis of the 2D histogram plot
	make/o/n=( numStep ) indexWave1 =  minX  +  ( ( ( maxX - minX )  / numStep ) * p )			// x grid wave
	make/o/n=( numStep ) indexWave2 =  minY  +  ( ( ( maxY - minY ) / numStep ) * p )				// y grid wave
	// additional information waves (comes as an output of the function)
	make/o /n = 4 limits = { minX, maxX, minY, maxY }	// limits of axes of the 2D histogram plot
	make/o /n = 0 trajInc							// number of trajectories included (can be repetitive)
	make/o /n = 2 infoForPlot = 0					// 0 - # of states, 1 - # of trajectories (without repetition)
	make/o /n = 7 w_coef
	//
	aa = 0
	prompt aa "Normalise to duration?", popup, "No;Yes"
	doprompt "Select one", aa
	if( V_flag == 0 )
		if( aa == 2 )
			amp1 = 1
			print "normalisation of 2D plot to state duration selected"
			note histPlot, "Normalised to state duration."
		elseif( aa == 1 )
			amp1 = 0
		endif
	else
		abort
	endif
	// fill 2d histogram plot
	for( aa = 0 ; aa < dimSize( xWave, 0 ) ; aa += 1 ) // walk throught each member of input wave pair
		// record number of different traces
		if( aa < dimSize( xWave, 0 ) - 1 )
			if( trajIndexWave[ aa ] != trajIndexWave[aa+1] )
				trCount += 1
			endif
		endif
		//
		if( numtype(xWave[ aa ]) == 0 && xWave[ aa ] >= minX && xWave[ aa ] < maxX && inW1[ aa ][ %dur ] > durThresh )
			if( numtype(yWave[ aa ]) == 0 && yWave[ aa ] >= minY && yWave[ aa ] < maxY  )
				//
				if( amp1 == 0 )  // non normalised to duration of state
					// find pixel of 2D histogram plot, to which the pair of points belong.
					FindLevel/P /Q indexWave1, xWave[ aa ] ; 	xCoord = round( V_LevelX  )
					//xCoord = findLEvelMT( indexWave1, xWave[ aa ] )
					FindLevel/P /Q indexWave2, yWave[ aa ] ; 	yCoord = round( V_LevelX  )
					//yCoord = findLEvelMT( indexWave2, yWave[ aa ] )
					// fill a pixel defined by xCoord and YCoord in the 2d histogram plot
					histPlotBinned[ xCoord ][ yCoord ] += 1
					// type of 2D histogram plot
					if( type2DPlot == 1 ) 			// pixelated
						// fill a pixel defined by xCoord and YCoord in the 2d histogram plot
						histPlot[ xCoord ][ yCoord ] += 1
						//
					else  // gaussian 2D histogram plot
						//
						w_coef = { 0, 1, xWave[aa], wGX, yWave[aa], wGY, 0 }
						// fill the 2D histogram plot with a 2D Gaussian
						// limits of the 2D Gaussian, find limits,
						// which were expressend in x or y axis values, in actual coordinates of the plot
						FindLevel/P /Q indexWave1, max( minX, xWave[ aa ] - wGX * 2 );	xcoord1 = floor(V_LevelX  )
						//xcoord1 = findLEvelMT( indexWave1, max( minX, xWave[ aa ] - wGX * 2 ) )
						FindLevel/P /Q indexWave1, min( maxX, xWave[ aa ] + wGX * 2 );	xcoord2 = ceil(V_LevelX  )
						//xcoord2 = findLEvelMT( indexWave1, min( maxX, xWave[ aa ] + wGX * 2 ) )
						FindLevel/P /Q indexWave2, max( minY, yWave[ aa ] - wGY * 2 );	ycoord1 = floor(V_LevelX  )
						//yCoord1 = findLEvelMT( indexWave2, max( minY, yWave[ aa ] - wGY * 2 ) )
						FindLevel/P /Q indexWave2, min( maxY, yWave[ aa ] + wGY * 2 );	ycoord2 = ceil(V_LevelX  )
						//yCoord2 = findLEvelMT( indexWave2,  min( maxY, yWave[ aa ] + wGY * 2 ) )
						// filling the 2D Gaussian into the 2D histogram plot.
						for( bb = xCoord1 ; bb < xCoord2 ; bb += 1 )
							//
							for( cc = yCoord1 ; cc < yCoord2 ; cc += 1  )
								//
								histPlot[bb][cc] += Gauss2D( w_coef, indexWave1[ bb ], indexWave2[ cc ] )
								//
								histPlotNStates[bb][cc] += 1
								//
							endFor
							//
						endFor	
						//
					endif
					// count number of trajectories included
					insertPoints/m=0 0, 1, trajInc
					trajInc[ 0 ] = trajIndexWave[ aa ]			
					// calculate number of states included
					infoForPlot[ 0 ] += 1
					//
				else
					// find pixel of 2D histogram plot, to which the pair of points belong.
					FindLevel/P /Q indexWave1, xWave[ aa ] ; 	xCoord = round( V_LevelX  )
					//xCoord = findLEvelMT( indexWave1, xWave[ aa ] )
					FindLevel/P /Q indexWave2, yWave[ aa ] ; 	yCoord = round( V_LevelX  )
					//yCoord = findLEvelMT( indexWave2, yWave[ aa ] )
					// fill a pixel defined by xCoord and YCoord in the 2d histogram plot
					histPlotBinned[ xCoord ][ yCoord ] += 1
					// type of 2D histogram plot
					if( type2DPlot == 1 ) 			// pixelated
						// fill a pixel defined by xCoord and YCoord in the 2d histogram plot
						histPlot[ xCoord ][ yCoord ] += abs( 1/ durWave[ aa ] )
						histPlotNStates[xCoord][yCoord] += 1
						//
					else  // gaussian 2D histogram plot
						//
						w_coef = { 0, 1/ durWave[ aa ], xWave[aa], wGX, yWave[aa], wGY, 0 }
						// fill the 2D histogram plot with a 2D Gaussian
						// limits of the 2D Gaussian, find limits,
						// which were expressend in x or y axis values, in actual coordinates of the plot
						FindLevel/P /Q indexWave1, max( minX, xWave[ aa ] - wGX * 2 );	xcoord1 = floor(V_LevelX  )
						//xcoord1 = findLEvelMT( indexWave1, max( minX, xWave[ aa ] - wGX * 2 ) )
						FindLevel/P /Q indexWave1, min( maxX, xWave[ aa ] + wGX * 2 );	xcoord2 = ceil(V_LevelX  )
						//xcoord2 = findLEvelMT( indexWave1, min( maxX, xWave[ aa ] + wGX * 2 ) )
						FindLevel/P /Q indexWave2, max( minY, yWave[ aa ] - wGY * 2 );	ycoord1 = floor(V_LevelX  )
						//yCoord1 = findLEvelMT( indexWave2, max( minY, yWave[ aa ] - wGY * 2 ) )
						FindLevel/P /Q indexWave2, min( maxY, yWave[ aa ] + wGY * 2 );	ycoord2 = ceil(V_LevelX  )
						//yCoord2 = findLEvelMT( indexWave2,  min( maxY, yWave[ aa ] + wGY * 2 ) )
						// filling the 2D Gaussian into the 2D histogram plot.
						for( bb = xCoord1 ; bb < xCoord2 ; bb += 1 )
							//
							for( cc = yCoord1 ; cc < yCoord2 ; cc += 1  )
								//
								histPlot[bb][cc] += Gauss2D( w_coef, indexWave1[ bb ], indexWave2[ cc ] )
								//
								histPlotNStates[bb][cc] += 1
								//
							endFor
							//
						endFor	
						//
					endif
					// count number of trajectories included
					insertPoints/m=0 0, 1, trajInc
					trajInc[ 0 ] = trajIndexWave[ aa ]			
					// calculate number of states included
					infoForPlot[ 0 ] += 1
					//
				endif
				//
			endif
			//
		endif
		//
	endFor
	//
	duplicate/o histPlot , histPlotRaw
	duplicate/o histPlotNStates, histPlotNStatesRaw
	// check for non-repeating trajectories
	for( bb = 0 ; bb + 1 < dimsize( trajinc,0) ; bb += 1 )
		if( trajinc[bb] != trajinc[bb+1] )	// new trajectory
			infoForPlot[ 1 ] += 1
		endif
	endFor
	// normalizing map for sum of z values
	if( amp1 == 0 )
		wavestats/q histPlot; histPlot /= V_sum;
	else
		histPlot[][] /= histPlotNStates[p][q]  // normalise to number of states per bin
	endif
	// make 1D histograms of this plot along both x and y axes.
	hist_1d_ta_mt( minX, maxX, minY, maxY, numStep, histPlot )
	wave histTableX, histTableY
	// release memory occupied by local variables and waves
	killVariables/z aa, bb, cc, minX, maxX , minY , maxY, wGX, wGY, xCoord, xCoord1, xCoord2, yCoord, yCoord1, yCoord2
	killWaves/z trajInc
	//
end  // end of map making procedure
//
function/D findLEvelMT( inWRuler, inVar )
	wave inWRuler
	variable inVar
	//
	variable pp, outVar
	//
	for( pp = 0 ; pp < dimSize(inWRuler, 0) ; pp += 1 )
		if( inWRuler[pp] > inVar )
			outVar = pp - 1
			break
		endif
	endFor
	//
	print outVar
	return outVar
	//			
end
//**************************************************
// stochiometry vs Efret 2D histogram plot
function/Wave SEfret2DPlot_ta_mt( inW, stochTable, numBins, selectionWToggle, autoManSelect )
	wave inW, stochTable
	variable numBins
	variable selectionWToggle, autoManSelect
	//
	duplicate/o inW, eFretTable
	//
	if( autoManSelect == 1 )
		wave accRejW_Tex
	else
		make/o /n = ( min( dimsize( eFretTable, 1 ), dimsize( stochTable, 1 ) ) ) accRejW_Tex = selectionWToggle
	endif
	// local variables
	variable aa, cc, gg, minAvg
	variable pointerX, pointerY
	variable maxVal = 3
	variable deltaInt = maxVal / numBins
	make/o /n = 2  countSpotsPSP = 0
	// make a 2D matrix
	make/o /n = ( numBins, numBins ) outW = 0
	make/o /n = ( numBins + 1 ) rulerInt = -0.1 + abs( deltaInt * p )
	//
	// normlise trace aa to the begining of it.
	// seach for minimal avg.
	for( aa = 0 ; aa < dimsize(stochTable,1) ; aa += 1 )
		for( gg = 0 ; gg + 10 < dimsize( stochTable, 0 )*0.3 ; gg += 1 )
			imagestats/q /g = {gg, gg+10, aa, aa } stochTable
			if( gg == 0 )
				minAvg = V_avg
			else
				if( V_avg < minAvg )
					minAvg = V_avg
				endif
			endif
		endfor
		//
		stochTable[ ][ aa ] /= minAvg
	endfor
	//
	print dimsize(eFretTable,0), dimsize(eFretTable,1), ": x, y, size of Efret table"
	print dimsize(stochTable,0), dimsize(stochTable,1), ": x, y, size of stochiometry table"
	// fill the 2D matrix
	for( aa = 0 ; aa <  min( dimsize( eFretTable, 1 ), dimsize( stochTable, 1 ) ) ; aa += 1 )
		// check type of trace
		if( selectionWToggle == accRejW_Tex[ aa ] )
			// count # of traces
			countSpotsPSP[1] += 1
			// add points onto 2D matrix for trace aa
			for( cc = 0 ; cc <   min( dimsize( eFretTable, 0 ), dimsize( stochTable, 0 ) ) ; cc += 1 )
				// find to which of intensity groups the point belongs for Efret
				if(  eFretTable[ cc ][ aa ] > -0.1 && eFretTable[ cc ][ aa ] < maxVal-0.1  )
					//
					FindLevel /P/Q rulerInt, eFretTable[ cc ][ aa ]
					// add point onto 2D matrix, time moment cc and intesity indicated by V_LevelX
					if( floor( V_LevelX ) < dimsize( outW, 1 ) || floor(  V_LevelX ) >= 0 )
						pointerX =  floor( V_LevelX )
					else
						print "index of intensity out of matrix y range."
						print floor( V_LevelX ), ": indicator value."
						abort
					endif
					//
				endif
				// find to which of intensity groups the point belongs for Stochiometry
				if(  stochTable[ cc ][ aa ] > -0.1 && stochTable[ cc ][ aa ] < maxVal-0.1 )
					//
					FindLevel /P/Q rulerInt, stochTable[ cc ][ aa ]
					// add point onto 2D matrix, time moment cc and intesity indicated by V_LevelX
					if( floor( V_LevelX ) < dimsize( outW, 1 ) || floor(  V_LevelX ) >= 0 )
						pointerY =  floor( V_LevelX )
					else
						print "index of intensity out of matrix y range."
						print floor( V_LevelX ), ": indicator value."
						abort
					endif
					//
				endif			
				//		
				outW[ pointerX ][ pointerY ] += 1
				// count # of states
				countSpotsPSP[0] += 1
				//
			endFor
			//
		endif
		//
	endFor
	//
	print countSpotsPSP[0], ": # of signals included into the plot."
	// normalise 2d plot
	outW /= countSpotsPSP[0]
	//
	setscale/i y,  -0.1, maxVal, outW
	setscale/i x,  -0.1, maxVal, outW
	//
	return outW
	//
end
//********************************************************************************************
// makes 1D histograms (collappsed 2D histogram plot onto one or another axis).
function hist_1d_ta_mt( minX, maxX, minY, maxY, numStep, plot2DHist )
	wave plot2DHist														// input 2D histogram plot
	variable minX, maxX, minY, maxY, numStep					// input variables
	// local variables
	variable numStatesX, numStatesY, stateValueMin, stateValueMax
	variable minLoc, maxLoc
	variable aa, bb
	//
	print "******************************************"
	// entering number of states for x and  y axis,
	prompt numStatesY, "# of states for horizontal 1D histogram"
	prompt numStatesX, "# of states for vertical 1D histogram"
	doPrompt "enter values",  numStatesY, numStatesX
	if( V_flag == 1 )
		abort
	else // check wether number of states is higher than 0.
		if( numStatesY <= 0 )
			numStatesY = 1
		endif
		if( numStatesX <= 0 )
			numStatesX = 1
		endif
		//
		print numStatesY, numStatesX, ": # states Y, X."
		//
	endif
	// make tables for x and y axis histograms
	make/o /n = ( numStep, numStatesY ) histTableX = nan
	make/o /n = ( numStep, numStatesX ) histTableY = nan
	make/o /n = ( numStep ) hist1 = nan
	make/o /n = ( numStep + 1 ) histRulerX = minX + ( abs( maxX - minX ) / numStep ) * x
	make/o /n = ( numStep + 1 ) histRulerY = minY + ( abs( maxY - minY ) / numStep ) * x
	// se scale for containers.
	setscale/i x, MinX, maxX, histTableX
	setscale/i x, MinY, maxY, histTableY
	// making histograms for X axis
	stateValueMin = MinX;		stateValueMax = MaxX
	//
	if( numStatesX > 0 )
		//
		for( aa = 0 ; aa < numStatesX ; aa += 1 )
			//
			prompt stateValueMin, "minimal value of state "+num2str(aa+1)
			prompt stateValueMax, "maximal  value of state "+num2str(aa+1)
			doPrompt "enter values for vertical histogram",  stateValueMin, stateValueMax
			if( V_flag == 1 )
				abort
			else
				print stateValueMin, stateValueMax, ": min, max, Y histogram, no: "+num2str(aa)
			endif
			// find row/column location
			FindLevel/P /Q histRulerX, stateValueMin;	minLoc = ceil( V_LevelX )
			FindLevel/P /Q histRulerX, stateValueMax;	maxLoc = ceil( V_LevelX )
			// make a manual integrated line-scan.
			for( bb = minLoc ; bb < maxLoc; bb += 1 )
				imagestats/q /g={0,dimsize(plot2Dhist,0)-1,bb,bb}/m=2 plot2DHist
				histTableY[ bb ][ aa ] = V_avg * V_npnts
			endFor
			//
		endFor
		//
	endif
	// making histograms for Y axis
	stateValueMin = MinY;		stateValueMax = MaxY
	//
	if( numStatesY > 0 )
		//
		for( aa = 0 ; aa < numStatesY ; aa += 1 )
			//
			prompt stateValueMin, "minimal value of state "+num2str(aa+1)
			prompt stateValueMax, "maximal  value of state "+num2str(aa+1)
			doPrompt "enter values for horizontal histogram",  stateValueMin, stateValueMax
			if( V_flag == 1 )
				abort
			else
				print stateValueMin, stateValueMax, ": min, max, X histogram, no: "+num2str(aa)
			endif
			// find row/column location
			FindLevel/P /Q histRulerY, stateValueMin;	minLoc = ceil( V_LevelX )
			FindLevel/P /Q histRulerY, stateValueMax;	maxLoc = ceil( V_LevelX )
			// make a manual integrated line-scan.
			for( bb = minLoc ; bb < maxLoc; bb += 1 )
				imagestats/q /g={bb,bb,0,dimsize(plot2Dhist,1)-1} plot2DHist
				histTableX[ bb ][ aa ] = V_npnts * V_avg
			endFor
			//
		endFor
		//
	endif
	//
end
//***********************************
//  differential 2D histogram plot
//***********************************
function diffHist_ta_mt( ctrlName ):buttonControl
	string ctrlName
	// find which waves user wants to subtract
	string waveNames = "", waveTitles = ""
	string windowNames =WinList("*Wind*", ";", "WIN:1" )
	variable aa, bb
	//
	print itemsinlist( windowNames, ";" ), ": number of windows with 2D histogram plots."
	//
	for( aa = 0 ; aa < itemsinlist( windowNames, ";" ); aa += 1 )
		waveTitles = imageNameList( stringFromlist(aa, windowNames, ";") , ";" )
		for( bb = 0 ; bb < itemsinlist( waveTitles, ";" ) ; bb += 1 )
			if( StringMatch( stringfromlist( bb , waveTitles , ";" ) , "*_binned*" ) == 0 )
				waveNames += stringfromlist( bb , waveTitles , ";" )+";"
			endif
		endfor
	endfor
	// sort manes of waves alphanumberically and then print them into the history window.
	wavenames = SortList(  wavenames, ";", 16 ); print wavenames
	// check how many wave names are in list, and if therre are less than 2, abort the execution.
	if( itemsinlist(wavenames, ";") < 2 )
		abort "there are less than two plots displayed."
	endif
	//
	variable plotName1 = 0, plotName2 = 0
	prompt plotName1, "Plot 1", popup, waveNames
	prompt plotName2, "Plot 2", popup, waveNames
	doPrompt "Select Plots (plot 1 - plot 2)", plotName1, plotName2
	if( V_flag == 1 ) // cancel clikced.
		abort
	endif
	//
	duplicate/o $stringfromlist(plotName1-1, wavenames, ";"), inW1
	duplicate/o $stringfromlist(plotName2-1, wavenames, ";"), inW2
	wave inW1, inW2						// input waves for making differential plot
	// giving a name of differential plot.
	string plotName = stringfromlist(plotName1-1, wavenames, ";")+"_"+stringfromlist(plotName2-1, wavenames, ";")
	print plotName, ": name of differential plot."
	//
	duplicate/o inW1, outW; outW -= inW2 
	wave outW
	// make a 1D histograms of X and Y axes
	make/o/n=( dimsize(outW,0) ) hist1
	make/o/n=( dimsize(outW,1) ) hist2
	//
	for( aa = 0 ; aa < dimsize( outW, 0 ) ; aa += 1 )
		imagestats/q /g = { aa, aa , 0, dimsize( outW,1 ) - 1 } outW
		hist1[aa] = V_avg * V_npnts
	endFor
	//
	for( aa = 0 ; aa < dimsize( outW, 1 ) ; aa += 1 )
		imagestats/q /g = { 0, dimsize( outW,1 ) - 1, aa , aa } outW
		hist2[aa] = V_avg * V_npnts
	endFor
	//
	duplicate/o hist1, $"hist1_"+plotName
	duplicate/o hist2, $"hist2_"+plotName
	duplicate/o outW, $plotName
	//
	dowindow/k $plotName+"_wind"
	Display/n=$plotName+"_wind"
	AppendImage/w=$plotName+"_wind" $plotName
	appendtograph/w=$plotName+"_wind" /l=left1 $"hist1_"+plotName
	appendtograph/w=$plotName+"_wind" /b=bottom1/vert $"hist2_"+plotName
	//
	ModifyGraph/w=$plotName+"_wind" axisEnab(left)={0,0.65},axisEnab(left1)={0.7,1}, freePos(left1)={0,bottom}
	ModifyGraph/w=$plotName+"_wind" axisEnab(bottom)={0,0.65},axisEnab(bottom1)={0.7,1}, freePos(bottom1)={0,left}
	//
	modifyGraph/w=$plotName+"_wind" margin(right)=113, margin(top)=28
	ModifyGraph/w=$plotName+"_wind" mirror=0,standoff(left)=0,standoff(bottom)=0
	execute/z/q "tilewindows/a=(1,1)/w=(0,0,400,375) "+plotName+"_wind"
	//
	ModifyGraph/w=$plotName+"_wind" lblPosMode(left1)=1, lblPosMode(bottom1)=1
	Label/w=$plotName+"_wind" left1 "Probability";	Label/w=$plotName+"_wind" bottom1 "Probability"
	ModifyGraph/w=$plotName+"_wind" grid(bottom)=1,gridRGB(bottom)=(0,0,0),  grid(left)=1,gridRGB(left)=(0,0,0)
	ModifyGraph/w=$plotName+"_wind" zero(left1)=1,zero(bottom1)=1
	variable xMax = DimDelta(outW, 0) * dimSize(outW,0)
	variable yMax = DimDelta(outW, 1) * dimSize(outW,1)
	SetAxis/N=1 left 0,yMax
	SetAxis/N=1 bottom 0,xMax
	//
	setscale/p x, 0,  1, $"hist1_"+plotName,  $"hist2_"+plotName
	//
	wavestats/q outW
	ModifyImage/w=$plotName+"_wind" $plotName ctab= {-min( abs(V_min) , abs(V_max) ),min( abs(V_min) , abs(V_max) ),RedWhiteBlue,0} 
	// adding color scale and information about # of particles and # of states included 
	TextBox/w=$plotName+"_wind"/C/N=text1/E=2/A=MT/F= 0/y=0/x=-10 "\Z14Differential plot: "+stringFromList(plotName1-1, waveNames, ";")+" - "+stringFromList(plotName2-1, waveNames, ";")
	// add color scale to non normalized plot
	ColorScale/w=$plotName+"_wind"/e=2/C/N=text0/A=RC/F = 0/B=1/H={12,0,0}/x=0/y=0  lblMargin=20,height=100, width=7 , "%"
	//
end
//***********************************************************
// state duration histograms for specific intensity states
//***********************************************************
function durHist_states_ta_mt( ctrlName ):buttonControl
	string ctrlName
	// local variables
	variable nStates, intState1, halfWidthState1
	variable aa, bb, durThresh, count = 0
	string string1, outName
	// ask for a path to the concatenated tables folder
	newpath/o/m="Define directory, where tables for making plots are located" path4
	if( V_flag != 0 )
		abort "you did not selected the path"
	endif
	// load ICP table
	string fileName = ListMatch( (indexedFile ( path4 , -1 , ".ibw" )) , "*050_*" )
	LoadWave/H/O/P = path4/Q stringFromList( 0 , fileName, ";" )	// loading non-filtered signal traces contianer
	wave/z inW = $stringFromlist( 0 , S_wavenames )
	print stringFromlist( 0 , S_wavenames ), "wave loaded"	
	// ask for number of states
	prompt nStates, "Number of states"
	prompt durThresh, "Duration of state threshold"
	prompt outName, "Base of out wave name"
	doPrompt "Enter value", nStates, durThresh, outName
	if( V_flag != 0 )
		abort
	endif
	print nStates, durThresh, ": nStates, durThresh."
	// make wave for entered parameter value storing
	make/o /n = ( nStates, 2 ) paramsW
	make/o /n = ( 0, nStates ) outW
	// ask for state intensity and width
	for( aa = 0 ; aa < nStates ; aa += 1 )
		//
		prompt intState1, "Mean intensity of state."
		prompt halfWidthState1, "Half-width of state."
		doprompt "Enter values for state no.: "+num2str(aa+1), intState1, halfWidthState1
		if(V_flag != 0 )
			abort
		endif
		//
		paramsW[aa][0] = intState1
		paramsW[aa][1] = halfWidthState1
		//
		print intState1,halfWidthState1,aa+1, ": mean int., half-width of state, state no."
		//
	endFor
	// make waves for state duration for each state
	for( aa = 0 ; aa < dimsize( inW, 0 ) ; aa +=1 )
		//
		bb = 0
		//
		do
			// mean intensikty of current state >= int of state bb - halfwidth and < int of state bb + halfwidth.
			if( numtype(inW[ aa ][ %currInt ]) == 0 && numtype(inW[ aa ][ %dur ]) == 0 )
				if( inW[ aa ][ %currInt ] >= paramsW[ bb ][ 0 ] - paramsW[ bb ][ 1 ] && inW[ aa ][ %currInt ] < paramsW[ bb ][ 0 ] + paramsW[ bb ][ 1 ] && inW[ aa ][ %dur ] > durThresh )
					//
					insertpoints/m=0 count, 1, outW
					outW[count][] = nan
					outW[count][bb] = inW[ aa ][ %dur ]
					//
					count += 1
					//
					break
					//
				else
					bb += 1
				endif
				//
			else
				bb += 1
			endif
			//
			if( bb >= dimsize(paramsW,0) )
				//
				break
				//
			endif
			//
		while(1)
		//
	endFor
	// generate single waves without nan's.
	for( aa = 0 ; aa < dimsize( outW, 1 ) ; aa +=1 )
		//
		make/o /n = ( dimsize( outW, 0 ) ) wave1 = outW[p][aa]
		//
		bb = 0
		//
		do
			//
			if( numtype( wave1[bb] ) != 0 )
				deletepoints/m=0 bb,1, wave1
			else
				bb += 1
			endif
			//
			if( bb >= dimsize(wave1,0))
				break
			endif
			//
		while(1)
		//
		duplicate/o wave1, $"outW_"+outName+"_"+num2str(aa+1)
		print "outW_"+outName+"_"+num2str(aa+1), ":out wave name."
		//
	endFor
	//
end
//
//****************************************************
// state duration histograms for specific transitions
//****************************************************
function durHist_trans_ta_mt( ctrlName ):buttonControl
	string ctrlName
	// local variables
	variable nStates, aa, intState1, sdState1,  intState2, sdState2, bb, count = 0
	string string1
	// ask for a path to the concatenated tables folder
	newpath/o/m="define directory, where tables for making plots are located" path4
	if( V_flag != 0 )
		abort "you did not selected the path"
	endif
	// load ICP table
	string fileName = ListMatch( (indexedFIle ( path4 , -1 , ".ibw" )) , "*050_*" )
	LoadWave/H/O/P = path4/Q stringFromList( 0 , fileName, ";" )	// loading non-filtered signal traces contianer
	duplicate/o $stringFromlist( 0 , S_wavenames ), inW
	wave inW
	print stringFromlist( 0 , S_wavenames ), "wave loaded"	
	// ask for number of states
	prompt nStates, "Number of transitions."
	doPrompt "Enter value", nStates
	if( V_flag != 0 )
		abort
	endif
	// make local waves
	make/o /n = ( nStates, 4 ) paramsW
	make/o /n = ( 0, nStates ) outW1
	// ask for state intensity and width
	for( aa = 0 ; aa < nStates ; aa += 1 )
		//
		prompt intState1, "Avg intensity for state 1."
		prompt sdState1, "Half-width of state intensity 1."
		prompt intState2, "Avg intensity for state 2."
		prompt sdState2, "Half-width of state intensity 2."
		doprompt "Enter values for transition no.: "+num2str(aa+1), intState1, sdState1, intState2, sdState2
		if(V_flag != 0 )
			abort
		endif
		//
		paramsW[aa][0] = intState1
		paramsW[aa][1] = sdState1
		paramsW[aa][2] = intState2
		paramsW[aa][3] = sdState2
		//
		string1 = num2str(paramsW[aa][0])+"_to_"+num2str(paramsW[aa][2]);		setdimlabel 1, aa, $string1, outW1
		//
	endFor
	// make waves for state duration for each transition
	for( aa = 0 ; aa < dimsize( inW, 0 ) ; aa +=1 )
		//
		bb = 0
		do
			if( inW[ aa ][ %currInt ] >= paramsW[ bb ][ 0 ] - paramsW[ bb ][ 1 ] && inW[ aa ][ %currInt ] < paramsW[ bb ][ 0 ] + paramsW[ bb ][ 1 ] )
				if( inW[ aa ][ %fwInt ] >= paramsW[ bb ][ 2 ] - paramsW[ bb ][ 3 ] && inW[ aa ][ %fwInt ] < paramsW[ bb ][ 2 ] + paramsW[ bb ][ 3 ]  )
					insertpoints/m=0 count, 1, outW1
					outW1[ count ][  ] = Nan
					outW1[ count ][ bb ] = inW[ aa ][ %dur ]
					count += 1
					//
					break
					//
				else
					bb += 1
				endif
			else
				bb += 1
			endif
			//
			if( bb >= dimsize(paramsW,0))
				break
			endif
			//
		while(1)
		//
	endFor
	//
	print nameofwave(outW1)
	//
end
//
function separatedKinetics( inW, durThresh, expTime )
	wave inW
	variable durThresh, expTime
	//
	variable aa, bb
	//
	for( aa = 0 ; aa < dimsize( inw, 1 ) ; aa += 1 )
		make/o/n=0 waveTemp
		for( bb = 0 ; bb < dimsize( inw, 0 ) ; bb += 1 )
			//
			//print inw[bb][aa]
			if( numtype( inw[bb][aa] ) == 0 && inw[bb][aa] * expTime > durThresh )
				insertpoints/m=0 0, 1, waveTemp
				waveTemp[0] = inw[bb][aa] * expTime
			endif
			//
		endFor
		//
		duplicate/o waveTemp, $"wave"+num2str(aa)
		print "wave"+num2str(aa)
		//
	endFor
	//
end
//************************************************
// state duration histograms: Efret and TFM in EF.
//************************************************
function durationHist2_ta_mt( inW, eFretLoopMin, eFretLoopMax, accLoopMin, accLoopMax, bleachLevelAcc, expTime )
	// input table
	wave inW
	// input variables
	variable eFretLoopMin, eFretLoopMax, accLoopMin, accLoopMax, bleachLevelAcc, expTime
	// local variables
	variable aa, newTrace
	variable eFRETCurr, accCurr, parAntiParToggle = 0
	string string1
	// make local waves
	make/o /n = 0 durPloop, durAPloop, durToPloop, durToAPloop
	// make waves for state duration for each transition
	for( aa = 0 ; aa < dimsize( inW, 0 ) ; aa +=1 )
		//
		if( aa > 0 )
			//
			if( inW[aa][%index] != inW[aa+1][%index] )
				newTrace = 1
			else
				newTrace = 0
			endif
			//
		endif
		//
		eFRETCurr = inW[aa][%currEfret]
		accCurr =  inW[aa][%currInt]
		//
		if( eFRETCurr > eFretLoopMin && eFRETCurr < eFretLoopMax ) 	// parallel loop Efret
			//
			if( accCurr > accLoopMin && accCurr < accLoopMax )			// parallel loop acc Int. (unlooping parallel)
				insertpoints/m=0 0,1, durPloop;		durPloop[0] = inW[aa][%dur] * expTime
			endif
			//
		elseif( eFRETCurr <= eFretLoopMin ) 							// not parallel loop or not looped.
			//
			if( accCurr > accLoopMin && accCurr < accLoopMax )			// anti-parallel loop acc Int. (unlooping anti-parallel)
				//
				insertpoints/m=0 0,1, durAPloop;		durAPloop[0] = inW[aa][%dur] * expTime
				//
			elseif( accCurr <= accLoopMin && accCurr > bleachLevelAcc )	// not looped, but not bleached
				//
				if( aa > 0 && newTrace == 0 )	// following state should belong to the same trace as the current.
					//
					if( inW[aa+1][%currInt] > accLoopMin && inW[aa+1][%currInt] < accLoopMax )
						//
						if( inW[aa+1][%currEfret] > eFretLoopMin && inW[aa+1][%currEfret] < eFretLoopMax )
							parAntiParToggle = 1
						elseif( inW[aa+1][%currEfret] <= eFretLoopMin )
							parAntiParToggle = 2					
						endif
						//
					else
						parAntiParToggle = 0
					endif
					//
					if( parAntiParToggle == 1 ) 					// following parallel
						//
						insertpoints/m=0 0,1, durToPloop;	durToPloop[0] = inW[aa][%dur] * expTime
						//
					elseif( parAntiParToggle == 2 )				// following anti-parallel
						//
						insertpoints/m=0 0,1, durToAPloop;	durToAPloop[0] = inW[aa][%dur] * expTime
						//
					endif
					//
				endif
				//
			endif
			//
		endif
		//
	endFor
	//
	statsresample/ITER = 10000 /n = ( dimsize( durPloop , 0 ) - 1 ) /WS = 2  durPloop
	wave M_WaveStatsSamples
	make/o /n = ( dimsize( M_WaveStatsSamples, 1 ) ) meanW = M_WaveStatsSamples[ 3 ][ p ]
	print "pLoop: "+num2str(mean( meanW ))+": mean dur., " +num2str(sqrt(variance(meanW))) +": sdev of mean, " +num2str(dimsize(durPloop,0))+": npnts"
	//
	statsresample/ITER = 10000 /n = ( dimsize( durAPloop ,0 ) - 1 ) /WS = 2  durAPloop
	make/o /n = ( dimsize( M_WaveStatsSamples, 1 ) ) meanW = M_WaveStatsSamples[ 3 ][ p ]
	print "apLoop: "+num2str(mean( meanW ))+": mean dur., " +num2str(sqrt(variance(meanW))) +": sdev of mean, " +num2str(dimsize(durAPloop,0))+": npnts"
	//
	statsresample/ITER = 10000 /n = ( dimsize( durToPloop ,0 ) - 1 ) /WS = 2  durToPloop
	make/o /n = ( dimsize( M_WaveStatsSamples, 1 ) ) meanW = M_WaveStatsSamples[ 3 ][ p ]
	print "to pLoop: "+num2str(mean( meanW ))+": mean dur., " +num2str(sqrt(variance(meanW))) +": sdev of mean, " +num2str(dimsize(durToPloop,0))+": npnts"
	//
	statsresample/ITER = 10000 /n = ( dimsize( durToAPloop ,0 ) - 1 ) /WS = 2  durToAPloop
	make/o /n = ( dimsize( M_WaveStatsSamples, 1 ) ) meanW = M_WaveStatsSamples[ 3 ][ p ]
	print "to apLoop: "+num2str(mean( meanW ))+": mean dur., " +num2str(sqrt(variance(meanW))) +": sdev of mean, " +num2str(dimsize(durToAPloop,0))+": npnts"
	//
end
//*********************************************************************
// postsynchronised trajectories plot.
//******************************************** 
function/wave tr2DPlot_ta_mt( trajTable1, nBinsX, nBinsY, minInt, maxInt, deltaT, normToggle, selectionWToggle, autoManSelect, bleachedLevel, max1stGauss )
	wave trajTable1 // table 1 -  signals
	variable nBinsX, nBinsY, maxInt, minInt, deltaT, normToggle, selectionWToggle, autoManSelect, bleachedLevel, max1stGauss
	// make a copy of input wave
	make/o/n=(dimsize(trajTable1,0),dimsize(trajTable1,1)) trajTable;		trajTable[][] = trajTable1[p][q][0]
	//
	if( autoManSelect == 1 )
		wave accRejW_Tex
		make/o /n = ( dimsize( trajTable, 1 ), 2 ) selFrTrW_Tex; selFrTrW_Tex[][0] = 0; selFrTrW_Tex[][1] = dimsize( trajTable, 0 )-1
	elseif( autoManSelect == 2 )
		wave selFrTrW_Tex
		make/o /n = ( dimsize( trajTable, 1 ) ) accRejW_Tex = selFrTrW_Tex[p][0]+selFrTrW_Tex[p][1]
		accRejW_Tex = accRejW_Tex[p] > 0 ? 1 : accRejW_Tex[p]
	else
		make/o /n = ( dimsize( trajTable, 1 ) ) accRejW_Tex = selectionWToggle
		make/o /n = ( dimsize( trajTable, 1 ), 2 ) selFrTrW_Tex; selFrTrW_Tex[][0] = 0; selFrTrW_Tex[][1] = dimsize( trajTable, 0 )-1
	endif
	// local variables
	variable aa, cc, gg
	variable minAvg
	variable continueVar = 0
	variable startPnt, endPnt
	variable countPnts
	make/o/n=2  countSpotsPSP = 0
	variable deltaInt = abs(maxInt - minInt) / nBinsY
	// print information about input wave
	print nameofwave(trajTable), ": name of input wave, size x, y: "+num2str(dimsize(trajTable,0))+", "+num2str(dimsize(trajTable,1))
	// make a 2D matrix
	make/o /n = ( nBinsX, nBinsY ) outW = 0
	make/o /n = ( nBinsY + 1 ) rulerInt = minInt + abs( deltaInt * p )
	//
	make/o/n=(0) center1W, center2W
	make/o/d/n=4 w_coef
	make/o/n=30 hist1, hist2
	make/o/n=(dimsize(trajTable,0)) crop1 = trajTable[p][aa]
	//
	if(normToggle == 2)
		dowindow/k cernterW_tableW
		edit/n=cernterW_tableW center1W, center2W	
	endif
	// fill the 2D matrix
	for( aa = 0 ; aa < dimsize( trajTable, 1 ) ; aa += 1 )
		//***************************
		// check tag of the current trace
		if( selectionWToggle == accRejW_Tex[ aa ]  )
			//*************************************************
			// normalise trace
			if( normToggle == 1 )  // to the avg. minimum of it.
				// seach for minimal avg.
				for( gg = 0 ; gg + 10 < dimsize( trajTable, 0 )*0.1 ; gg += 1 )
					imagestats/q /g = {gg, gg+10, aa, aa } trajTable
					if( gg == 0 )
						minAvg = V_avg
					else
						if( V_avg < minAvg && V_avg > 0.5 )
							minAvg = V_avg
						endif
					endif
				endfor
				//
				trajTable[ ][ aa ] /= minAvg
				//
			elseif( normToggle == 2 )	// to the first Gaussian mean value.
				// seach for minimal avg. (pre-normalisation)
				for( gg = 0 ; gg + 10 < dimsize( trajTable, 0 )*0.1 ; gg += 1 )
					imagestats/q /g = {gg, gg+10, aa, aa } trajTable
					if( gg == 0 )
						minAvg = V_avg
					else
						if( V_avg < minAvg && V_avg > bleachedLevel )
							minAvg = V_avg
						endif
					endif
				endfor
				// norm to avg. minimum.
				trajTable[ ][ aa ] /= minAvg
				// fit the first Gauss to the pre-normalised trace.
				insertpoints/m=0 0,1, center1W, center2W
				//
				crop1 = trajTable[p][aa]
				//
				histogram/c/p/b={0.5, abs(max1stGauss-0.5)/30,30} crop1, hist1
				CurveFit/M=2 /W=2 /Q /N=1 /NTHR=0 gauss, hist1
				// normalise to the mean of the first Gauss.
				trajTable[ ][ aa ] /= w_coef[2]
				//
				crop1 = trajTable[p][aa]
				//
				histogram/c/p/b={0.5, abs(max1stGauss-0.5)/30,30} crop1, hist1
				CurveFit/M=2 /W=2 /Q /N=1 /NTHR=0 gauss, hist1
				center1W[0] = w_coef[2]
				// 2nd Gauss.
				make/o/n=30 hist1 = 0
				histogram/c/p/b={max1stGauss,abs(3-max1stGauss)/30,30} crop1, hist2
				CurveFit/M=2 /W=2 /Q /N=1 /NTHR=0 gauss, hist2
				center2W[0] = w_coef[2]
				//
			endif
			//*************************************************
			// count # of traces
			countSpotsPSP[1] += 1
			//
			startPnt = selFrTrW_Tex[aa][0]
			endPnt = min( min( selFrTrW_Tex[aa][0]+nBinsX, dimsize( trajTable, 0 )  ), selFrTrW_Tex[aa][1] )
			countPnts = 0	
			// add points onto 2D matrix for trace aa
			for( cc = startPnt ; cc < endPnt ; cc += 1 )
				// find to which of intensity groups the point belongs
				if(  trajTable[ cc ][ aa ] > minInt && trajTable[ cc ][ aa ] < maxInt )
					//
					FindLevel /P/Q rulerInt, trajTable[ cc ][ aa ]
					// add point onto 2D matrix, time moment cc and intesity indicated by V_LevelX
					if( floor( V_LevelX ) < dimsize( outW, 1 ) || floor(  V_LevelX ) >= 0 )
						//
						outW[ countPnts ][ floor( V_LevelX ) ] += 1
						// count # of states
						countSpotsPSP[0] += 1
						countPnts += 1
						//
					else
						print "index of intensity out of matrix y range."
						print trajTable[ cc ][ aa ], ": trace intensity"
						print floor( V_LevelX ), ": indicator value."
						abort
					endif
					//
				endif
				//
			endFor
			//
		endif
		//
	endFor
	//
	print countSpotsPSP[0], ": # of points included into the plot."
	print countSpotsPSP[1], ": # of traces included into the plot."
	// normalise 2d plot to number integral.
	outW /= countSpotsPSP[0]
	//
	setscale/i y,  minInt, maxInt, outW
	setscale/p x,  0, deltaT, outW
	//
	killvariables/z aa, cc, deltaInt, continueVar
	killwaves/z rulerInt
	//
	return outW
	//
end
//*********************************************************************
// postsynchronised trajectories plot. for given liposome size
//******************************************** 
function/wave tr2DPlot_lipSize_ta_mt( trajTable1, nBinsX, nBinsY, minInt, maxInt, deltaT, normToggle, selectionWToggle, autoManSelect, minLipInt, maxLipInt, lipChInd )
	wave trajTable1 // table 1 -  signals
	variable nBinsX, nBinsY, maxInt, minInt, deltaT, normToggle, selectionWToggle, autoManSelect, minLipInt, maxLipInt, lipChInd
	//
	wave spotInfoTable
	// make a copy of input wave
	duplicate/o trajTable1, trajTable
	//
	if( autoManSelect == 1 )
		wave accRejW_Tex
		make/o /n = ( dimsize( trajTable, 1 ), 2 ) selFrTrW_Tex; selFrTrW_Tex[][0] = 0; selFrTrW_Tex[][1] = dimsize( trajTable, 0 )-1
	elseif( autoManSelect == 2 )
		wave selFrTrW_Tex
		make/o /n = ( dimsize( trajTable, 1 ) ) accRejW_Tex = selFrTrW_Tex[p][0]+selFrTrW_Tex[p][1]
		accRejW_Tex = accRejW_Tex[p] > 0 ? 1 : accRejW_Tex[p]
	else
		make/o /n = ( dimsize( trajTable, 1 ) ) accRejW_Tex = selectionWToggle
		make/o /n = ( dimsize( trajTable, 1 ), 2 ) selFrTrW_Tex; selFrTrW_Tex[][0] = 0; selFrTrW_Tex[][1] = dimsize( trajTable, 0 )-1
	endif
	// local variables
	variable aa, cc, gg
	variable minAvg
	variable continueVar = 0
	variable startPnt, endPnt
	variable countPnts
	variable lipInt
	make/o/n=2  countSpotsPSP = 0
	variable deltaInt = abs(maxInt - minInt) / nBinsY
	// print information about input wave
	print nameofwave(trajTable), ": name of input wave, size x, y: "+num2str(dimsize(trajTable,0))+", "+num2str(dimsize(trajTable,1))
	// make a 2D matrix
	make/o /n = ( nBinsX, nBinsY ) outW = 0
	make/o /n = ( nBinsY + 1 ) rulerInt = minInt + abs( deltaInt * p )
	// fill the 2D matrix
	for( aa = 0 ; aa < dimsize( trajTable, 1 ) ; aa += 1 )
		// normlise trace aa to the begining of it.
		if( normToggle == 1 )
			// seach for minimal avg.
			for( gg = 0 ; gg + 10 < dimsize( trajTable, 0 )*0.1 ; gg += 1 )
				imagestats/q /g = {gg, gg+10, aa, aa } trajTable
				if( gg == 0 )
					minAvg = V_avg
				else
					if( V_avg < minAvg && V_avg > 0.5 )
						minAvg = V_avg
					endif
				endif
			endfor
			//
			trajTable[ ][ aa ] /= minAvg
			//
		endif
		//***************************
		// calculate liposome intensity
		if( lipChInd == 1 )
			lipInt = spotInfoTable[ aa ][ %amp1 ] * abs( spotInfoTable[ aa ][ %xW1 ] ^ 2 )
		else
			lipInt = spotInfoTable[ aa ][ %amp2 ] * abs( spotInfoTable[ aa ][ %xW2 ] ^ 2 )
		endif
		// check tag of the current trace
		if( selectionWToggle == accRejW_Tex[ aa ] && lipInt >= minLipInt && lipInt < maxLipInt )
			// count # of traces
			countSpotsPSP[1] += 1
			//
			startPnt = selFrTrW_Tex[aa][0]
			endPnt = min( selFrTrW_Tex[aa][0]+nBinsX, dimsize( trajTable, 0 )  )
			countPnts = 0
			// add points onto 2D matrix for trace aa
			for( cc = startPnt ; cc < endPnt ; cc += 1 )
				// find to which of intensity groups the point belongs
				if(  trajTable[ cc ][ aa ] > minInt && trajTable[ cc ][ aa ] < maxInt )
					//
					FindLevel /P/Q rulerInt, trajTable[ cc ][ aa ]
					// add point onto 2D matrix, time moment cc and intesity indicated by V_LevelX
					if( floor( V_LevelX ) < dimsize( outW, 1 ) || floor(  V_LevelX ) >= 0 )
						//
						outW[ countPnts ][ floor( V_LevelX ) ] += 1
						// count # of states
						countSpotsPSP[0] += 1
						countPnts += 1
						//
					else
						print "index of intensity out of matrix y range."
						print trajTable[ cc ][ aa ], ": trace intensity"
						print floor( V_LevelX ), ": indicator value."
						abort
					endif
					//
				endif
				//
			endFor
			//
		endif
		//
	endFor
	// 
	print countSpotsPSP[0], ": # of signals included into the plot."
	// normalise 2d plot
	outW /= countSpotsPSP[0]
	//
	setscale/i y,  minInt, maxInt, outW
	setscale/p x,  0, deltaT, outW
	//
	killvariables/z aa, cc, deltaInt, continueVar
	killwaves/z rulerInt
	//
	return outW
	//
end
//*********************************************************************
// postsynchronised trajectories plot.
//******************************************** 
function/wave tr2DPlot3_ta_mt( trajTable1, spotInfoTable, nBinsX, nBinsY, minInt, maxInt, deltaT, normToggle, maxInt2ndCh )
	wave trajTable1 // table 1 - channel 1 or channel 2 signals
	wave spotInfoTable
	variable nBinsX, nBinsY, maxInt, minInt, deltaT, normToggle
	variable maxInt2ndCh		// ampM
	// make a copy of input wave
	duplicate/o trajTable1, trajTable
	// local variables
	variable aa, cc
	variable continueVar = 0, countSpots = 0
	variable deltaInt = abs(maxInt - minInt) / nBinsY
	// print information about input wave
	print nameofwave(trajTable), ": name of input wave, size x, y: "+num2str(dimsize(trajTable,0))+", "+num2str(dimsize(trajTable,1))
	// make a 2D matrix
	make/o /n = ( nBinsX, nBinsY ) outW = 0
	make/o /n = ( nBinsY + 1 ) rulerInt = minInt + abs( deltaInt * p )
	// fill the 2D matrix
	for( aa = 0 ; aa < dimsize( trajTable, 1 ) ; aa += 1 )
		// normlise trace aa to the begining of it.
		if( normToggle == 1 )
			imagestats/q /g = { 0, 10, aa, aa } trajTable;	trajTable[ ][ aa ] /= V_Avg
		endif
		//
		if( spotInfoTable[ aa ][ %ampM ] < maxInt2ndCh )
			// add points onto 2D matrix for trace aa
			for( cc = 0 ; cc < min( nBinsX, dimsize( trajTable, 0 ) ) ; cc += 1 )
				// find to which of intensity groups the point belongs
				if(  trajTable[ cc ][ aa ] > minInt && trajTable[ cc ][ aa ] < maxInt )
					//
					FindLevel /P/Q rulerInt, trajTable[ cc ][ aa ]
					// add point onto 2D matrix, time moment cc and intesity indicated by V_LevelX
					if( floor( V_LevelX ) < dimsize( outW, 1 ) || floor(  V_LevelX ) >= 0 )
						outW[ cc ][ floor( V_LevelX ) ] += 1
					else
						print "index of intensity out of matrix y range."
						print trajTable[ cc ][ aa ], ": trace intensity"
						print floor( V_LevelX ), ": indicator value."
						abort
					endif
					//
				endif
				//
			endFor
			//
			countSpots += 1
			//
		endif
		//
	endFor
	// 
	print countSpots, ": # of signals included into the plot."
	// normalise 2d plot
	outW /= countSpots
	//
	setscale/i y,  minInt, maxInt, outW
	setscale/p x,  0, deltaT, outW
	//
	killvariables/z aa, cc, deltaInt, continueVar, countSpots
	killwaves/z rulerInt
	//
	return outW
	//
end
//***************************************************************************************************************
// postsynchronised trajectories plot. makes plot for signals coming specific intensity of 2nd channel
//*************************************************************************************************************** 
function/wave tr2DPlot2_ta_mt( trajTable1, trajTable2, nBinsX, nBinsY, minInt, maxInt, deltaT, normToggle, dimMin, dimMax,  dimTog, dimNumPnts )
	wave trajTable1, trajTable2 // table 1 - channel 1 signals, table 2 - channel 2 signals
	variable nBinsX, nBinsY, maxInt, minInt, deltaT, normToggle
	variable dimMin, dimMax //range of intensity for the second channel
	variable dimTog		// intensity toggle for the second channel, 1 - active, else inactive
	variable dimNumPnts	// number of point to take average of the 2nd channel signal.
	// make a copy of input wave
	duplicate/o trajTable1, trajTable
	// local variables
	variable aa, cc
	variable continueVar = 0, countSpots = 0
	variable deltaInt = abs(maxInt - minInt) / nBinsY
	// print information about input wave
	print nameofwave(trajTable), ": name of input wave, size x, y: "+num2str(dimsize(trajTable,0))+", "+num2str(dimsize(trajTable,1))
	// make a 2D matrix
	make/o /n = ( nBinsX, nBinsY ) outW = 0
	make/o /n = ( nBinsY + 1 ) rulerInt = minInt + abs( deltaInt * p )
	// fill the 2D matrix
	for( aa = 0 ; aa < dimsize( trajTable, 1 ) ; aa += 1 )
		// normlise trace aa to the begining of it.
		if( normToggle == 1 )
			imagestats/q /g = { 0, 10, aa, aa } trajTable;	trajTable[ ][ aa ] /= V_Avg
		endif
		//
		if( dimTog == 1 )  // add points to plot only if 2nd channel signal is in between the right range
			imagestats/q /G={0, dimNumPnts, aa, aa } trajTable2
			if( V_avg > dimMin && V_avg < dimMax )
				continueVar = 1
			else
				continueVar = 0
			endif
		else
			continueVar = 1
		endif
		//
		if( continueVar == 1 )
			// add points onto 2D matrix for trace aa
			for( cc = 0 ; cc < min( nBinsX, dimsize( trajTable, 0 ) ) ; cc += 1 )
				// find to which of intensity groups the point belongs
				if(  trajTable[ cc ][ aa ] > minInt && trajTable[ cc ][ aa ] < maxInt )
					//
					FindLevel /P/Q rulerInt, trajTable[ cc ][ aa ]
					// add point onto 2D matrix, time moment cc and intesity indicated by V_LevelX
					if( floor( V_LevelX ) < dimsize( outW, 1 ) || floor(  V_LevelX ) >= 0 )
						outW[ cc ][ floor( V_LevelX ) ] += 1
					else
						print "index of intensity out of matrix y range."
						print trajTable[ cc ][ aa ], ": trace intensity"
						print floor( V_LevelX ), ": indicator value."
						abort
					endif
					//
				endif
				//
			endFor
			//
			countSpots += 1
			//
		endif
		//
	endFor
	// 
	print countSpots, ": # of signals included into the plot."
	// normalise 2d plot
	outW /= countSpots
	//
	setscale/i y,  minInt, maxInt, outW
	setscale/p x,  0, deltaT, outW
	//
	killvariables/z aa, cc, deltaInt, continueVar, countSpots
	killwaves/z rulerInt
	//
	return outW
	//
end