#pragma rtGlobals=3		// Use modern global access method and strict wave access.
#pragma ModuleName = tracesAnalyzer_visTrMol

// function for visualisation of SM trajectory, molecule appearance in image and movie 

function main_visTrMol_ta_mt( ctrlName ) :BUTTONCONTROL
	string ctrlName
	// erase current data folder for any contents
	killwaves/a/z; killstrings/a/z; killVariables/z/a
	// kill windows
	doWindow/k cPan_visTrMol_ta_mt			// control panel
	doWindow/k gr1_visTrMol_ta_mt			// trajectory
	doWindow/k gr2_visTrMol_ta_mt			// 1st image
	doWindow/k gr3_visTrMol_ta_mt			// 2nd image
	dowindow/k stChannel
	dowindow/k ndChannel
	dowindow/k thresholdChannel
	//
	Struct TA_preferences TAPrefs
	load_preferences_TA_MT( TAPrefs )
	// create global variables
	variable/G dualView = TAPrefs.imageTypeTA[0]
	variable/G topBottom = TAPrefs.imageTypeTA[2]
	variable/G horizVert = TAPrefs.imageTypeTA[3]
	variable/G numChToggle = TAPrefs.noChToggle				// 1 - 1st ch, 2 - 2nd ch, 3 - both ch. (FRET)
	variable/G dualVdualC = TAPrefs.imageTypeTA[0]
	variable/G topBottom = TAPrefs.imageTypeTA[1]
	variable/G topBottom2 = TAPrefs.imageTypeTA[2]
	variable/G horizVert = TAPrefs.imageTypeTA[3]
	variable/G excitationType = TAPrefs.excType					// 1 - ALEX, 2 -single laser
	variable/G antiCorrToggleMain =  TAPrefs.antiCorToggleMain		// 1 - anti-correlation check on, else off.
	variable/g x0ROI = TAPrefs.sizeImage[ 2 ]						// x0
	variable/g x1ROI = TAPrefs.sizeImage[ 3 ]						// x1
	variable/g y0ROI = TAPrefs.sizeImage[ 4 ]						// y0
	variable/g y1ROI = TAPrefs.sizeImage[ 5 ]						// y1
	variable/g axisPopUpVar = 1
	variable/g accRejIndic = 0
	// local variables, waves, strings
	make/o/n=6 traceSubTypeW = 0
	make/o/n=4 chOnOffW = 0
	variable/G frameId = 0
	variable/G frSize = 8
	variable/G numTraj = 0
	variable/G maxIntVar = 3000
	variable/G minIntVar = 0
	variable/G traceLoaded = 0
	variable/G maxIntImage1 = 100
	variable/G maxIntImage2 = 100
	variable/G var1G=1, var2G=1, minHistInt1G, maxHistInt1G, minHistInt2G, maxHistInt2G, durG, normCG, nBinsG
	string/g movieName1 = ""
	// create local variables and strings
	variable aa = 0, counter = 1, bb = 2, movieFoldIndex = 0
	string folderNames = "", subFolders = ""
	// ask user to redifine paths or to keep the existing ones
	prompt bb , "Redifine paths", popup,  "Yes; No"
	doprompt "Select action", bb
	if( V_flag == 0 )
		if( bb == 1 )
			// define directory with results
			NewPath /M = "results folder" /O /Q /Z resPathMain
			if( V_flag != 0 )
				abort
			endif
			//
		else	
			//
			pathinfo resPathMain
			if( V_flag != 1 )
				abort
			else
				print S_path, ": main directory of results"
			endif
			//
		endif
		//
	else
		abort
	endif
	// select directory to analyse
	for( bb = 0 ; bb < itemsinlist( indexedDir( resPathMain, -1, 0  ), ";" ); bb += 1 )
		folderNames += stringfromlist( bb, indexedDir( resPathMain, -1, 0  ), ";" )+";"
	endFor
	//
	folderNames = sortlist( folderNames, ";", 16 )
	prompt bb , "index of movie to be analysed", popup,  folderNames
	doprompt "Select movie to be analysed", bb;	bb -= 1
	if( V_flag != 0 )
		Abort
	endif
	//
	movieName1 = stringfromlist( bb, folderNames, ";" )
	// define current directories
	pathinfo resPathMain;	newpath/o /q resPath, S_path+stringfromlist( bb, folderNames, ";" )
	pathInfo resPath;		print s_path, ": current results folder";	NewPath /O/Q/Z Path4, S_path
	// make control panel and windows for signals and images.
	make/o/n=1 acceptRejIdicatorW
	GUI_visTrMol_ta_mt( )
	//
end

Function butProc_visTrMol_ta_mt(ctrlName) : ButtonControl
	String ctrlName
	// referencing global variables
	NVAR frameId, numTraj, numChToggle
	NVAR traceLoaded
	// referencing waves
	wave acceptRejIdicatorW
	wave selFragTrTable
	// local variables 
	variable hh, countTrace = 0
	//
	if( itemsinList( ListMatch( ctrlName, "closeWindButton" ) ) != 1    )
		if( traceLoaded != 1 )
			print "first loade the data"
			abort
		endif
	endif
	// check wich of the buttons was clicked
	strswitch( ctrlName )
		case "fwButton":
			//	update counter
			frameId = min( frameId + 1, numTraj - 1 )
			//
			TextBox/w = gr1_visTrMol_ta_mt /C /N = text1 /k
			//
			if( frameId == numTraj - 1 )
				beep
				TextBox/w = gr1_visTrMol_ta_mt /C /N = text1 /A = RT /X = 0.00 /Y = 20 "Last trajectory"
			endif
			// update screen
			updateSignals( )
			//
			break
		case "prevButton":
			//	update counter
			frameId = max( frameId - 1, 0 )
			//
			TextBox/w = gr1_visTrMol_ta_mt /C /N = text1 /k
			//
			if( frameId == 0 )
				beep
				TextBox/w = gr1_visTrMol_ta_mt /C /N = text1 /A = RT /X = 0.00 /Y = 20 "First trajectory"
			endif
			// update screen
			updateSignals( )
			//
			break
		case "saveDataButton":		// save data
			//
			pathinfo resPath
			if( V_flag == 0 )
				break
			endif
			// ask is that was not a coincidence
			prompt hh, "Are you surely want to quit?", popup, "yes;no;"
			doprompt "Choose", hh
			if( hh == 1 && V_flag != 1 ) // do not quit.
				//
				Save/C /O /p = resPath acceptRejIdicatorW as "051_accRejIndic.ibw"
				Save/C /O /p = resPath selFragTrTable as "052_selFragTr.ibw"	
				// close windows
				doWindow/k cPan_visTrMol_ta_mt			// control panel
				doWindow/k gr1_visTrMol_ta_mt			// trajectory
				doWindow/k gr2_visTrMol_ta_mt			// 1st image
				doWindow/k gr3_visTrMol_ta_mt			// 2nd image
				doWindow/k stChannel			
				doWindow/k ndChannel				
				// erase local waves, created by the program
				killwaves/a/z; killstrings/a/z; killVariables/z/a
				//
				print "Done"; beep
				//
			endif
			//
			break
		case "closeWindButton":
			// ask is that was not a coincidence
			prompt hh, "Are you surely want to quit?", popup, "yes;no;"
			doprompt "Choose", hh
			if( hh == 1 && V_flag != 1 ) // do not quit.
				// close windows
				doWindow/k cPan_visTrMol_ta_mt		// control panel
				doWindow/k gr1_visTrMol_ta_mt			// trajectory
				doWindow/k gr2_visTrMol_ta_mt			// 1st image
				doWindow/k gr3_visTrMol_ta_mt			// 2nd image
				doWindow/k stChannel			
				doWindow/k ndChannel	
				// erase local waves, created by the program
				killwaves/a/z; killstrings/a/z; killVariables/z/a
				//
			endif
			//
			break
	endswitch
End
//************************************************************************************************************************
function GUI_visTrMol_ta_mt( )
	//
	NVAR numTraj, frameId, numChToggle
	NVAR maxIntVar, minIntVar
	NVAR maxIntImage1, maxIntImage2
	NVAR axisPopUpVar
	NVAR accRejIndic
	//
	wave traceSubTypeW, acceptRejIdicatorW, chOnOffW
	//
	variable scale1 = 0
	//	control panel
	NewPanel/K=2/W=(0,0, 300,450) as "Trace Analyzer, v.1"
	doWindow/c cPan_visTrMol_ta_mt
	SetWindow cPan_visTrMol_ta_mt, hook(MyHook) = MyWindowHook_visTraj_TA_MT	// Install window hook
	// Button controls
	Button loadDataButton disable = 0 , fsize=12, pos={20, 2}, fstyle=0,size={150, 20}, title = "Load data", win=cPan_visTrMol_ta_mt, proc = loadWaves_visTraj_TA_MT
	Button fwButton disable = 2 , fsize=12, pos={100, 30}, fstyle=0,size={70, 20}, title = "Following", win=cPan_visTrMol_ta_mt, proc = butProc_visTrMol_ta_mt
	Button prevButton disable = 2 , fsize=12, pos={20, 30}, fstyle=0,size={70, 20}, title = "Previous", win=cPan_visTrMol_ta_mt, proc = butProc_visTrMol_ta_mt
	Button saveDataButton disable = 2 , fsize=12, pos={20, 90}, fstyle=0,size={80, 20}, title = "Save & close", win=cPan_visTrMol_ta_mt, proc = butProc_visTrMol_ta_mt
	Button closeWindButton disable = 2 , fsize=12, pos={105, 90}, fstyle=0,size={80, 20}, title = "Close", win=cPan_visTrMol_ta_mt, proc = butProc_visTrMol_ta_mt
	Button selFragTrButton disable = 2 , fsize=12, pos={190, 2}, fstyle=0,size={100, 20}, title = "Select fragment", win=cPan_visTrMol_ta_mt, proc = selFragTr_VisTrMol_TA_MT
	Button deSelFragTrButton disable = 2 , fsize=12, pos={190, 22}, fstyle=0,size={100, 20}, title = "Deselect frag.", win=cPan_visTrMol_ta_mt, proc = selFragTr_VisTrMol_TA_MT
	Button genReport_button disable = 2 , fsize=12, pos={190, 50}, fstyle=0,size={100, 20}, title = "Report", win=cPan_visTrMol_ta_mt, proc = report_VisTrMol_TA_MT
	Button histDraw_button disable = 2 , fsize=12, pos={190, 70}, fstyle=0,size={100, 20}, title = "Draw hist.", win=cPan_visTrMol_ta_mt, proc = hist_VisTrMol_TA_MT
	Button histOpt_button disable = 2 , fsize=12, pos={190, 90}, fstyle=0,size={100, 20}, title = "Hist. options", win=cPan_visTrMol_ta_mt, proc = hist_VisTrMol_TA_MT
	// Set variable controls
	SetVariable traceTypeMarkSetting disable = 2, live=1, fsize=12, limits={0, 10, 1}, pos={50, 60}, size = {100, 20}, value = accRejIndic, proc = setVarProc_visTrMol_ta_mt,title= "Type", win=cPan_visTrMol_ta_mt
	SetVariable minIntSetting disable = 2, fsize=12, limits={-inf, inf, 1}, pos={ 20, 210 }, size = {140, 20}, value = minIntVar,  proc = setVarProc_visTrMol_ta_mt, title= "Min int.", win=cPan_visTrMol_ta_mt
	SetVariable maxIntSetting disable = 2, fsize=12, limits={-inf, inf, 1}, pos={ 20, 230 }, size = {140, 20}, value = maxIntVar,  proc = setVarProc_visTrMol_ta_mt, title= "Max int.", win=cPan_visTrMol_ta_mt
	SetVariable intCh1_SV disable = 2, fsize=12, limits={-inf, inf, 1}, pos={ 20, 140 }, size = {140, 20}, value = maxIntImage1,  proc = setVarProc_visTrMol_ta_mt, title= "Int. ch1", win=cPan_visTrMol_ta_mt
	SetVariable intCh2_SV disable = 2, fsize=12, limits={-inf, inf, 1}, pos={ 20, 160 }, size = {140, 20}, value = maxIntImage2,  proc = setVarProc_visTrMol_ta_mt, title= "Int. ch2", win=cPan_visTrMol_ta_mt
	SetVariable frameId_SV disable = 2, fsize=12, limits={-inf, inf, 1}, pos={ 20, 280 }, size = {140, 20}, value = frameId,  proc = setVarProc_visTrMol_ta_mt, title= "Go to", win=cPan_visTrMol_ta_mt
	// Text box
	SetDrawLayer/w=cPan_visTrMol_ta_mt UserFront;	SetDrawEnv/w=cPan_visTrMol_ta_mt xcoord= abs,ycoord= abs,fillfgc= (0,65535,65535);
	DrawText/w=cPan_visTrMol_ta_mt 20,130,"Max. int. of images"
	SetDrawLayer/w=cPan_visTrMol_ta_mt UserFront;	SetDrawEnv/w=cPan_visTrMol_ta_mt xcoord= abs,ycoord= abs,fillfgc= (0,65535,65535);
	DrawText/w=cPan_visTrMol_ta_mt 20,205,"Range of axes"
	SetDrawLayer/w=cPan_visTrMol_ta_mt UserFront;	SetDrawEnv/w=cPan_visTrMol_ta_mt xcoord= abs,ycoord= abs,fillfgc= (0,65535,65535);
	DrawText/w=cPan_visTrMol_ta_mt 20, 325,"Load/show these traces"
	SetDrawLayer/w=cPan_visTrMol_ta_mt UserFront;	SetDrawEnv/w=cPan_visTrMol_ta_mt xcoord= abs,ycoord= abs,fillfgc= (0,65535,65535);
	DrawText/w=cPan_visTrMol_ta_mt 20, 275,"Molecule index indicator"
	// Raw trace
	if( traceSubTypeW[ 0 ] == 1 )
		CheckBox traceSubTypeCheckBox0 win = cPan_visTrMol_ta_mt, title="Raw signals" , size={190, 15}, value = 1, fsize=12, pos={20, 330}, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
	else
		CheckBox traceSubTypeCheckBox0 win = cPan_visTrMol_ta_mt, title="Raw signals" , size={190, 15}, value = 0, fsize=12, pos={20, 330}, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
	endif
	// Filtered trace
	if( traceSubTypeW[ 1 ] == 1 )
		CheckBox traceSubTypeCheckBox1 win = cPan_visTrMol_ta_mt, title="Filtered signals" , size={190, 15}, value = 1, fsize=12, pos={ 20, 350}, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
	else
		CheckBox traceSubTypeCheckBox1 win = cPan_visTrMol_ta_mt, title="Filtered signals" , size={190, 15}, value = 0, fsize=12, pos={20, 350}, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
	endif
	// Normalised trace
	if( traceSubTypeW[ 2 ] == 1 )
		CheckBox traceSubTypeCheckBox2 win = cPan_visTrMol_ta_mt, title="Normalised signals" , size={190, 15}, value = 1, fsize=12, pos={ 20, 370}, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
	else
		CheckBox traceSubTypeCheckBox2 win = cPan_visTrMol_ta_mt, title="Normalised signals" , size={190, 15}, value = 0, fsize=12, pos={20, 370}, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
	endif
	// Ideal trace
	if( traceSubTypeW[ 3 ] == 1 )
		CheckBox traceSubTypeCheckBox3 win = cPan_visTrMol_ta_mt, title="Ideal signals" , size={190, 15}, value = 1, fsize=12, pos={ 20, 390}, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
	else
		CheckBox traceSubTypeCheckBox3 win = cPan_visTrMol_ta_mt, title="Ideal signals" , size={190, 15}, value = 0, fsize=12, pos={20, 390}, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
	endif
	// anti-corr trace
	if( traceSubTypeW[ 4 ] == 1 )
		CheckBox traceSubTypeCheckBox4  win = cPan_visTrMol_ta_mt, title="Anti-corr. indicators" , size={190, 15}, value = 1, fsize=12, pos={ 20, 410}, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
	else
		CheckBox traceSubTypeCheckBox4 win = cPan_visTrMol_ta_mt, title= "Anti-corr. indicators" , size={190, 15}, value = 0, fsize=12, pos={20, 410}, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
	endif
	// accept/reject indicators
	if( traceSubTypeW[ 5 ] == 1 )
		CheckBox traceSubTypeCheckBox5  win = cPan_visTrMol_ta_mt, title="Acc/reject indicators (for loading data)" , size={190, 15}, value = 1, fsize=12, pos={ 20, 430}, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
	else
		CheckBox traceSubTypeCheckBox5 win = cPan_visTrMol_ta_mt, title= "Acc/reject indicators (for loading data)" , size={190, 15}, value = 0, fsize=12, pos={20, 430}, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
	endif
	// 1st ; 2nd ch on or off
	if( numChToggle == 3 )
		if( chOnOffW[ 0 ] == 1 )
			CheckBox stChOnOfCheckBox win = cPan_visTrMol_ta_mt, title="1st ch" , size={190, 15}, value = 1, fsize=12, pos={ 170, 350}, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
		else
			CheckBox stChOnOfCheckBox win = cPan_visTrMol_ta_mt, title="1st ch" , size={190, 15}, value = 0, fsize=12, pos={ 170, 350}, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
		endif
		if( chOnOffW[ 1 ] == 1 )
			CheckBox ndChOnOfCheckBox win = cPan_visTrMol_ta_mt, title="2nd ch" , size={190, 15}, value = 1, fsize=12, pos={ 170, 370}, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
		else
			CheckBox ndChOnOfCheckBox win = cPan_visTrMol_ta_mt, title="2nd ch" , size={190, 15}, value = 0, fsize=12, pos={ 170, 370}, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
		endif
		if( chOnOffW[ 2 ] == 1 )
			CheckBox rdChOnOfCheckBox win = cPan_visTrMol_ta_mt, title="FRET" , size={190, 15}, value = 1, fsize=12, pos={ 170, 390}, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
		else
			CheckBox rdChOnOfCheckBox win = cPan_visTrMol_ta_mt, title="FRET" , size={190, 15}, value = 0, fsize=12, pos={ 170, 390}, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
		endif
		if( chOnOffW[ 3 ] == 1 )
			CheckBox thChOnOfCheckBox win = cPan_visTrMol_ta_mt, title="Stoch." , size={190, 15}, value = 1, fsize=12, pos={ 170, 410}, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
		else
			CheckBox thChOnOfCheckBox win = cPan_visTrMol_ta_mt, title="Stoch." , size={190, 15}, value = 0, fsize=12, pos={ 170, 410}, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
		endif
		//
		SetDrawLayer/w=cPan_visTrMol_ta_mt UserFront;	SetDrawEnv/w=cPan_visTrMol_ta_mt xcoord= abs,ycoord= abs,fillfgc= (0,65535,65535);
		DrawText/w=cPan_visTrMol_ta_mt 160,340,"Show/Hide raw signals"
		//
	elseif( numChToggle == 2 ) // 2nd
		chOnOffW[ 0 ] = 0
		chOnOffW[ 1 ] = 1
		chOnOffW[ 2 ] = 0
		chOnOffW[ 3 ] = 0
	elseif( numChToggle == 1 ) // 1st
		chOnOffW[ 0 ] = 1
		chOnOffW[ 1 ] = 0
		chOnOffW[ 2 ] = 0
		chOnOffW[ 3 ] = 0
	elseif( numChToggle == 3 ) // fret
		chOnOffW[ 0 ] = 0
		chOnOffW[ 1 ] = 0
		chOnOffW[ 2 ] = 1
		chOnOffW[ 3 ] = 0
	elseif( numChToggle == 3 ) // Stoch.
		chOnOffW[ 0 ] = 0
		chOnOffW[ 1 ] = 0
		chOnOffW[ 2 ] = 0
		chOnOffW[ 3 ] = 1	
	endif
	// axis of analysed signals
	if( axisPopUpVar == 1 )
		popupmenu axis_PopUp font="Arial", fsize = 11, fstyle = 1, pos={170, 300}, size={ 100 , 20  }, mode = 1 ,value = "Top;Bottom;", title = "Anal. axis",win = cPan_visTrMol_ta_mt, proc = axisPopUp_visTraj_TA_MT,  popvalue = "Top"
	else
		popupmenu axis_PopUp font="Arial", fsize = 11, fstyle = 1, pos={170, 300 }, size={ 100 , 20  }, mode = 1 ,value = "Top;Bottom;", title = "Anal. axis",win = cPan_visTrMol_ta_mt, proc = axisPopUp_visTraj_TA_MT,  popvalue = "Bottom"
	endif
	// load image of the 1st and 2nd channel
	ImageLoad /N = image1Orig /O /T = tiff /Q /P=resPath /Z "stChImageProcessed.tif"
	ImageLoad /N = image2Orig /O /T = tiff /Q /P=resPath /Z "ndChImageProcessed.tif"
	wave image1Orig, image2Orig
	make/o /n = ( 1, 1 ) image1, image2
	// make 2 graphs with croped piece of the 1st and 2nd channel images
	newimage /s = 0 /k = 2 /n = gr2_visTrMol_ta_mt image1
	newimage /s = 0 /k = 2 /n = gr3_visTrMol_ta_mt image2
	// make a graph with signals
	make/o /n = 1 smTraj, smFiltTraj, smNormTraj, smAntiCorrTraj,smIdTraj
	make/o /n = 1 smTraj1, smTraj2, smAlexTraj1, smAlexTraj2, smAlexStochTraj
	make/o /n = 20 hist1, hist2;	hist1 = 0; hist2 = 0
	//
	display/n = gr1_visTrMol_ta_mt smTraj, smAlexStochTraj
	//
	removefromgraph/Z /w = gr1_visTrMol_ta_mt smFiltTraj, smNormTraj, smAntiCorrTraj,smIdTraj
	if( axisPopUpVar == 1 )
		appendtograph/w = gr1_visTrMol_ta_mt /l = left1 smFiltTraj, smNormTraj, smAntiCorrTraj,smIdTraj
	else
		appendtograph/w = gr1_visTrMol_ta_mt smFiltTraj, smNormTraj, smAntiCorrTraj,smIdTraj
	endif
	//
	if( numChToggle == 3 )
		appendtograph/w = gr1_visTrMol_ta_mt /l = left1 smTraj1, smTraj2, smAlexTraj1, smAlexTraj2
	else
		appendtograph/w = gr1_visTrMol_ta_mt smTraj1, smTraj2, smAlexTraj1, smAlexTraj2
	endif
	// append histograms
	appendtograph/w = gr1_visTrMol_ta_mt /VERT hist1
	appendtograph/w = gr1_visTrMol_ta_mt /l = left1 /VERT hist2
	//
	if( numChToggle == 3 )
		ModifyGraph/w=gr1_visTrMol_ta_mt zero(left1)=1,axisEnab(left)={0,0.45},axisEnab(left1)={0.5,1}, freePos(left1)={0,bottom}, lsize=1
	endif
	//
	ModifyGraph/w=gr1_visTrMol_ta_mt rgb(smTraj)=(40000,0,0), rgb(smFiltTraj)=(40000,0,0),rgb(smIdTraj)=(40000,0,0), rgb(smNormTraj)=(40000,0,0), lsize(smIdTraj)=1.5,rgb(smIdTraj)=(0,0,0)
	ModifyGraph/w=gr1_visTrMol_ta_mt rgb(smTraj1)=(0,40000,0), rgb(smTraj2)=(40000,0,0)
	ModifyGraph/w=gr1_visTrMol_ta_mt rgb(smAlexStochTraj)=(1,16019,65535), rgb(smAlexTraj1)=(0,0,0), rgb(smAlexTraj2)=(65535,0,52428)
	ModifyGraph/w=gr1_visTrMol_ta_mt mode(smAntiCorrTraj)=3, marker(smAntiCorrTraj)=8, rgb(smAntiCorrTraj)=(0,65535,65535), msize(smAntiCorrTraj)=6,mrkThick(smAntiCorrTraj)=2, opaque=0
	//
	if( numChToggle == 3 )
	ModifyGraph/w = gr1_visTrMol_ta_mt lblPosMode(left1)=1, grid=1,nticks=10,gridRGB=(34952,34952,34952)
	endif
	//
	ModifyGraph /w = gr1_visTrMol_ta_mt grid(left)=1,gridRGB(left)=(34952,34952,34952)
	// organise windows
	autoscaleWind_VisTrMol_TA_MT("")
	//
end
//
Function MyWindowHook_visTraj_TA_MT(s)
	STRUCT WMWinHookStruct &s
	//
	Variable hookResult = 0	// 0 if we do not handle event, 1 if we handle it.
	wave acceptRejIdicatorW
	NVAR frameId, accRejIndic
	//
	switch(s.eventCode)
		case 11:					// Keyboard event
			switch (s.keycode)
				case 28:		// left arrow.
					butProc_visTrMol_ta_mt("prevButton")
					hookResult = 1
					break
				case 29:		// rigth arrow.
					butProc_visTrMol_ta_mt("fwButton")
					hookResult = 1
					break
				case 30:		// up arrow.
					acceptRejIdicatorW[ frameId ] += 1
					hookResult = 1
					accRejIndic = acceptRejIdicatorW[ frameId ]
					SetVariable traceTypeMarkSetting value = accRejIndic, proc = setVarProc_visTrMol_ta_mt,title= "Type", win=cPan_visTrMol_ta_mt
					updateSignals( )
					break
				case 31:		// down arrow.
					acceptRejIdicatorW[ frameId ] -= 1
					hookResult = 1
					accRejIndic = acceptRejIdicatorW[ frameId ]
					SetVariable traceTypeMarkSetting value = accRejIndic, proc = setVarProc_visTrMol_ta_mt,title= "Type", win=cPan_visTrMol_ta_mt
					updateSignals( )
					break		
			endswitch
			break
	endswitch
	//
	return hookResult
	//
End
// setting values for popupmenuControl variables
function axisPopUp_visTraj_TA_MT(PM_Struct) : PopupMenuControl
	STRUCT WMPopupAction &PM_Struct 
	//
	NVAR axisPopUpVar
	wave smFiltTraj, smNormTraj, smAntiCorrTraj, smIdTraj
	//
	if( PM_Struct.eventCode == 1 || PM_Struct.eventCode == 2 )		// act only on Enter key accepting edit, or on mouse up in the arrow buttons
		// checking which of the popup men us where selected
		strswitch( PM_Struct.ctrlName )						// string switch
		case "axis_PopUp":
			axisPopUpVar = PM_Struct.popNum
			//
			removefromgraph/Z /w = gr1_visTrMol_ta_mt smFiltTraj, smNormTraj, smAntiCorrTraj, smIdTraj
			if( axisPopUpVar == 1 )
				appendtograph/w = gr1_visTrMol_ta_mt /l = left1 smFiltTraj, smNormTraj, smAntiCorrTraj, smIdTraj
			else
				appendtograph/w = gr1_visTrMol_ta_mt smFiltTraj, smNormTraj, smAntiCorrTraj, smIdTraj
			endif
			//
			break
			//
		endswitch
		//
	endif		
end
//  place windows in the original positions
function autoscaleWind_VisTrMol_TA_MT(ctrlName)
	String ctrlName
	//
	wave image1Orig, image2Orig
	//
	variable scale1
	//
	moveWindow /w= gr1_visTrMol_ta_mt 350, 20, 1220, 500
	moveWindow /w= gr2_visTrMol_ta_mt 360, 23, 662, 285
	moveWindow /w= gr3_visTrMol_ta_mt 670, 23, 973, 283
	scale1 = dimsize(image1Orig,1) / dimsize(image1Orig,0)
	scale1 = dimsize(image2Orig,1) / dimsize(image2Orig,0)
	//
end
// histogram options
function hist_VisTrMol_TA_MT(ctrlName) : ButtonControl
	string ctrlName
	//
	wave hist1, hist2
	NVAR var1G, var2G, minHistInt1G, maxHistInt1G, minHistInt2G, maxHistInt2G, durG, normCG, nBinsG
	//
	variable var1=var1G, var2=var2G, minHistInt1=minHistInt1G, maxHistInt1=maxHistInt1G
	variable minHistInt2=minHistInt2G, maxHistInt2=maxHistInt2G, dur=durG, normC=normCG, nBins=nBinsG
	string list1 = "Hide;"+WaveList("*", ";", "WIN:gr1_visTrMol_ta_mt" )
	//
	variable V_flag = 0
	//
	strswitch ( ctrlName	)
		case "histOpt_button":
			//
			prompt var1, "Bottom panel", popup, list1
			prompt var2, "Top panel", popup, list1
			prompt minHistInt1, "Min. int. bottom panel"
			prompt maxHistInt1, "Max. int. bottom panel"
			prompt minHistInt2, "Min. int. top panel"
			prompt maxHistInt2, "Max. int. top panel"
			prompt dur, "End point top panel"
			prompt normC, "nor.m constant for both."
			prompt nBins, "# of bins for both."
			doPrompt "Select wave for histogram", var1, var2, minHistInt1, maxHistInt1, minHistInt2, maxHistInt2, dur, normC, nBins
			//
			break
	endswitch
	//
	if( V_flag == 0 )
		//
		var1G=var1; var2G=var2; minHistInt1G=minHistInt1; maxHistInt1G=maxHistInt1
		minHistInt2G=minHistInt2; maxHistInt2G=maxHistInt2; durG=dur; normCG=normC; nBinsG=nBins
		//
		if( var1 != 1 )
			duplicate/o/r=[0, dur] $stringfromlist(var1-1,list1,";"), wave1
			make/o/n=(nBins) hist1
			histogram/p/c/b={ minHistInt1, maxHistInt1/dimsize(hist1,0), dimsize(hist1,0)} wave1, hist1
			wavestats/q hist1; hist1 /= V_max
			hist1 *=  normC
			ModifyGraph/w = gr1_visTrMol_ta_Mt hideTrace(hist1)=0
		else
			ModifyGraph/w = gr1_visTrMol_ta_Mt hideTrace(hist1)=1
		endif
		//
		if( var2 != 1 )
			duplicate/o/r=[0,dur] $stringfromlist(var2-1,list1,";"), wave2
			make/o/n=(nBins) hist2
			histogram/p/c/b={ minHistInt2, maxHistInt2/dimsize(hist2,0), dimsize(hist2,0)} wave2, hist2
			wavestats/q hist2; hist2 /= V_max
			hist2 *=  normC
			ModifyGraph/w = gr1_visTrMol_ta_Mt hideTrace(hist2)=0
		else
			ModifyGraph/w = gr1_visTrMol_ta_Mt hideTrace(hist2)=1
		endif
		//
	endif
	//
	ModifyGraph/w = gr1_visTrMol_ta_Mt lsize(hist1)=1.5,rgb(hist1)=(0,0,0),lsize(hist2)=1.5, rgb(hist2)=(0,0,0)
	//
end
// slection fragment of trace
function selFragTr_VisTrMol_TA_MT(ctrlName) : ButtonControl
	string ctrlName    // selFragTrButton; deSelFragTrButton;
	//
	NVAR frameId
	//
	wave selFragTrTable
	//
	strswitch ( ctrlName	)
		case "selFragTrButton":
			//
			selFragTrTable[frameId][0] = min( pcsr(A), pcsr(B) )
			selFragTrTable[frameId][1] = max( pcsr(A), pcsr(B) )
			//
			frameId += 1
			//
			break
			//
		case "deSelFragTrButton":
			//
			selFragTrTable[frameId][0] = 0
			selFragTrTable[frameId][1] = 0
			//
			frameId += 1		
			//
			break
			//
	endswitch
	//
	updateSignals(  )
	//
end
// generate report file
function report_VisTrMol_TA_MT(ctrlName) : ButtonControl
	string ctrlName
	//
	NVAR frameId, numTraj
	wave acceptRejIdicatorW, selFragTrTable
	//
	variable currFr, traceTag, typeSelection, startTrace = 0, countGrpahs = 0
	//
	prompt typeSelection,  "Selection type: ", popup, "Type;Fragment;"
	prompt startTrace, "start with this trace"
	doPrompt "Select", typeSelection, startTrace
	if( V_flag == 1 )
		abort
	else
		if( typeSelection == 1 )
			//
			prompt traceTag,  "Plot traces indicated by this tag: "
			doPrompt "Enter number", traceTag
			if( V_flag == 1 )
				abort
			endif
			//
		endif
	endif
	// open new notebook
	dowindow/K report_TA_MT
	NewNotebook /F=1 /N=report_TA_MT  /W=(0,0,600,800 )
	NoteBook report_TA_MT text = "\r\tAccepted signals"
	// selected
	for( currFr = startTrace ; currFr < numTraj; currFr += 1 )
		//
		if( typeSelection == 1 )
			//
			if( acceptRejIdicatorW[ currFr ] == traceTag )
				//
				frameId = currFr
				//
				updateSignals(  )
				//
				doUpdate
				//
				NoteBook report_TA_MT text = "\r\t# of graph "+num2str(countGrpahs)
				Notebook report_TA_MT,  picture={gr1_visTrMol_ta_mt, -5 ,1}
				countGrpahs += 1
				//
			endif
			//
		else
			//
			if( selFragTrTable[ currFr ][0] + selFragTrTable[ currFr ][1] > 0 )
				//
				frameId = currFr
				//
				updateSignals(  )
				//
				doUpdate
				//
				Notebook report_TA_MT,  picture={gr1_visTrMol_ta_mt, -5 ,1}
				//
			endif
			//	
		endif
		//
	endFor
	//
end
//*****************************************************************************
//
Function checkBoxProc_visTrMol_ta_mt(CB_Struct) : CheckBoxControl
	STRUCT WMCheckboxAction &CB_Struct 
	//
	wave traceSubTypeW, chOnOffW
	NVAR traceLoaded
	//
	if( CB_Struct.eventCode == 1 || CB_Struct.eventCode == 2 )			// act only on Enter key accepting edit, or on mouse up in the arrow buttons
		//
		strswitch( CB_Struct.ctrlName )
		case "traceSubTypeCheckBox0":	// trajectory raw
			traceSubTypeW[0] = CB_Struct.checked
			// hide/show  signals
			if( traceSubTypeW[0]  == 1 )
				ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smTraj)=0, hideTrace(smTraj1)=0, hideTrace(smTraj2)=0,  hideTrace(smAlexTraj1)=0, hideTrace(smAlexTraj2)=0 , hideTrace(smAlexStochTraj)=0 
			else
				ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smTraj)=1, hideTrace(smTraj1)=1, hideTrace(smTraj2)=1, hideTrace(smAlexTraj1)=1, hideTrace(smAlexTraj2)=1 , hideTrace(smAlexStochTraj)=1 
			endif
			//
			break
		case "traceSubTypeCheckBox1":	// trajectory filtered
			traceSubTypeW[1] = CB_Struct.checked
			// hide/show  signals
			if( traceSubTypeW[1]  == 1 )
				ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smFiltTraj)=0
			else
				ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smFiltTraj)=1
			endif
			//
			break
		case "traceSubTypeCheckBox2":	// trajectory normalised
			traceSubTypeW[2] = CB_Struct.checked
			// hide/show  signals
			if( traceSubTypeW[2]  == 1 )
				ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smNormTraj)=0
			else
				ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smNormTraj)=1
			endif
			//
			break
		case "traceSubTypeCheckBox3":	// trajectory ideal
			traceSubTypeW[3] = CB_Struct.checked
			// hide/show  signals
			if( traceSubTypeW[3]  == 1 )
				ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smIdTraj)=0
			else
				ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smIdTraj)=1
			endif
			//
			break
		case "traceSubTypeCheckBox4":	//  anticorrelation indicators
			traceSubTypeW[4] = CB_Struct.checked
			// hide/show  signals
			if( traceSubTypeW[4]  == 1 )
				ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smAntiCorrTraj)=0
			else
				ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smAntiCorrTraj)=1
			endif
			//
			break
		case "traceSubTypeCheckBox5":	//  accept/reject indicators
			traceSubTypeW[5] = CB_Struct.checked
			//
			break
		case "stChOnOfCheckBox":	//  1st ch. on/off indicators
			chOnOffW[ 0 ] = CB_Struct.checked
			if( chOnOffW[ 0 ] == 1 )
				CheckBox stChOnOfCheckBox win = cPan_visTrMol_ta_mt, title="1st ch", value = 1, fsize=12, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
			else
				CheckBox stChOnOfCheckBox win = cPan_visTrMol_ta_mt, title="1st ch" , value = 0, fsize=12, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
			endif
			//
			break		
			//
		case "ndChOnOfCheckBox":	//  2nd ch. on/off indicators
			chOnOffW[ 1 ] = CB_Struct.checked
			if( chOnOffW[ 1 ] == 1 )
				CheckBox ndChOnOfCheckBox win = cPan_visTrMol_ta_mt, title="2nd ch", value = 1, fsize=12, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
			else
				CheckBox ndChOnOfCheckBox win = cPan_visTrMol_ta_mt, title="2nd ch" , value = 0, fsize=12, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
			endif
			//
			break		
			//	
		case "rdChOnOfCheckBox":	//  FRET ch. on/off indicators
			chOnOffW[ 2 ] = CB_Struct.checked
			if( chOnOffW[ 2 ] == 1 )
				CheckBox rdChOnOfCheckBox win = cPan_visTrMol_ta_mt, title="FRET", value = 1, fsize=12, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
			else
				CheckBox rdChOnOfCheckBox win = cPan_visTrMol_ta_mt, title="FRET", value = 0, fsize=12, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
			endif
			//
			break		
			//	
		case "thChOnOfCheckBox":	//  Stoch ch. on/off indicators
			chOnOffW[ 3 ] = CB_Struct.checked
			if( chOnOffW[ 3 ] == 1 )
				CheckBox thChOnOfCheckBox win = cPan_visTrMol_ta_mt, title="Stoch.", value = 1, fsize=12, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
			else
				CheckBox thChOnOfCheckBox win = cPan_visTrMol_ta_mt, title="Stoch.", value = 0, fsize=12, mode = 0 , proc = checkBoxProc_visTrMol_ta_mt
			endif
			//
			break		
			//			
		endswitch
		//
	endif
	//
	if( traceLoaded != 1 )
	
	else
		updateSignals( )
	endif
	//
end
//
function setVarProc_visTrMol_ta_mt(SV_Struct ) : SetVariableControl
	STRUCT WMSetVariableAction &SV_Struct
	//
	NVAR maxIntVar, minIntVar
	NVAR frameId
	NVAR maxIntImage1, maxIntImage2
	NVAR accRejIndic
	wave acceptRejIdicatorW
	//
	if( SV_Struct.eventCode == 1 || SV_Struct.eventCode == 2 )			// act only on Enter key accepting edit, or on mouse up in the arrow buttons
		//
		strswitch( SV_Struct.ctrlName )
		case "minIntSetting":
			minIntVar = SV_Struct.dval
			break
		case "maxIntSetting":
			maxIntVar = SV_Struct.dval
			break
		case "intCh1_SV":
			maxIntImage1 = SV_Struct.dval
			break
		case "intCh2_SV":
			maxIntImage2 = SV_Struct.dval
			break
		case "frameID_SV":
			//
			frameId = SV_Struct.dval
			SetVariable frameId_SV value = frameId, proc = setVarProc_visTrMol_ta_mt, win=cPan_visTrMol_ta_mt
			//
			break
		case "traceTypeMarkSetting":
			//
			accRejIndic = SV_Struct.dval
			acceptRejIdicatorW[ frameId ] = SV_Struct.dval
			//
			break
			//
		endswitch
		//
		updateSignals( )
		//
	endif
	//
end
//********************************************************************************
// load signals and images.
function loadWaves_visTraj_TA_MT(ctrlName) : ButtonControl
	String ctrlName
	// global varaibels
	NVAR numChToggle, numTraj
	NVAR traceLoaded
	NVAR excitationType
	wave traceSubTypeW
	// local variabels
	string fileName
	variable nPnts = 0
	// these tables are the same for selected or all extracted.
	// particle info table
	fileName = ListMatch( (indexedFIle ( resPath , -1 , ".ibw" )) , "*040_*" );	LoadWave/H/O/N = wave1/P = resPath/Q stringFromList(0 , fileName, ";" );	duplicate/o $stringFromlist( 0 , S_wavenames ), particleInfoTable	
	// raw trace
	If( traceSubTypeW[ 0 ] == 1 )
		fileName = ListMatch( (indexedFIle ( resPath , -1 , ".ibw" )) , "*030_0_*" );	LoadWave/H/O/N = wave1/P = resPath/Q stringFromList(0 , fileName, ";" );	duplicate/o $stringFromlist( 0 , S_wavenames ), trajRawTable
		nPnts = dimSize( trajRawTable, 0 )
	endif
	//  filtered trace
	If( traceSubTypeW[ 1 ] == 1 )
		fileName = ListMatch( (indexedFIle ( resPath , -1 , ".ibw" )) , "*031_0_*" );	LoadWave/H/O/N = wave1/P = resPath/Q stringFromList(0 , fileName, ";"  );	duplicate/o $stringFromlist( 0 , S_wavenames ), trajFiltTable
		nPnts = dimSize( trajFiltTable, 0 )
	endif
	//  normalized trace
	If( traceSubTypeW[ 2 ] == 1 )
		fileName = ListMatch( (indexedFIle ( resPath , -1 , ".ibw" )) , "*032_0_*" );	LoadWave/H/O/N = wave1/P = resPath/Q stringFromList(0 , fileName, ";"  );	duplicate/o $stringFromlist( 0 , S_wavenames ), trajNormTable
		nPnts = dimSize( trajNormTable, 0 )
	endif
	//  ideal trace
	If( traceSubTypeW[ 3 ] == 1 )
		fileName = ListMatch( (indexedFIle ( resPath , -1 , ".ibw" )) , "*033_0_*" );	LoadWave/H/O/N = wave1/P = resPath/Q stringFromList(0 , fileName, ";"  );	duplicate/o $stringFromlist( 0 , S_wavenames ), trajIdTable
		nPnts = dimSize( trajIdTable, 0 )
	endif
	// accepted/rejected indicator table
	if(  traceSubTypeW[ 5 ] == 1 )
		fileName = ListMatch( (indexedFIle ( resPath , -1 , ".ibw" )) , "*051_*" );	LoadWave/H/O/N = wave1/P = resPath/Q stringFromList(0 , fileName, ";"  );	duplicate/o $stringFromlist( 0 , S_wavenames ), acceptRejIdicatorW
		fileName = ListMatch( (indexedFIle ( resPath , -1 , ".ibw" )) , "*052_*" );	LoadWave/H/O/N = wave1/P = resPath/Q stringFromList(0 , fileName, ";"  );	duplicate/o $stringFromlist( 0 , S_wavenames ), selFragTrTable
	else
		make/o /n= ( dimsize( particleInfoTable, 0 ) ) acceptRejIdicatorW
		make/o /n= ( dimsize( particleInfoTable, 0 ), 2 ) selFragTrTable
	endif
	// FRET.
	if( numChToggle == 3 )
		// Raw signal tables
		If( traceSubTypeW[ 0 ] == 1 )
			fileName = ListMatch( (indexedFIle ( resPath , -1 , ".ibw" )) , "*030_1_*" );	LoadWave/H/O/N = wave1/P = resPath/Q stringFromList(0 , fileName, ";"  );	duplicate/o $stringFromlist( 0 , S_wavenames ), trajRawTable1
			fileName = ListMatch( (indexedFIle ( resPath , -1 , ".ibw" )) , "*030_2_*" );	LoadWave/H/O/N = wave1/P = resPath/Q stringFromList(0 , fileName, ";"  );	duplicate/o $stringFromlist( 0 , S_wavenames ), trajRawTable2
		endif
		// anti-correlation
		if(  traceSubTypeW[ 4 ] == 1 )
			fileName = ListMatch( (indexedFIle ( resPath , -1 , ".ibw" )) , "*034_0_*" );	LoadWave/H/O/N = wave1/P = resPath/Q stringFromList(0 , fileName, ";"  );	duplicate/o $stringFromlist( 0 , S_wavenames ), antiCorIndTable
		endif
		// ALEX
		if( excitationType == 1 )
			If( traceSubTypeW[ 0 ] == 1 )
				fileName = ListMatch( (indexedFIle ( resPath , -1 , ".ibw" )) , "*030_6_*" );	LoadWave/H/O/N = wave1/P = resPath/Q stringFromList(0 , fileName, ";"  );	duplicate/o $stringFromlist( 0 , S_wavenames ), trajAlexTable1
				fileName = ListMatch( (indexedFIle ( resPath , -1 , ".ibw" )) , "*030_7_*" );	LoadWave/H/O/N = wave1/P = resPath/Q stringFromList(0 , fileName, ";"  );	duplicate/o $stringFromlist( 0 , S_wavenames ), trajAlexTable2
				fileName = ListMatch( (indexedFIle ( resPath , -1 , ".ibw" )) , "*030_10_*" );	LoadWave/H/O/N = wave1/P = resPath/Q stringFromList(0 , fileName, ";"  );	duplicate/o $stringFromlist( 0 , S_wavenames ), AlexStochTable				
			endif
		endif
		//
	endif
	// estimate number of trajectories
	numTraj = dimsize( particleInfoTable, 0 )
	//
	traceLoaded = 1
	//
	updateSignals( )
	// disable the load data button
	Button loadDataButton disable = 2, win=cPan_visTrMol_ta_mt
	// enable other controls
	Button fwButton disable = 0, win=cPan_visTrMol_ta_mt
	Button prevButton disable = 0, win=cPan_visTrMol_ta_mt
	Button saveDataButton disable = 0, win=cPan_visTrMol_ta_mt
	Button closeWindButton disable = 0, win=cPan_visTrMol_ta_mt
	Button selFragTrButton disable = 0, win=cPan_visTrMol_ta_mt
	Button deSelFragTrButton disable = 0, win=cPan_visTrMol_ta_mt
	Button genReport_button disable = 0, win=cPan_visTrMol_ta_mt
	Button histDraw_button disable = 0, win=cPan_visTrMol_ta_mt
	Button histOpt_button disable = 0, win=cPan_visTrMol_ta_mt
	SetVariable traceTypeMarkSetting disable = 0, win=cPan_visTrMol_ta_mt	
	SetVariable minIntSetting disable = 0, win=cPan_visTrMol_ta_mt
	SetVariable maxIntSetting disable = 0, win=cPan_visTrMol_ta_mt
	SetVariable intCh1_SV disable = 0, win=cPan_visTrMol_ta_mt
	SetVariable intCh2_SV disable = 0, win=cPan_visTrMol_ta_mt
	SetVariable frameId_SV disable = 0, win=cPan_visTrMol_ta_mt	
	// 
end
//
function updateSignals(  )
	// global variables
	NVAR frameId, frSize, numTraj, numChToggle
	NVAR maxIntVar, traceLoaded, minIntVar
	NVAR excitationType
	NVAR x0ROI, x1ROI, y0ROI, y1ROI
	NVAR maxIntImage1, maxIntImage2
	SVAR movieName1
	// referencing tables
	wave particleInfoTable
	wave acceptRejIdicatorW
	wave image1Orig, image2Orig
	wave traceSubTypeW
	wave chOnOffW
	wave selFragTrTable
	// local variables
	variable xCoord, yCoord
	variable xCoord1, yCoord1
	variable x1, x2, y1, y2, avgIntExcInt
	variable aa
	//
	if( traceLoaded != 1 )
		print "first loade the data"
		abort
	endif
	//**** crop piece of image representing current molecule and draw a crosshair.
	// crop
	if( numChToggle == 3 )
		xCoord = round( particleInfoTable[frameId][%xC1] );	yCoord = round( particleInfoTable[frameId][%yC1] )
		duplicate/o /r = [ xCoord - frSize, xCoord + frSize ][ yCoord - frSize, yCoord + frSize ] image1Orig, image1	// channel 1
		xCoord = round( particleInfoTable[frameId][%xC2] );	yCoord = round( particleInfoTable[frameId][%yC2] )
		duplicate/o /r = [ xCoord - frSize, xCoord + frSize ][ yCoord - frSize, yCoord + frSize ] image2Orig, image2	// channel 2
	elseif( numChToggle == 1 )
		xCoord = round( particleInfoTable[frameId][%xC1] );	yCoord = round( particleInfoTable[frameId][%yC1] )
		duplicate/o /r = [ xCoord - frSize, xCoord + frSize ][ yCoord - frSize, yCoord + frSize ] image1Orig, image1	// channel 1
		xCoord = round( particleInfoTable[frameId][%xC1] );	yCoord = round( particleInfoTable[frameId][%yC1] )
		duplicate/o /r = [ xCoord - frSize, xCoord + frSize ][ yCoord - frSize, yCoord + frSize ] image2Orig, image2	// channel 2	
	elseif( numChToggle == 2 )
		xCoord = round( particleInfoTable[frameId][%xC2] );	yCoord = round( particleInfoTable[frameId][%yC2] )
		duplicate/o /r = [ xCoord - frSize, xCoord + frSize ][ yCoord - frSize, yCoord + frSize ] image1Orig, image1	// channel 1
		xCoord = round( particleInfoTable[frameId][%xC2] );	yCoord = round( particleInfoTable[frameId][%yC2] )
		duplicate/o /r = [ xCoord - frSize, xCoord + frSize ][ yCoord - frSize, yCoord + frSize ] image2Orig, image2	// channel 2	
	endif
	//
	setscale/p x 0, 1 , image1; 	setscale/p y 0, 1 , image1
	setscale/p x 0, 1 , image2; 	setscale/p y 0, 1 , image2
	// draw cross-hair 1st ch.
	SetDrawLayer/W=gr2_visTrMol_ta_mt /k userFront
	SetDrawEnv/w=gr2_visTrMol_ta_mt xcoord= top,ycoord= left,linefgc= (65535,0,0),dash= 7,linethick= 2.00
	DrawLine/w=gr2_visTrMol_ta_mt abs( dimsize(image1,0)*0.5) -0.5, 0, abs( dimsize(image1,0)*0.5 ) - 0.5, dimsize(image1,1)-1
	SetDrawLayer/W=gr2_visTrMol_ta_mt /k progFront
	SetDrawEnv/w=gr2_visTrMol_ta_mt xcoord= top,ycoord= left,linefgc= (65535,0,0),dash= 7,linethick= 2.00
	DrawLine/w=gr2_visTrMol_ta_mt 0, abs( dimsize(image1,1)*0.5 ) - 0.5, dimsize(image1,0)-1, abs( dimsize(image1,1)*0.5 ) - 0.5
	// draw cross-hair 2nd ch.
	SetDrawLayer/W=gr3_visTrMol_ta_mt /k userFront
	SetDrawEnv/w=gr3_visTrMol_ta_mt xcoord= top,ycoord= left,linefgc= (65535,0,0),dash= 7,linethick= 2.00
	DrawLine/w=gr3_visTrMol_ta_mt abs( dimsize(image2,0)*0.5 ) - 0.5, 0, abs( dimsize(image2,0)*0.5 ) - 0.5, dimsize(image2,1)-1
	SetDrawLayer/W=gr3_visTrMol_ta_mt /k progFront
	SetDrawEnv/w=gr3_visTrMol_ta_mt xcoord= top,ycoord= left,linefgc= (65535,0,0),dash= 7,linethick= 2.00
	DrawLine/w=gr3_visTrMol_ta_mt 0, abs( dimsize(image2,1)*0.5 ) - 0.5, dimsize(image2,0)-1, abs( dimsize(image2,1)*0.5 ) - 0.5
	//
	wavestats/q image1; 	ModifyImage/w=gr2_visTrMol_ta_mt image1 ctab= {V_min,maxIntImage1,Grays,0}
	wavestats/q image2;	ModifyImage/w=gr3_visTrMol_ta_mt image2 ctab= {0,maxIntImage2,Grays,0}
	// crop single trace
	if( numChToggle == 3 )
		// raw traces
		if( traceSubTypeW[ 0 ] == 1 )
			//
			wave trajRawTable, trajRawTable1, trajRawTable2
			duplicate/o /r=[ *, * ][ frameId, frameId ] trajRawTable, smTraj
			duplicate/o /r=[ *, * ][ frameId, frameId ] trajRawTable1, smTraj1
			duplicate/o /r=[ *, * ][ frameId, frameId ] trajRawTable2, smTraj2
			//
			if( excitationType == 1 )
				wave trajAlexTable1,trajAlexTable2, AlexStochTable
				duplicate/o /r=[ *, * ][ frameId, frameId ] trajAlexTable1, smAlexTraj1
				duplicate/o /r=[ *, * ][ frameId, frameId ] trajAlexTable2, smAlexTraj2
				duplicate/o /r=[ *, * ][ frameId, frameId ] AlexStochTable, smAlexStochTraj
			endif
			//
			if( chOnOffW[ 0 ] == 1 ) 
				ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smTraj1)=0, hideTrace(smAlexTraj1)=0
			else
				ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smTraj1)=1, hideTrace(smAlexTraj1)=1
			endif
			if( chOnOffW[ 1 ] == 1 ) 
				ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smTraj2)=0, hideTrace(smAlexTraj2)=0
			else
				ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smTraj2)=1, hideTrace(smAlexTraj2)=1
			endif
			if( chOnOffW[ 2 ] == 1 ) 
				ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smTraj)=0
			else
				ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smTraj)=1
			endif
			if( chOnOffW[ 3 ] == 1 ) 
				ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smAlexStochTraj)=0
			else
				ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smAlexStochTraj)=1
			endif	
			//
		else
			smTraj = nan
			smTraj1 = nan
			smTraj2 = nan
			ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smTraj)=1, hideTrace(smTraj1)=1,hideTrace(smAlexTraj1)=1, hideTrace(smAlexTraj2)=1,hideTrace(smAlexStochTraj)=1
		endif
		// filtered traces
		if( traceSubTypeW[ 1 ] == 1 ) 
			//
			wave trajFiltTable
			duplicate/o /r=[ *, * ][ frameId, frameId ] trajFiltTable, smFiltTraj
			//
			ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smFiltTraj)=0
			//
		else
			smFiltTraj = nan
			ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smFiltTraj)=1
		endif
		// normalised traces
		if( traceSubTypeW[ 2 ] == 1 ) 
			//
			wave trajNormTable
			duplicate/o /r=[ *, * ][ frameId, frameId ] trajNormTable, smNormTraj
			//
			ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smNormTraj)=0
			//
		else
			smNormTraj = nan
			ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smNormTraj)=1
		endif
		// ideal traces
		if( traceSubTypeW[ 3 ] == 1 ) 
			wave trajIdTable
			duplicate/o /r=[ *, * ][ frameId, frameId ] trajIdTable, smIdTraj
			ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smIdTraj)=0
		else
			smIdTraj = nan
			ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smIdTraj)=1
		endif
		// anti-corr indicator trace
		if( traceSubTypeW[ 4 ] == 1 ) 
			wave antiCorIndTable
			duplicate/o /r=[ *, * ][ frameId, frameId ] antiCorIndTable, smAntiCorrTraj
			ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smAntiCorrTraj)=0
		else
			smAntiCorrTraj = nan
			ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smAntiCorrTraj)=1
		endif
		//
		setaxis/a /w = gr1_visTrMol_ta_mt left1 minIntVar, maxIntVar
		setaxis/a /w = gr1_visTrMol_ta_mt left -0.1,1.1
		//
	else
		//
		if( traceSubTypeW[ 0 ] == 1 ) 
			wave trajRawTable
			duplicate/o /r=[ *, * ][ frameId, frameId ] trajRawTable, smTraj
			ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smTraj)=0
		else
			smTraj = nan
			ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smTraj)=1
		endif
		//
		if( traceSubTypeW[ 1 ] == 1 ) 
			wave trajFiltTable
			duplicate/o /r=[ *, * ][ frameId, frameId ] trajFiltTable, smFiltTraj
			ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smFiltTraj)=0
		else
			smFiltTraj = nan
			ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smFiltTraj)=1
		endif
		//
		if( traceSubTypeW[ 2 ] == 1 ) 
			wave trajNormTable
			duplicate/o /r=[ *, * ][ frameId, frameId ] trajNormTable, smNormTraj
			ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smNormTraj)=0
		else
			smNormTraj = nan
			ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smNormTraj)=1
		endif
		//
		if( traceSubTypeW[ 3 ] == 1 ) 
			wave trajIdTable
			duplicate/o /r=[ *, * ][ frameId, frameId ] trajIdTable, smIdTraj
			ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smIdTraj)=0
		else
			smIdTraj = nan
			ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(smIdTraj)=1
		endif
		//
		setaxis/a /w = gr1_visTrMol_ta_mt left minIntVar, maxIntVar
		//
	endif
	//
	setaxis/a /w = gr1_visTrMol_ta_mt bottom *,*
	// update indicator text box
	if( numChToggle == 3 )
		TextBox/w = gr2_visTrMol_ta_mt /C /N = text0 /k
		TextBox/w = gr2_visTrMol_ta_mt /C /N = text0 /A = RT /X = 0.00 /Y = 0.00 "Molecule #: "+num2str( frameId + 1 )+", from: . "+num2str( numTraj )+"\rChannel 1"
		AppendText /W = gr2_visTrMol_ta_mt /N = text0 "\K(45000,0,0)xC, yC: "+num2str(round( particleInfoTable[frameId][%xC1] ))+", "+num2str(round( particleInfoTable[frameId][%yC1] ))
		TextBox/w = gr3_visTrMol_ta_mt /C /N = text0 /k
		TextBox/w = gr3_visTrMol_ta_mt /C /N = text0 /A = RT /X = 0.00 /Y = 0.00 "Molecule #: "+num2str( frameId + 1 )+", from: . "+num2str( numTraj )+"\rChannel 2"
		AppendText /W = gr3_visTrMol_ta_mt /N = text0 "\K(45000,0,0)xC, yC: "+num2str(round( particleInfoTable[frameId][%xC2] ))+", "+num2str(round( particleInfoTable[frameId][%yC2] ))
	elseif( numChToggle == 2 )
		TextBox/w = gr2_visTrMol_ta_mt /C /N = text0 /k
		TextBox/w = gr2_visTrMol_ta_mt /C /N = text0 /A = RT /X = 0.00 /Y = 0.00 "Molecule #: "+num2str( frameId + 1 )+", from: . "+num2str( numTraj )+"\rChannel 2"
		AppendText /W = gr2_visTrMol_ta_mt /N = text0 "\K(45000,0,0)xC, yC: "+num2str(round( particleInfoTable[frameId][%xC2] ))+", "+num2str(round( particleInfoTable[frameId][%yC2] ))
		TextBox/w = gr3_visTrMol_ta_mt /C /N = text0 /k
		TextBox/w = gr3_visTrMol_ta_mt /C /N = text0 /A = RT /X = 0.00 /Y = 0.00 "Molecule #: "+num2str( frameId + 1 )+", from: . "+num2str( numTraj )+"\rChannel 2"
		AppendText /W = gr3_visTrMol_ta_mt /N = text0 "\K(45000,0,0)xC, yC: "+num2str(round( particleInfoTable[frameId][%xC2] ))+", "+num2str(round( particleInfoTable[frameId][%yC2] ))	
	elseif( numChToggle == 1 )
		TextBox/w = gr2_visTrMol_ta_mt /C /N = text0 /k
		TextBox/w = gr2_visTrMol_ta_mt /C /N = text0 /A = RT /X = 0.00 /Y = 0.00 "Molecule #: "+num2str( frameId + 1 )+", from: . "+num2str( numTraj )+"\rChannel 1"
		AppendText /W = gr2_visTrMol_ta_mt /N = text0 "\K(45000,0,0)xC, yC: "+num2str(round( particleInfoTable[frameId][%xC1] ))+", "+num2str(round( particleInfoTable[frameId][%yC1] ))
		TextBox/w = gr3_visTrMol_ta_mt /C /N = text0 /k
		TextBox/w = gr3_visTrMol_ta_mt /C /N = text0 /A = RT /X = 0.00 /Y = 0.00 "Molecule #: "+num2str( frameId + 1 )+", from: . "+num2str( numTraj )+"\rChannel 2"
		AppendText /W = gr3_visTrMol_ta_mt /N = text0 "\K(45000,0,0)xC, yC: "+num2str(round( particleInfoTable[frameId][%xC1] ))+", "+num2str(round( particleInfoTable[frameId][%yC1] ))	
	endif
	// In or out of the main ROI?
	if( particleInfoTable[frameId][%xC1] > x0ROI && particleInfoTable[frameId][%xC1] < x1ROI && particleInfoTable[frameId][%yC1] > y0ROI && particleInfoTable[frameId][%yC1] < y1ROI  )
		TextBox/W=gr1_visTrMol_ta_mt/C/N=textH/A=RT/E=2/X=0 "\\f01\\K(0,65535,0)Inside the main ROI"
	else
		TextBox/W=gr1_visTrMol_ta_mt/C/N=textH/A=RT/E=2/X=0 "\\f01\\K(65535,0,0)Outside the main ROI"
	endif
	//
	Legend/W = gr1_visTrMol_ta_mt /K /N = text0/E/a=rc/x=0/y=-5
	Legend/w = gr1_visTrMol_ta_mt /C /N = text0 /J/E/a=rc/x=0/y=-5 "Molecule: "+num2str(frameId + 1)+", from:"+num2str( numTraj )
	//
	AppendText /W = gr1_visTrMol_ta_mt /N = text0 "\K(45000,0,0) Type of signal: "+num2str( acceptRejIdicatorW[ frameId ] )+" \K(0,0,0)"
	AppendText /W = gr1_visTrMol_ta_mt /N = text0 "\K(45000,0,0) Sel. frag.: "+num2str( selFragTrTable[frameId][0] ) +", "+ num2str( selFragTrTable[frameId][1] )+"."
	//
	Label/w=gr1_visTrMol_ta_mt left "Intensity, a.u.";	Label/w=gr1_visTrMol_ta_mt bottom "time, frames"
	if( numChToggle == 3 )
		if( traceSubTypeW[ 0 ] == 1 ) 
			Legend/w=gr1_visTrMol_ta_mt/C/N=text1/J/E/a=rc/x=0/y=30 "\f01\\s(smTraj1) 532nm 1st ch.\r\\s(smTraj2) 532nm 2nd ch.\r\\s(smAlexTraj1) 635nm 1st ch.\r\\s(smAlexTraj2) 635nm 2nd ch."
			AppendText /W = gr1_visTrMol_ta_mt /N = text0 "\r\\s(smTraj) Efret\r\\s(smAlexStochTraj) Stochiometry"	
		elseif( traceSubTypeW[ 1 ] == 1 ) 
			Legend/w=gr1_visTrMol_ta_mt/C/N=text1/J/E/a=rc/x=0/y=30 "\f01\\s(smFiltTraj1) filtered"
			AppendText /W = gr1_visTrMol_ta_mt /N = text0 "\r\\s(smFiltTraj) Efret"
		elseif( traceSubTypeW[ 2 ] == 1 ) 
			Legend/w=gr1_visTrMol_ta_mt/C/N=text1/J/E/a=rc/x=0/y=30 "\f01\\s(smNormTraj1) normalised"
			AppendText /W = gr1_visTrMol_ta_mt /N = text0 "\r\\s(smNormTraj) Efret"
		endif
		Label/w=gr1_visTrMol_ta_mt left "Efret"; 		Label/w=gr1_visTrMol_ta_mt left1 "Intensity, a.u."
	endif
	//
	AppendText /W = gr1_visTrMol_ta_mt /N = text0 "\rMovie: "+movieName1
	//
	hist_VisTrMol_TA_MT("ctrlName")
	//
end



////
//function histInt_VisTraj_TA_MT()
//	//
//	NVAR numChToggle, typeForHistToggle
//	NVAR hist1Start, hist1End, nBinsVar, maxIntVar, minIntVar
//	NVAR traceLoaded
//	//
//	wave traceSubTypeW, chOnOffW
//	//
//	if( traceLoaded != 1 )
//		print "first loade the data"
//		abort
//	endif
//	//
//	variable lenght 
//	if( typeForHistToggle == 1 )
//		wave trajRawTable
//		make/o /n = ( dimsize( trajRawTable, 1 ) ) avgIntTraces, avgIntTraces2
//		lenght = dimsize( trajRawTable, 1 )
//	elseif( typeForHistToggle == 2 )
//		wave trajFiltTable
//		make/o /n = ( dimsize( trajFiltTable, 1 ) ) avgIntTraces, avgIntTraces2
//		lenght = dimsize( trajFiltTable, 1 )
//	elseif( typeForHistToggle == 3 )
//		wave trajNormTable
//		make/o /n = ( dimsize( trajNormTable, 1 ) ) avgIntTraces, avgIntTraces2
//		lenght = dimsize( trajNormTable, 1 )
//	endif
//	//
//	variable aa
//	//
//	for( aa = 0 ; aa < lenght ; aa += 1 )
//		//
//		if( numChToggle == 1 || numChToggle == 3 )
//			//
//			if( typeForHistToggle == 1 ) // raw
//				if( numChToggle == 3 )
//					wave trajRawTable1
//					imagestats /q /m = 1 /g = { 0, 10, aa, aa } trajRawTable1
//				else
//					wave trajRawTable
//					imagestats /q /m = 1 /g = {  0, 10, aa, aa } trajRawTable
//				endif
//			elseif( typeForHistToggle == 2 )	// filtered
//				if( numChToggle == 3 )
//					wave trajFiltTable1
//					imagestats /q /m = 1 /g = {  0, 10, aa, aa } trajFiltTable1
//				else
//					wave trajFiltTable
//					imagestats /q /m = 1 /g = {  0, 10, aa, aa } trajFiltTable
//				endif
//			elseif( typeForHistToggle == 3 )	// normalised
//				if( numChToggle == 3 )
//					wave trajNormTable1
//					imagestats /q /m = 1 /g = {  0, 10, aa, aa } trajNormTable1
//				else
//					wave trajNormTable
//					imagestats /q /m = 1 /g = { 0, 10, aa, aa } trajNormTable
//				endif
//			endif
//			//
//			avgIntTraces[ aa ] = V_avg
//			//
//		endif
//		//
//		if( numChToggle == 2 || numChToggle == 3 )
//			//
//			if( typeForHistToggle == 1 ) // raw
//				if( numChToggle == 3 )
//					wave trajRawTable2
//					imagestats /q /m = 1 /g = { 0, 10, aa, aa } trajRawTable2
//					avgIntTraces2[ aa ] = V_avg
//				else
//					wave trajRawTable
//					imagestats /q /m = 1 /g = { 0, 10, aa, aa } trajRawTable
//					avgIntTraces[ aa ] = V_avg
//				endif
//			elseif( typeForHistToggle == 2 ) // filtered
//				if( numChToggle == 3 )
//					wave trajFiltTable2
//					imagestats /q /m = 1 /g = { 0, 10, aa, aa } trajFiltTable2
//					avgIntTraces2[ aa ] = V_avg
//				else
//					wave trajFiltTable
//					imagestats /q /m = 1 /g = { 0, 10, aa, aa } trajFiltTable
//					avgIntTraces[ aa ] = V_avg
//				endif
//			elseif( typeForHistToggle == 3 ) // Normalised
//				if( numChToggle == 3 )
//					wave trajNormTable2
//					imagestats /q /m = 1 /g = { 0, 10, aa, aa } trajNormTable2
//					avgIntTraces2[ aa ] = V_avg
//				else
//					wave trajNormTable
//					imagestats /q /m = 1 /g = { 0, 10, aa, aa } trajNormTable
//					avgIntTraces[ aa ] = V_avg
//				endif			
//			endif
//			//
//		endif
//		//
//	endfor
//	//
//	if( numChToggle == 3 )
//		//
//		make/o /n = ( nBinsVar ) histAvgInt, histAvgInt2
//		histogram/p /c /b = { minIntVar, maxIntVar / nBinsVar, nBinsVar } avgIntTraces, histAvgInt
//		histogram/p /c /b = { minIntVar, maxIntVar / nBinsVar, nBinsVar } avgIntTraces2, histAvgInt2
//		//
//		histAvgInt *= hist1End*10
//		histAvgInt2 *= hist1End*10
//		//
//		setaxis/a /w = gr1_visTrMol_ta_mt left1 minIntVar, maxIntVar
//		if( chOnOffW[ 0 ] == 1 )
//			ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(histAvgInt)=0
//		else
//			ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(histAvgInt)=1
//		endif
//		if( chOnOffW[ 1 ] == 1 )
//			ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(histAvgInt2)=0
//		else
//			ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(histAvgInt2)=1
//		endif
//		//
//	else
//		//
//		make/o /n = ( nBinsVar ) histAvgInt
//		histogram/p /c /b = { minIntVar, maxIntVar / nBinsVar, nBinsVar } avgIntTraces, histAvgInt	
//		histAvgInt *= hist1End*10
//		//
//		setaxis/a /w = gr1_visTrMol_ta_mt left minIntVar, maxIntVar
//		//
//		ModifyGraph/w=gr1_visTrMol_ta_mt hideTrace(histAvgInt)=0
//		//
//	endif
//	//
//end


//// ************************************************************************************************************************************************************************************************************************************
//// make movies functions
//function trajectoriesMovieDuble( inputTRace, inputTRace2, inputTRace3, fileName , partInfo, nWaves, showCoords, FRETtoggle, channelToggle )
//	wave inputTRace, inputTRace2, inputTRace3, partInfo
//	string fileName
//	variable nWaves, showCoords, FRETtoggle, channelToggle
//	//
//	variable loopVar1 = 0, loopVar2 = 1, loopVar3 = 2
//	//
//	make/o/n = ( dimSIze( inputTRace, 0 )) crop1, crop2, crop3
//	// show the graph
//	dowindow/k graph1
//	display/n=graph1 /hide = 0 crop1
//	appendtograph/w = graph1 /l=left1 crop2
//	appendtograph/w = graph1 /l=left2 crop3	
//	//
//	if( nWaves >= 2 )
//		make/o/n = ( dimSIze( inputTRace2, 0 )) crop11, crop21, crop31
//		appendtograph/w = graph1 /l=left crop11
//		appendtograph/w = graph1 /l=left1 crop21
//		appendtograph/w = graph1 /l=left2 crop31
//		modifygraph /w = graph1 rgb(crop11)=(1,4,52428), rgb(crop21)=(1,4,52428), rgb(crop31)=(1,4,52428);
//		modifygraph /w = graph1 lsize(crop11)=1.5,lsize(crop21)=1.5,lsize(crop31)=1.5
//	endif
//	if( nWaves == 3 )
//		make/o/n = ( dimSIze( inputTRace2, 0 )) crop12, crop22, crop32
//		appendtograph/w = graph1 /l=left crop12
//		appendtograph/w = graph1 /l=left1 crop22
//		appendtograph/w = graph1 /l=left2 crop32
//		modifygraph /w = graph1 rgb(crop12)=(34952,34952,34952), rgb(crop22)=(34952,34952,34952), rgb(crop32)=(34952,34952,34952);
//		modifygraph /w = graph1 mode( crop12 ) = 3,marker( crop12 ) = 8,mrkThick( crop12 ) = 1.5
//		modifygraph /w = graph1 mode( crop22 ) = 3,marker( crop22 ) = 8,mrkThick( crop22 ) = 1.5
//		modifygraph /w = graph1 mode( crop32 ) = 3,marker( crop32 ) = 8,mrkThick( crop32 ) = 1.5
//	endif
//	// adjust axes
//	wavestats/q inputTRace
//	SetAxis/w = graph1 left V_min, V_max
//	SetAxis/w = graph1 left1 V_min, V_max
//	SetAxis/w = graph1 left2 V_min, V_max
//	// modify properties of graph
//	Modifygraph /w = graph1 grid(left)=1,grid(left1)=1,grid(left2)=1
//	Modifygraph /w = graph1 axisEnab(left)={0,0.31},axisEnab(left1)={0.33,0.65},axisEnab(left2)={0.66,0.98};
//	Modifygraph /w = graph1 freePos(left1)={0,bottom},freePos(left2)={0,bottom}
//	Modifygraph /w = graph1 gridRGB(left)=(0,0,0),gridRGB(left1)=(0,0,0),gridRGB(left2)=(0,0,0)
//	modifygraph /w = graph1 width=900,height=550, fSize=12, margin(bottom)=150, margin(top)=0
//	modifygraph /w = graph1 zero(left)=1,zeroThick(left)=4, zero(left1)=1,zeroThick(left1)=4, zero(left2)=1,zeroThick(left2)=4
//	//
//	Label/w= graph1 left "intensity (a.u.)"; Label/w= graph1 bottom "time (s)"
//	// erase file if it exists
//	DeleteFile /P = Path4 /Z  fileName
//	//
//	doupdate
//	dowindow/f graph1
//	newMovie/P = Path4 /F = 60 /O  as fileName
//	//
//	do
//		//
//		loopVar1 = min( loopVar1, dimsize(inputTRace,1)-1)
//		loopVar2 = min( loopVar2, dimsize(inputTRace,1)-1)
//		loopVar3 = min( loopVar3, dimsize(inputTRace,1)-1)
//		//
//		crop1[ ] = inputTRace[ p ][ loopVar1 ];	crop2[ ] = inputTRace[ p ][ loopVar2 ];	crop3[ ] = inputTRace[ p ][ loopVar3 ]	
//		//
//		if( nWaves >= 2 )
//			crop11[ ] = inputTRace2[ p ][ loopVar1 ];	crop21[ ] = inputTRace2[ p ][ loopVar2 ];	crop31[ ] = inputTRace2[ p ][ loopVar3 ]
//		endif
//		if( nWaves == 3 )
//			crop12[ ] = inputTRace3[ p ][ loopVar1 ];	crop22[ ] = inputTRace3[ p ][ loopVar2 ];	crop32[ ] = inputTRace3[ p ][ loopVar3 ]
//		endif
//		// adjust axis
//		if( FRETtoggle != 1 )
//			wavestats/q crop1
//			SetAxis/w = graph1 left V_min,V_max
//			//
//			wavestats/q crop2
//			SetAxis/w = graph1 left1 V_min,V_max
//			//
//			wavestats/q crop3
//			SetAxis/w = graph1 left2 V_min,V_max
//		else
//			SetAxis/w = graph1 left -0.1,1.1
//			SetAxis/w = graph1 left1 -0.1,1.1
//			SetAxis/w = graph1 left2 -0.1,1.1
//		
//		endif
//		//
//		if( showCoords == 1 )
//			textBox/w= graph1/n =text1/k
//			textBox/w = graph1/n = text1/a = MB /f = 0 /E=2 "# : "+num2str( loopVar3 )+" xC: "+num2str( partInfo[ loopVar3 ][ %xC2 ] )+" yC: "+num2str( partInfo[ loopVar3 ][ %yC2 ] )
//			AppendText /W = graph1 /N = text1 "# : "+num2str( loopVar2 )+" xC: "+num2str( partInfo[ loopVar2 ][ %xC2 ] )+" yC: "+num2str( partInfo[ loopVar2 ][ %yC2 ] ) 
//			AppendText /W = graph1 /N = text1 "# : "+num2str( loopVar1 )+" xC: "+num2str( partInfo[ loopVar1 ][ %xC2 ] )+" yC: "+num2str( partInfo[ loopVar1 ][ %yC2 ] ) 
//		else
//			textBox/w= graph1/n =text1/k
//			textBox/w = graph1/n = text1/a = MB /f = 0 /E=2 "# : "+num2str( loopVar3 )
//			AppendText /W = graph1 /N = text1 "# : "+num2str( loopVar2 )
//			AppendText /W = graph1 /N = text1 "# : "+num2str( loopVar1 )
//		endif
//		// 
//		doUpdate
//		//
//		addMovieFrame
//		//
//		loopVar1 += 3; loopVar2 += 3; loopVar3 += 3
//		if( loopVar1 >= dimSIze( inputTRace, 1 ) )
//			break
//		endIf
//		//
//	while( 1 )
//	//
//	closeMovie
//	doWindow/k graph1
//	//
//end
////
//function trajectoriesMovieFRET( inputTRace1, inputTRace2, inputTRace3, inputTRace1_1, inputTRace2_1, inputTRace3_1, fileName , partInfo, showCoords, antiCorrToggle, stringIn1, stringIn2 )
//	wave inputTRace1, inputTRace2, inputTRace3
//	wave inputTRace1_1, inputTRace2_1, inputTRace3_1
//	wave partInfo
//	string fileName
//	variable showCoords		// 1 - on, else off.
//	variable antiCorrToggle		// 1 -on, else off.
//	string stringIn1, stringIn2
//	//
//	variable loopVar1 = 0
//	//
//	if( antiCorrToggle == 1 )
//		wave trAntiCorrContAcc
//		make/o/n = ( dimSIze( trAntiCorrContAcc, 0 )) cropAntiCorr
//	endif
//	//
//	make/o/n = ( dimSIze( inputTrace1, 0 )) crop1, crop2, crop3
//	make/o/n = ( dimSIze( inputTrace1, 0 )) crop1_1, crop2_1, crop3_1
//	// show the graph
//	dowindow/k graph1
//	display/n=graph1 /hide = 0 crop1, crop1_1
//	appendtograph/w = graph1 /l=left1 crop2, crop3, crop2_1, crop3_1
//	// modify properties of graph
//	Modifygraph /w = graph1 grid(left)=1,grid(left1)=1, rgb(crop2)=(0,40000,0 ), rgb(crop3)=(40000,0,0 ), rgb(crop2_1)=(0,20000,0 ), rgb(crop3_1)=(20000,0,0 ) , rgb(crop1_1)=(30000,0,0 )
//	Modifygraph/w = graph1  lsize(crop2_1) = 1.5, lsize(crop3_1) = 1.5 , lsize(crop1_1) = 1.5
//	Modifygraph /w = graph1 zero(left)=1,zeroThick(left)=4, zero(left1)=1,zeroThick(left1)=4, lblPosMode(left1)=1
//	Modifygraph /w = graph1 axisEnab(left)={0,0.45},axisEnab(left1)={0.50,0.95}, freePos(left1)={0,bottom}
//	Modifygraph /w = graph1 gridRGB(left)=(0,0,0),gridRGB(left1)=(0,0,0)
//	Modifygraph /w = graph1 width=900,height=550, fSize=12, margin(bottom)=150, margin(top)=0
//	if( antiCorrToggle == 1 )
//		appendtograph/w = graph1 	cropAntiCorr
//		Modifygraph /w = graph1 rgb(cropAntiCorr)=(0,15000,50000),mode(cropAntiCorr)=3,marker(cropAntiCorr)=8
//	endif
//	//
//	Label/w= graph1 left "Efret"; Label/w= graph1 bottom "time (s)"; Label/w= graph1 left1 "intensity (a.u.)";
//	// erase file if it exists
//	DeleteFile /P = Path4 /Z  fileName
//	//
//	doupdate
//	dowindow/f graph1
//	newMovie/P = Path4 /F = 60 /O  as fileName
//	//
//	do
//		//
//		loopVar1 = min( loopVar1, dimsize(inputTrace1,1)-1)
//		//
//		crop1[ ] = inputTRace1[ p ][ loopVar1 ];	crop2[ ] = inputTRace2[ p ][ loopVar1 ];	crop3[ ] = inputTRace3[ p ][ loopVar1 ]
//		crop1_1[ ] = inputTRace1_1[ p ][ loopVar1 ];	crop2_1[ ] = inputTRace2_1[ p ][ loopVar1 ];	crop3_1[ ] = inputTRace3_1[ p ][ loopVar1 ]
//		if( antiCorrToggle == 1 )
//			cropAntiCorr[ ] = trAntiCorrContAcc[ p ][ loopVar1 ]
//		endif
//		// adjust axis
//		SetAxis/A /w = graph1 left -0.1, 1.1;		SetAxis/A /w = graph1 left1
//		//
//		if( showCoords == 1 )
//			textBox/w= graph1/n =text1/k
//			textBox/w = graph1/n = text1/a = MB /f = 0 /E=2 "Acceptor: # : "+num2str( loopVar1 )+" xC: "+num2str( partInfo[ loopVar1 ][ %xC2 ] )+" yC: "+num2str( partInfo[ loopVar1 ][ %yC2 ] )
//			AppendText/w = graph1/n = text1 "Donor: # : "+num2str( loopVar1 )+" xC: "+num2str( partInfo[ loopVar1 ][ %xC1 ] )+" yC: "+num2str( partInfo[ loopVar1 ][ %yC1 ] )
//			AppendText/w = graph1/n = text1 "\\s(crop1) "+stringIn1+"\r\\s(crop1_1) "+stringIn2
//		else
//			textBox/w= graph1/n =text1/k
//			textBox/w = graph1/n = text1/a = MB /f = 0 /E=2 "# : "+num2str( loopVar1 )
//			AppendText/w = graph1/n = text1 "\\s(crop1) "+stringIn1+"\r\\s(crop1_1) "+stringIn2
//		endif
//		// 
//		doUpdate
//		//
//		addMovieFrame
//		//
//		loopVar1 += 1
//		if( loopVar1 >= dimSIze( inputTrace1, 1 ) )
//			break
//		endIf
//		//
//	while( 1 )
//	//
//	closeMovie
//	doWindow/k graph1
//	//
//end